/*
SilverhornChars Configuration
	by Lach, Tatsuru, SMS Alfredo, Krabs, Frostiikin, & Inazuma

beta
*/

rawset(_G, "Silverhorn", {})

Silverhorn.Inazuma = {}
Silverhorn.Aether = {}

if srb2p and not P_MoveOrigin
	rawset(_G, "P_MoveOrigin", P_TeleportMove)
	rawset(_G, "P_SetOrigin", P_TeleportMove)
end

// To prevent duplicate freeslots
local function SafeFreeslot(...)
	for _, item in ipairs({...})
		if rawget(_G, item) == nil
			freeslot(item)
		end
	end
end

function A_SetPAnim(mo, var1, var2)
	if not (mo and mo.valid and mo.player) then return end
	mo.player.panim = var2
end

//Sounds

SafeFreeslot("sfx_boltst", "sfx_ebar", "sfx_xsgtk", "sfx_boltbl", "sfx_zcrash", "sfx_donk",
	"sfx_inzarg", "sfx_inzloa", "sfx_inzeto", "sfx_pswap", "sfx_pfail", "sfx_ljmp", "sfx_inaju1", "sfx_inaju2",
	"sfx_inapr1", "sfx_inapr2", "sfx_inapr3", "sfx_inapr4",
	"sfx_inzlz1", "sfx_inzlz2", "sfx_inzbl",
	"sfx_inlaz1", "sfx_inlaz2", "sfx_inlaz3", "sfx_inlaz4", "sfx_inlaz5", "sfx_boltsk", "sfx_elcbmp", "sfx_rflsh")

sfxinfo[sfx_boltst].caption = "Bolt"
sfxinfo[sfx_ebar].caption = "Warbling"
sfxinfo[sfx_xsgtk].caption = "Zap"
sfxinfo[sfx_boltbl].caption = "Discharge"
sfxinfo[sfx_zcrash].caption = "Thunderclap"
sfxinfo[sfx_ljmp].caption = "Lightning Jump"
sfxinfo[sfx_boltsk].caption = "METEOR SMASH"
sfxinfo[sfx_rflsh].caption = "Flashbanged"
sfxinfo[sfx_elcbmp].caption = "Spark"
sfxinfo[sfx_donk].caption = "Donk"
sfxinfo[sfx_inzarg].caption = "Arrrggg!!!"
sfxinfo[sfx_inzloa].caption = "Metamorphosis"
sfxinfo[sfx_inzeto].caption = "Rupture"
sfxinfo[sfx_pswap].caption = "Switch!"
sfxinfo[sfx_pfail].caption = "Can't Switch!"
sfxinfo[sfx_inaju1].caption = "Jump"
sfxinfo[sfx_inaju2].caption = "Jump"
sfxinfo[sfx_inapr1].caption = "You never stood a chance."
sfxinfo[sfx_inapr2].caption = "Couldn't do it without Aether."
sfxinfo[sfx_inapr3].caption = "Glad Aether's by my side."
sfxinfo[sfx_inapr4].caption = "We make a great team, Dirk."

sfxinfo[sfx_inzlz1].caption = "Charging"
sfxinfo[sfx_inzlz1].flags = $|SF_X8AWAYSOUND
sfxinfo[sfx_inzlz2].caption = "Ultra Lightning Blast"
sfxinfo[sfx_inzlz2].flags = $|SF_X8AWAYSOUND
sfxinfo[sfx_inzbl].caption = "Lightning Blast"
sfxinfo[sfx_inzbl].flags = $|SF_X8AWAYSOUND
sfxinfo[sfx_inlaz1].caption = "/"
sfxinfo[sfx_inlaz1].flags = $|SF_X8AWAYSOUND
sfxinfo[sfx_inlaz2].caption = "/"
sfxinfo[sfx_inlaz2].flags = $|SF_X8AWAYSOUND
sfxinfo[sfx_inlaz3].caption = "/"
sfxinfo[sfx_inlaz3].flags = $|SF_X8AWAYSOUND
sfxinfo[sfx_inlaz4].caption = "/"
sfxinfo[sfx_inlaz4].flags = $|SF_X8AWAYSOUND
sfxinfo[sfx_inlaz5].caption = "/"
sfxinfo[sfx_inlaz5].flags = $|SF_X8AWAYSOUND

-- Extra Sounds

SafeFreeslot(
	"sfx_pmdtx",  -- text sound
	"sfx_msrg10", -- ???
	"sfx_dbboms" -- Slow motion boom
)
sfxinfo[sfx_pmdtx].flags = SF_NOMULTIPLESOUND

-- Extra Sprites
SafeFreeslot(
	-- Credits
	"SPR_CCCT",
	"SPR_CCC1",
	"SPR_CCC2"
)

//Skincolors

-- Safely update the old emerald color to its new name
Silverhorn.EmeraldColor = SKINCOLOR_EMERALD
pcall(function()
	Silverhorn.EmeraldColor = SKINCOLOR_SHAMROCK
end)

SafeFreeslot("SKINCOLOR_FULLPOWERSUPER1",
"SKINCOLOR_FULLPOWERSUPER2",
"SKINCOLOR_FULLPOWERSUPER3",
"SKINCOLOR_FULLPOWERSUPER4",
"SKINCOLOR_FULLPOWERSUPER5",
"SKINCOLOR_ROSEGOLD1",
"SKINCOLOR_ROSEGOLD2",
"SKINCOLOR_ROSEGOLD3",
"SKINCOLOR_ROSEGOLD4",
"SKINCOLOR_ROSEGOLD5",
"SKINCOLOR_ULTIMATE1",
"SKINCOLOR_ULTIMATE2",
"SKINCOLOR_ULTIMATE3",
"SKINCOLOR_ULTIMATE4",
"SKINCOLOR_ULTIMATE5",
"SKINCOLOR_SUPER_ARCANE1",
"SKINCOLOR_SUPER_ARCANE2",
"SKINCOLOR_SUPER_ARCANE3",
"SKINCOLOR_SUPER_ARCANE4",
"SKINCOLOR_SUPER_ARCANE5",
"SKINCOLOR_SUPER_IMPULSE1",
"SKINCOLOR_SUPER_IMPULSE2",
"SKINCOLOR_SUPER_IMPULSE3",
"SKINCOLOR_SUPER_IMPULSE4",
"SKINCOLOR_SUPER_IMPULSE5",
"SKINCOLOR_INAFX",
"SKINCOLOR_BOLTSTREAM",
"SKINCOLOR_SUPER_SHADOWMIST1",
"SKINCOLOR_SUPER_SHADOWMIST2",
"SKINCOLOR_SUPER_SHADOWMIST3",
"SKINCOLOR_SUPER_SHADOWMIST4",
"SKINCOLOR_SUPER_SHADOWMIST5",
"SKINCOLOR_SUPER_BLOODMOON1",
"SKINCOLOR_SUPER_BLOODMOON2",
"SKINCOLOR_SUPER_BLOODMOON3",
"SKINCOLOR_SUPER_BLOODMOON4",
"SKINCOLOR_SUPER_BLOODMOON5")


skincolors[SKINCOLOR_SUPER_IMPULSE1] = {
    name = "Super Impulse 1",
    ramp = {0,1,144,144,145,145,146,147,148,148,162,163,164,165,166,158},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_IMPULSE2] = {
    name = "Super Impulse 2",
    ramp = {0,1,128,128,128,146,147,148,162,163,163,164,165,167,156,158},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_IMPULSE3] = {
    name = "Super Impulse 3",
    ramp = {0,144,128,129,146,147,148,148,163,164,164,165,166,167,157,158},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_IMPULSE4] = {
    name = "Super Impulse 4",
    ramp = {0,128,129,146,148,148,162,163,164,165,166,166,167,158,253,254},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_IMPULSE5] = {
    name = "Super Impulse 5",
    ramp = {128,129,131,147,148,163,163,164,165,166,167,167,157,159,253,254},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}


skincolors[SKINCOLOR_SUPER_ARCANE1] = {
    name = "Super Arcane 1",
    ramp = {0,0,1,80,80,80,80,88,120,121,141,141,142,136,137,173},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_ARCANE2] = {
    name = "Super Arcane 2",
    ramp = {0,1,80,81,88,88,89,121,123,124,142,142,136,137,173,167},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_ARCANE3] = {
    name = "Super Arcane 3",
    ramp = {0,80,81,88,89,121,123,123,124,142,142,136,137,137,168,186},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_ARCANE4] = {
    name = "Super Arcane 4",
    ramp = {2,88,89,97,123,123,124,142,142,136,137,137,173,173,168,186},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_ARCANE5] = {
    name = "Super Arcane 5",
    ramp = {2,89,97,123,123,124,142,142,136,136,137,137,173,168,168,186},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}

skincolors[SKINCOLOR_FULLPOWERSUPER1] = {
	name = "Super FullPowerSuper 1",
	ramp = {0,1,80,81,82,83,83,64,74,188,189,98,100,114,115,115},
	accessible = false
}

skincolors[SKINCOLOR_FULLPOWERSUPER2] = {
	name = "Super FullPowerSuper 2",
	ramp = {0,80,81,82,83,72,64,188,189,99,101,115,116,116,127,127},
	accessible = false
}

skincolors[SKINCOLOR_FULLPOWERSUPER3] = {
	name = "Super FullPowerSuper 3",
	ramp = {0,80,82,83,64,188,99,100,101,114,115,115,126,143,139,254},
	accessible = false
}

skincolors[SKINCOLOR_FULLPOWERSUPER4] = {
	name = "Super FullPowerSuper 4",
	ramp = {0,81,83,74,189,99,100,101,114,115,115,126,126,138,139,254},
	accessible = false
}

skincolors[SKINCOLOR_FULLPOWERSUPER5] = {
	name = "Super FullPowerSuper 5",
	ramp = {0,81,64,189,99,100,114,114,115,116,126,126,143,138,139,254},
	accessible = false
}

skincolors[SKINCOLOR_ROSEGOLD1] = {
	name = "Super RoseGold 1",
	ramp = {0,0,1,1,208,208,208,48,48,48,49,50,220,221,222,228},
	accessible = false
}

skincolors[SKINCOLOR_ROSEGOLD2] = {
	name = "Super RoseGold 2",
	ramp = {0,1,1,208,208,48,48,49,50,219,220,221,221,224,228,69},
	accessible = false
}

skincolors[SKINCOLOR_ROSEGOLD3] = {
	name = "Super RoseGold 3",
	ramp = {0,1,208,208,208,48,48,50,50,220,220,212,214,215,215,63},
	accessible = false
}

skincolors[SKINCOLOR_ROSEGOLD4] = {
	name = "Super RoseGold 4",
	ramp = {0,208,208,216,218,219,219,211,211,212,213,214,215,62,63,71},
	accessible = false
}

skincolors[SKINCOLOR_ROSEGOLD5] = {
	name = "Super RoseGold 5",
	ramp = {0,208,48,50,219,219,211,211,212,213,214,215,215,62,63,71},
	accessible = false
}

skincolors[SKINCOLOR_ULTIMATE1] = {
	name = "Super Ultimate 1",
	ramp = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 129, 255, 133, 134, 135},
	accessible = false
}

skincolors[SKINCOLOR_ULTIMATE2] = {
	name = "Super Ultimate 2",
	ramp = {0, 0, 0, 0, 128, 128, 129, 129, 255, 255, 133, 133, 134, 134, 135, 135},
	accessible = false
}

skincolors[SKINCOLOR_ULTIMATE3] = {
	name = "Super Ultimate 3",
	ramp = {0, 0, 128, 128, 129, 129, 255, 255, 133, 133, 134, 134, 135, 135, 136, 136},
	accessible = false
}

skincolors[SKINCOLOR_ULTIMATE4] = {
	name = "Super Ultimate 4",
	ramp = {0, 128, 129, 255, 133, 134, 135, 136, 137, 167, 167, 168, 168, 169, 169, 253},
	accessible = false
}

skincolors[SKINCOLOR_ULTIMATE5] = {
	name = "Super Ultimate 5",
	ramp = {128, 129, 255, 133, 134, 135, 136, 137, 167, 167, 168, 168, 169, 169, 253, 254},
	accessible = false
}

skincolors[SKINCOLOR_INAFX] = {
	name = "Inazuma Effects",
	ramp = {128, 144, 129, 145, 5, 130, 146, 131, 132, 133, 134, 135, 149, 172, 173, 137},
	accessible = false
}

skincolors[SKINCOLOR_BOLTSTREAM] = {
	name = "Bolt Stream",
	ramp = {128, 128, 129, 130, 130, 131, 132, 133, 146, 147, 147, 148, 148, 149, 149, 149},
	accessible = false
}
skincolors[SKINCOLOR_SUPER_SHADOWMIST1] = {
    name = "Super ShadowMist 1",
    ramp = {0,0,0,0,0,0,0,128,128,120,121,121,122,122,123,123},
    accessible = false
}

skincolors[SKINCOLOR_SUPER_SHADOWMIST2] = {
    name = "Super ShadowMist 2",
    ramp = {0,0,0,0,128,120,120,121,121,122,123,123,124,124,125,125},
    accessible = false
}

skincolors[SKINCOLOR_SUPER_SHADOWMIST3] = {
    name = "Super ShadowMist 3",
    ramp = {0,0,0,128,120,121,121,122,122,123,124,124,125,125,126,126},
    accessible = false
}

skincolors[SKINCOLOR_SUPER_SHADOWMIST4] = {
    name = "Super ShadowMist 4",
    ramp = {0,0,128,120,121,122,122,123,123,124,125,125,126,126,143,143},
    accessible = false
}

skincolors[SKINCOLOR_SUPER_SHADOWMIST5] = {
    name = "Super ShadowMist 5",
    ramp = {128,120,121,122,123,124,124,125,125,126,143,143,138,138,139,139},
    accessible = false
}

skincolors[SKINCOLOR_SUPER_BLOODMOON1] = {
    name = "Super BloodMoon 1",
    ramp = {0,208,216,218,51,52,55,55,55,34,34,36,36,39,207,196},
    invcolor = SKINCOLOR_PURPLE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_BLOODMOON2] = {
    name = "Super BloodMoon 2",
    ramp = {0,48,218,51,53,55,55,34,34,36,36,36,38,215,197,175},
    invcolor = SKINCOLOR_PURPLE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_BLOODMOON3] = {
    name = "Super BloodMoon 3",
    ramp = {208,216,218,51,53,34,34,36,36,36,37,40,207,207,198,175},
    invcolor = SKINCOLOR_PURPLE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_BLOODMOON4] = {
    name = "Super BloodMoon 4",
    ramp = {48,218,51,53,34,34,36,36,37,39,215,207,207,198,198,175},
    invcolor = SKINCOLOR_PURPLE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_BLOODMOON5] = {
    name = "Super BloodMoon 5",
    ramp = {48,219,53,34,34,36,36,36,215,206,207,207,207,197,198,175},
    invcolor = SKINCOLOR_PURPLE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}

//Sol forms
if not solchars
    rawset(_G, "solchars", {})
end
solchars["inazuma"] = {SKINCOLOR_SUPER_IMPULSE1, 2}
solchars["aether"] = {SKINCOLOR_SUPER_ARCANE1, 2}




//States and sprites

SafeFreeslot("SPR_IZFX", "SPR_XSGT", "SPR_IZPT", "SPR_ELEX", "SPR_EBAR",
	"SPR_XSGB", "SPR_RADF", "SPR_ZLIT", "SPR_LBST", "SPR_UITR", "SPR_ZMXE",
	"SPR_XSGE", "SPR_XSGG", // split for modeler convenience
	"SPR_SLBO", "SPR_SLSO",
	"SPR2_OOF_", "SPR2_GRND", "SPR2_GARD")

SafeFreeslot("S_INAZUMA_BARRIER", "S_ULTZUMA_BARRIER",
	"S_INAZUMA_FX", "S_INAZUMA_PARTICLE", "S_INAZUMA_TRAIL", "S_INAZUMA_LIGHTNINGBALL", "S_INAZUMA_LIGHTNINGBALL2", "S_INAZUMA_LIGHTNINGBLAST", "S_INAZUMA_LIGHTNINGBLAST_FAST",
	"S_INAZUMA_AURA", "S_INAZUMA_LOCKON", "S_BOLTBLAST", "S_INAZUMA_LIGHTNINGSTRIKE", "S_INAZUMA_HOOP", "S_INAZUMA_TOSSEDGLOVE",
	"S_INAZUMA_DASH", "S_INAZUMA_BOLTSTREAM", "S_INAZUMA_BOLTSTREAM_OVERLAY", "S_INAZUMA_SUPERRUN", "S_INAZUMA_OOF", "S_INAZUMA_FIRE", "S_INAZUMA_SMACK",
	"S_ULTZUMA_TRANS1", "S_ULTZUMA_TRANS2", "S_ULTZUMA_ORB", "S_ULTZUMA_FLASH", "S_ULTZUMA_CHARGE", "S_ULTZUMA_EXPLODE",
	"S_ULTZUMA_LASERSTART", "S_ULTZUMA_LASER", "S_ULTZUMA_LASEREND",
	"S_FACCIOLO_MIASMA1", "S_MINDSCAPE_PORTAL",
	"S_MINDSCAPE_BLOB1", "S_MINDSCAPE_BLOB2", "S_MINDSCAPE_BLOB_CORONA",
	"S_MINDSCAPE_BLOBEX1", "S_MINDSCAPE_BLOBEX2",
	"S_MINDSCAPE_BLOBEX3", "S_MINDSCAPE_BLOBEX4", "S_MINDSCAPE_BLOBEX5", 
	"S_SILVERHORN_EGGROBO")

states[S_INAZUMA_BARRIER] = {
	sprite = SPR_EBAR,
	frame = FF_ANIMATE|FF_FULLBRIGHT|FF_RANDOMANIM,
	var1 = 8,
	var2 = 1
}

states[S_ULTZUMA_BARRIER] = {
	sprite = SPR_EBAR,
	frame = J|FF_ANIMATE|FF_FULLBRIGHT|FF_RANDOMANIM,
	var1 = 8,
	var2 = 1
}

states[S_INAZUMA_FX] = {
	sprite = SPR_XSGT,
	frame = FF_ANIMATE|FF_FULLBRIGHT,
	tics = 7,
	var1 = 6,
	var2 = 1
}

states[S_INAZUMA_PARTICLE] = {
	sprite = SPR_IZPT,
	frame = FF_ANIMATE|FF_FULLBRIGHT|FF_RANDOMANIM,
	tics = 8,
	var1 = 3,
	var2 = 2
}

states[S_INAZUMA_TRAIL] = {
	sprite = SPR_IZFX,
	frame = B,
	tics = 10
}

states[S_INAZUMA_LIGHTNINGBALL] = {
	sprite = SPR_LBST,
	frame = FF_ANIMATE|FF_FULLBRIGHT,
	nextstate = S_INAZUMA_LIGHTNINGBALL2,
	tics = 4,
	var1 = 1,
	var2 = 2,
}

states[S_INAZUMA_LIGHTNINGBALL2] = {
	sprite = SPR_LBST,
	frame = FF_ANIMATE|FF_FULLBRIGHT|C,
	tics = -1,
	var1 = 2,
	var2 = 2,
}


states[S_INAZUMA_LIGHTNINGBLAST] = {
	sprite = SPR_RADF,
	frame = FF_ANIMATE|FF_FULLBRIGHT,
	action = A_Scream,
	tics = 12,
	var1 = 5,
	var2 = 2,
}

states[S_INAZUMA_LIGHTNINGBLAST_FAST] = {
	sprite = SPR_RADF,
	frame = C|FF_ANIMATE|FF_FULLBRIGHT,
	action = A_Scream,
	tics = 4,
	var1 = 3,
	var2 = 1,
}

states[S_INAZUMA_AURA] = {
	sprite = SPR_ELEX,
	frame = FF_FULLBRIGHT|FF_RANDOMANIM|FF_ANIMATE,
	tics = 1,
	var1 = 5,
	var2 = 1,
	nextstate = S_INAZUMA_AURA
}

states[S_INAZUMA_LOCKON] = {
	sprite = SPR_LCKN,
	frame = FF_FULLBRIGHT,
	tics = 2,
}

states[S_BOLTBLAST] = {
	sprite = SPR_RADF,
	frame = FF_ANIMATE|FF_FULLBRIGHT|FF_TRANS50,
	tics = 6,
	var1 = 5,
	var2 = 1,
}

states[S_INAZUMA_LIGHTNINGSTRIKE] = {
	sprite = SPR_ZLIT,
	frame = FF_FULLBRIGHT | FF_ANIMATE,
	tics = 7,
	var1 = 6,
	var2 = 1,
}

states[S_INAZUMA_HOOP] = {
	sprite = SPR_STAB,
	frame = FF_FULLBRIGHT | FF_PAPERSPRITE | FF_TRANS50,
	tics = 5,
}

states[S_INAZUMA_TOSSEDGLOVE] = {
	sprite = SPR_XSGG,
	frame = F,
	tics = 1,
	nextstate = S_INAZUMA_TOSSEDGLOVE,
	action = function(mo)
		if mo.fuse < 10
			mo.frame = $ | ((10 - mo.fuse) << FF_TRANSSHIFT)
		end
		mo.rollangle = $ + ANG15
	end
}

states[S_INAZUMA_DASH] = {
	sprite = SPR_PLAY,
	frame = SPR2_DASH,
	tics = 2,
	action = A_SetPAnim,
	var2 = PA_FALL,
	nextstate = S_INAZUMA_DASH
}

states[S_INAZUMA_BOLTSTREAM] = {
	sprite = SPR_PLAY,
	frame = SPR2_TAL3 | FF_FULLBRIGHT,
	action = A_SetPAnim,
	var2 = PA_ROLL
}

states[S_INAZUMA_BOLTSTREAM_OVERLAY] = {
	sprite = SPR_PLAY,
	frame = SPR2_TWIN | FF_FULLBRIGHT,
	tics = 1,
	nextstate = S_INAZUMA_BOLTSTREAM_OVERLAY,
	var1 = 1
}

states[S_INAZUMA_SUPERRUN] = {
	sprite = SPR_PLAY,
	frame = SPR2_DASH,
	tics = 1,
	action = A_SetPAnim,
	var2 = PA_RUN,
	nextstate = S_INAZUMA_SUPERRUN
}

states[S_INAZUMA_OOF] = {
	sprite = SPR_PLAY,
	frame = SPR2_OOF_,
	tics = 4,
	action = A_SetPAnim,
	var2 = PA_IDLE,
	nextstate = S_INAZUMA_OOF
}

states[S_INAZUMA_FIRE] = {
	sprite = SPR_PLAY,
	frame = SPR2_FIRE|FF_ANIMATE,
	tics = TICRATE/3,
	var2 = 2,
	nextstate = S_PLAY_FALL
}

states[S_INAZUMA_SMACK] = {
	sprite = SPR_PLAY,
	frame = SPR2_CLNG|FF_SPR2ENDSTATE,
	tics = 3,
	nextstate = S_INAZUMA_SMACK,
	var1 = S_PLAY_STND,
	var2 = PA_DASH
	// see Inazuma.SmackAction for action
}

states[S_ULTZUMA_TRANS1] = {
	sprite = SPR_NULL,
	tics = 2*TICRATE + TICRATE/2,
	nextstate = S_ULTZUMA_TRANS2
}

states[S_ULTZUMA_TRANS2] = {
	sprite = SPR_PLAY,
	frame = SPR2_TAL1|FF_SPR2SUPER|FF_FULLBRIGHT,
	tics = -1
}

states[S_ULTZUMA_ORB] = {
	sprite = SPR_UITR,
	frame = FF_FULLBRIGHT|FF_ANIMATE,
	tics = -1,
	var1 = 14,
	var2 = 1
}

states[S_ULTZUMA_FLASH] = {
	sprite = SPR_UITR,
	frame = P|FF_FULLBRIGHT,
	tics = 1,
	var1 = 7
}

states[S_ULTZUMA_CHARGE] = {
	sprite = SPR_UITR,
	frame = X|FF_FULLBRIGHT|FF_ANIMATE|FF_TRANS50,
	tics = -1,
	var1 = 6,
	var2 = 2
}

states[S_ULTZUMA_EXPLODE] = {
	sprite = SPR_UITR,
	frame = (Z+1 + 5)|FF_FULLBRIGHT|FF_ANIMATE,
	tics = 15,
	var1 = 4,
	var2 = 3
}

states[S_ULTZUMA_LASERSTART] = {
	sprite = SPR_RADF,
	frame = G|FF_ANIMATE|FF_FULLBRIGHT|FF_ADD,
	tics = 4,
	var1 = 1,
	var2 = 2,
	nextstate = S_ULTZUMA_LASER
}

states[S_ULTZUMA_LASER] = {
	sprite = SPR_RADF,
	frame = I|FF_ANIMATE|FF_FULLBRIGHT|FF_ADD,
	tics = -1,
	var1 = 3,
	var2 = 2,
	nextstate = S_ULTZUMA_LASEREND
}

states[S_ULTZUMA_LASEREND] = {
	sprite = SPR_RADF,
	frame = M|FF_ANIMATE|FF_FULLBRIGHT|FF_ADD,
	tics = 4,
	var1 = 1,
	var2 = 2,
}

states[S_FACCIOLO_MIASMA1] = {
	sprite = SPR_SHCK,
	frame = FF_PAPERSPRITE|FF_FULLBRIGHT|FF_RANDOMANIM|FF_ANIMATE,
	var1 = 7,
	var2 = 2,
	tics = 130,
	nextstate = S_XPLD2,
}

states[S_MINDSCAPE_PORTAL] = {
	sprite = SPR_ZMXE,
	frame = FF_FULLBRIGHT|FF_ANIMATE,
	var1 = 34,
	var2 = 1,
	tics = -1,
	nextstate = S_MINDSCAPE_PORTAL,
}

states[S_MINDSCAPE_BLOB1] = {
	sprite = SPR_SLBO,
	frame = FF_FULLBRIGHT|FF_TRANS30,
	tics = -1,
	nextstate = S_MINDSCAPE_BLOB1,
}

states[S_MINDSCAPE_BLOB2] = {
	sprite = SPR_SLBO,
	frame = FF_FULLBRIGHT|FF_TRANS30|FF_ANIMATE|B,
	action = A_Pain,
	var1 = 4,
	var2 = 2,
	tics = 10,
	nextstate = S_MINDSCAPE_BLOB1,
}

states[S_MINDSCAPE_BLOBEX1] = {
	sprite = SPR_SLBO,
	frame = FF_FULLBRIGHT|FF_TRANS30|G,
	tics = -1,
	nextstate = S_MINDSCAPE_BLOBEX1,
}

states[S_MINDSCAPE_BLOBEX2] = {
	sprite = SPR_SLBO,
	frame = FF_FULLBRIGHT|FF_TRANS30|FF_ANIMATE|H,
	action = A_Pain,
	var1 = 4,
	var2 = 2,
	tics = 10,
	nextstate = S_MINDSCAPE_BLOBEX1,
}

states[S_MINDSCAPE_BLOBEX3] = {
	sprite = SPR_SLBO,
	frame = FF_FULLBRIGHT|FF_TRANS30|FF_ANIMATE|M,
	action = A_PlaySeeSound,
	var1 = 3,
	var2 = 2,
	tics = 8,
	nextstate = S_MINDSCAPE_BLOBEX4,
}

states[S_MINDSCAPE_BLOBEX4] = {
	sprite = SPR_SLBO,
	frame = FF_FULLBRIGHT|FF_TRANS30|FF_ANIMATE|Q,
	tics = TICRATE,
	nextstate = S_MINDSCAPE_BLOBEX5,
}

states[S_MINDSCAPE_BLOBEX5] = {
	sprite = SPR_SLBO,
	frame = FF_FULLBRIGHT|FF_TRANS30|FF_ANIMATE|R,
	action = A_PlayAttackSound,
	var1 = 1,
	var2 = 2,
	tics = 4,
	nextstate = S_MINDSCAPE_BLOBEX1,
}

states[S_MINDSCAPE_BLOB_CORONA] = {
	sprite = SPR_FLAM,
	frame = FF_FULLBRIGHT|FF_TRANS90|12,
	var1 = 1,
	var2 = 28,
	tics = -1,
}

states[S_SILVERHORN_EGGROBO] = {
	sprite = SPR_XSGE,
	frame = FF_ANIMATE,
	tics = -1,
	var1 = 1,
	var2 = 2
}

//Objects

SafeFreeslot("MT_INAZUMA_FX", "MT_INAZUMA_PARTICLE", "MT_INAZUMA_TRAIL",
	"MT_INAZUMA_LIGHTNINGBALL", "MT_INAZUMA_LIGHTNINGBLAST",
	"MT_INAZUMA_LASER",
	"MT_INAZUMA_BARRIER", "MT_INAZUMA_SILVERHORN",
	"MT_MINDSCAPE_PORTAL",
	"MT_MINDSCAPE_BLOB1", "MT_MINDSCAPE_BLOB2",
	"MT_SILVERHORN_EGGROBO")

mobjinfo[MT_INAZUMA_FX] = {
	spawnstate = S_INAZUMA_FX,
	spawnhealth = 1000,
	speed = 20*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT
}

mobjinfo[MT_INAZUMA_PARTICLE] = {
	height = 16*FRACUNIT,
	radius = 8*FRACUNIT,
	spawnstate = S_INAZUMA_PARTICLE,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT
}

mobjinfo[MT_INAZUMA_TRAIL] = {
	height = 48*FRACUNIT,
	radius = 16*FRACUNIT,
	spawnstate = S_INAZUMA_TRAIL,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

mobjinfo[MT_INAZUMA_LIGHTNINGBALL] = {
	height = 64*FRACUNIT,
	radius = 32*FRACUNIT,
	spawnstate = S_INAZUMA_LIGHTNINGBALL,
	flags = MF_MISSILE|MF_NOGRAVITY,
	mass = DMG_ELECTRIC,
	speed = 32*FRACUNIT,
	seesound = sfx_s3k7c,
	painchance = 512*FRACUNIT,
}

mobjinfo[MT_INAZUMA_LIGHTNINGBLAST] = {
	height = 64*FRACUNIT,
	radius = 32*FRACUNIT,
	spawnstate = S_INAZUMA_LIGHTNINGBALL,
	deathstate = S_INAZUMA_LIGHTNINGBLAST,
	flags = MF_NOGRAVITY|MF_MISSILE,
	mass = DMG_ELECTRIC,
	speed = 72*FRACUNIT,
	seesound = sfx_inzbl,
	deathsound = sfx_kc3b,
	activesound = sfx_kc4d
}

mobjinfo[MT_INAZUMA_BARRIER] = {
	spawnstate = S_INVISIBLE,
	painstate = S_INAZUMA_BARRIER,
	deathstate = S_ULTZUMA_BARRIER,
	radius = mobjinfo[MT_PLAYER].radius,
	height = mobjinfo[MT_PLAYER].height,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT,
	mass = DMG_ELECTRIC
}

mobjinfo[MT_INAZUMA_SILVERHORN] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	dispoffset = 1,
	flags = MF_SCENERY|MF_NOTHINK|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT
}

mobjinfo[MT_MINDSCAPE_PORTAL] = {
	spawnstate = S_MINDSCAPE_PORTAL,
	spawnhealth = 1000,
	radius = 64*FRACUNIT,
	height = 128*FRACUNIT,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
}

sfxinfo[sfx_s1a2].flags = $ | SF_NOMULTIPLESOUND
mobjinfo[MT_MINDSCAPE_BLOB1] = {
	doomednum = 412,
	spawnstate = S_MINDSCAPE_BLOB1, //Main blob
	raisestate = S_MINDSCAPE_BLOB2, //Hit main blob
	seestate = S_MINDSCAPE_BLOBEX1, //Ultimate blob
	meleestate = S_MINDSCAPE_BLOBEX2, //Hit Ultimate blob
	missilestate = S_MINDSCAPE_BLOBEX3, //Spiked Ultimate blob
	xdeathstate = S_MINDSCAPE_BLOBEX4, //Fully spiked Ultimate blob
	painsound = sfx_bnce2, //Hit blob sound
	seesound = sfx_s1a2, //Extrude spikes
	attacksound = sfx_s3k64, //Retract spikes
	spawnhealth = 1000,
	radius = 32*FRACUNIT,
	height = 48*FRACUNIT,
	painchance = -1, //No points!
	mass = 12*FRACUNIT, //Vertical power
	activesound = TICRATE*2, //Time until Ultimate blobs spike
	flags = MF_SPECIAL|MF_NOGRAVITY
}

mobjinfo[MT_MINDSCAPE_BLOB2] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	activesound = mobjinfo[MT_MINDSCAPE_BLOB1].activesound,
	dispoffset = -2,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}

mobjinfo[MT_SILVERHORN_EGGROBO] = {
	spawnhealth = 1,
	spawnstate = S_EGGROBO1_PISSED,
	deathstate = S_SILVERHORN_EGGROBO,
	xdeathstate = S_XPLD_FLICKY,
	deathsound = sfx_s3kb4,
	radius = mobjinfo[MT_EGGROBO1].radius,
	height = mobjinfo[MT_EGGROBO1].height,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY
}

// Aether

SafeFreeslot("MT_AETHER_WING", "MT_AETHER_SWORD", "MT_GENESISSPAWNPOINT", "MT_SWORDSPAWNPOINT",
	"MT_AETHER_AURACENTER", "MT_AETHER_BURSTPARTICLE", "MT_AETHER_BURSTSHIELD",
	"MT_AETHER_ARCANEPARTICLE", "MT_AETHER_SWORDPARTICLE", "MT_AETHER_LIGHTORB", "MT_AETHER_RAYCAST",
	"MT_AETHER_ARCANEBOOSTER")
SafeFreeslot("SPR_AETP", "SPR_AESI", "SPR_WING", "SPR_WGSP", "SPR_SWRD", "SPR_C1RC", "SPR_BAND",
	"SPR_TORB", "SPR_RUNE", "SPR_ASH1", "SPR_ALZR", "SPR_AARO", "SPR_ALOB", "SPR_APOW", "SPR_BLES")
SafeFreeslot("S_AETHER_ARCANERUSH", "S_AETHER_SWORDRAIN", "S_AETHER_BLESSING") // player states
SafeFreeslot("S_AETHER_PARTICLE", "S_AETHER_PARTICLE2", "S_AETHER_WING", "S_AETHER_SWORD",
	"S_AETHER_PORTALRING", "S_AETHER_RUNEBAND", "S_AETHER_RUNES", "S_AETHER_ORB",
	"S_AETHER_SHIELD1", "S_AETHER_SHIELD2", "S_AETHER_SHIELD3", "S_AETHER_ARCANEPARTICLE",
	"S_AETHER_ARCANEBOOSTER", "S_AETHER_GENESISBEAM", "S_AETHER_BLESSBURST", "S_AETHER_LIGHTBALL_DEATH")
SafeFreeslot("sfx_sparkl", "sfx_flight", "sfx_genblt", "sfx_gencha", "sfx_spdwv", "sfx_swon", "sfx_swoff",
	"sfx_sparcr", "sfx_arcrsh", "sfx_arrshg", "sfx_spsel", "sfx_spelcd", "sfx_spcded", "sfx_spaubt",
	"sfx_spswrn", "sfx_abchrg", "sfx_abxp", "sfx_abbr", "sfx_abht", "sfx_absp", "sfx_aethdm", "sfx_aethwd",
	"sfx_srtral", "sfx_srfire", "sfx_srhit", "sfx_srport", "sfx_aeblss", "sfx_aeblsc", "sfx_algtbl")

sfxinfo[sfx_sparkl].caption = "Sparkling"
sfxinfo[sfx_flight].caption = "Flight"

sfxinfo[sfx_gencha].caption = "Charging"
sfxinfo[sfx_genblt].caption = "Powerful blast"

sfxinfo[sfx_spdwv].caption = "Speedwave"
sfxinfo[sfx_swon].caption = "Activation"
sfxinfo[sfx_swoff].caption = "Dissipate"

sfxinfo[sfx_sparcr].caption = "Arcane Rush"
sfxinfo[sfx_arcrsh].caption = "Boost"
sfxinfo[sfx_arrshg].caption = "Boost"

sfxinfo[sfx_spsel].caption = "Selection"
sfxinfo[sfx_spelcd].caption = "Spell on cooldown"
sfxinfo[sfx_spcded].caption = "Regain spell"

sfxinfo[sfx_spswrn].caption = "Sword Rain"
sfxinfo[sfx_srtral].caption = "/"
sfxinfo[sfx_srfire].caption = "Sword fire"
sfxinfo[sfx_srhit].caption = "Impact"
sfxinfo[sfx_srport].caption = "Portal spawn"

sfxinfo[sfx_spaubt].caption = "Aura Burst"
sfxinfo[sfx_absp].caption = "Shield get"
sfxinfo[sfx_abbr].caption = "Shattering"
sfxinfo[sfx_abht].caption = "Shield hit"
sfxinfo[sfx_abchrg].caption = "Charging"
sfxinfo[sfx_abxp].caption = "Explosion"

sfxinfo[sfx_aethwd].caption = "Dissipate"
sfxinfo[sfx_aethdm].caption = "Activation"

sfxinfo[sfx_aeblss].caption = "Blessing"
sfxinfo[sfx_aeblsc].caption = "Blessed"
sfxinfo[sfx_algtbl].caption = "Burst"

SafeFreeslot("SPR2_DNCE")

mobjinfo[MT_AETHER_WING] = {
	spawnstate = S_AETHER_WING,
	radius = 16*FRACUNIT,
	height = 48*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_SCENERY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_AETHER_BURSTPARTICLE] = {
	spawnstate = S_CACOFIRE_EXPLODE1,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_SCENERY|MF_NOCLIPHEIGHT|MF_NOCLIP|MF_NOCLIPTHING
}

mobjinfo[MT_AETHER_SWORD] = {
	spawnstate = S_AETHER_SWORD,
	deathstate = S_COINSPARKLE1,
	deathsound = sfx_srhit,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	speed = 48*FRACUNIT,
	flags = MF_MISSILE|MF_NOGRAVITY
}

mobjinfo[MT_GENESISSPAWNPOINT] = {
	spawnstate = S_INVISIBLE,
	radius = 64*FRACUNIT,
	height = 48*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOSECTOR|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_SWORDSPAWNPOINT] = {
	spawnstate = S_INVISIBLE,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOSECTOR|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_AETHER_AURACENTER] = {
	spawnstate = S_INVISIBLE,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOSECTOR|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_AETHER_BURSTSHIELD] = {
	spawnstate = S_AETHER_SHIELD1,
	painstate = S_AETHER_SHIELD3,
	deathstate = S_AETHER_SHIELD3,
	seesound = sfx_absp,
	painsound = sfx_abht,
	deathsound = sfx_abbr,
	spawnhealth = 2,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	dispoffset = 420,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT
}

mobjinfo[MT_AETHER_ARCANEPARTICLE] = {
	spawnstate = S_AETHER_ARCANEPARTICLE,
	speed = 16*FRACUNIT,
	height = 62*FRACUNIT,
	radius = 31*FRACUNIT,
	painchance = 3*FRACUNIT/4,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_SCENERY|MF_NOGRAVITY
}

mobjinfo[MT_AETHER_SWORDPARTICLE] = {
	spawnstate = S_AETHER_PARTICLE2,
	height = 4*FRACUNIT,
	radius = 2*FRACUNIT,
	speed = 8*FRACUNIT,
	painchance = 7*FRACUNIT/8,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY|MF_SCENERY
}

mobjinfo[MT_AETHER_LIGHTORB] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	seesound = sfx_kc3d, //Appear
	attacksound = sfx_kc5d, //Light up
	deathsound = sfx_kc59, //Deactivate
	activesound = sfx_s3k9e, //Bounce
	deathstate = S_AETHER_LIGHTBALL_DEATH,	// S_AETHER_LIGHTBALL_DEATH
	speed = 16*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_MISSILE|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_GRENADEBOUNCE,
}

mobjinfo[MT_AETHER_RAYCAST] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	speed = 32*FRACUNIT,
	radius = 32*FRACUNIT,
	height = FRACUNIT,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOCLIPTHING
}

mobjinfo[MT_AETHER_ARCANEBOOSTER] = {
	doomednum = -1,
	spawnstate = S_AETHER_ARCANEBOOSTER,
	spawnhealth = 1000,
	radius = 48*FRACUNIT,
	height = 48*FRACUNIT,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT|MF_SPECIAL|MF_NOGRAVITY
}

states[S_AETHER_ARCANERUSH] = {
	sprite = SPR_PLAY,
	tics = TICRATE/2,
	frame = SPR2_ROLL|FF_ANIMATE,
	var1 = 0,
	var2 = 1,
	nextstate = S_PLAY_JUMP
}

states[S_AETHER_SWORDRAIN] = {
	sprite = SPR_PLAY,
	frame = SPR2_TWIN,
	tics = 2,
	action = A_SetPAnim,
	var2 = PA_DASH,
	nextstate = S_AETHER_SWORDRAIN
}

states[S_AETHER_BLESSING] = {
	sprite = SPR_PLAY,
	tics = 3,
	frame = A|SPR2_MLEL,
	var1 = 0,
	var2 = 0,
	nextstate = S_AETHER_BLESSING,
}

states[S_AETHER_PARTICLE] = {
	sprite = SPR_AETP,
	frame = FF_FULLBRIGHT|FF_ANIMATE,
	var1 = 8,
	var2 = 1,
	tics = 9
}

states[S_AETHER_PARTICLE2] = {
	sprite = SPR_WGSP,
	frame = FF_FULLBRIGHT,
	tics = TICRATE
}

states[S_AETHER_SWORD] = {
	sprite = SPR_SWRD,
	frame = FF_FULLBRIGHT|C
}

states[S_AETHER_PORTALRING] = {
	sprite = SPR_C1RC,
	frame = FF_PAPERSPRITE
}

states[S_AETHER_RUNEBAND] = {
	sprite = SPR_BAND,
	frame = TR_TRANS20|FF_PAPERSPRITE
}

states[S_AETHER_RUNES] = {
	sprite = SPR_RUNE,
	frame = FF_PAPERSPRITE
}

states[S_AETHER_ORB] = {
	sprite = SPR_TORB
}

states[S_AETHER_WING] = {
	sprite = SPR_WING,
	frame = FF_PAPERSPRITE,
	tics = -1
}

local function AetherShieldTranslucency(mo)
	if mo.health <= 1
		mo.frame = ($ & ~FF_TRANSMASK) | FF_TRANS60
	else
		mo.frame = ($ & ~FF_TRANSMASK) | FF_TRANS40
	end
end

local function AetherShieldHealth(mo)
	if mo.health <= 0
		P_RemoveMobj(mo)
		return
	end
	AetherShieldTranslucency(mo)
end

states[S_AETHER_SHIELD1] = {
	sprite = SPR_ASH1,
	frame = FF_FULLBRIGHT|FF_ANIMATE|FF_TRANS20,
	var1 = 11,
	var2 = 2,
	tics = 24,
	nextstate = S_AETHER_SHIELD2,
	action = AetherShieldHealth
}

states[S_AETHER_SHIELD2] = {
	sprite = SPR_ASH1,
	frame = M|FF_FULLBRIGHT|FF_TRANS50,
	nextstate = S_AETHER_SHIELD2,
	action = AetherShieldTranslucency
}

states[S_AETHER_SHIELD3] = {
	sprite = SPR_ASH1,
	frame = N|FF_FULLBRIGHT|FF_ANIMATE|FF_TRANS20,
	var1 = 3,
	var2 = 2,
	tics = 8,
	nextstate = S_AETHER_SHIELD1
}

states[S_AETHER_ARCANEPARTICLE] = {
	sprite = SPR_AARO,
	frame = FF_FULLBRIGHT|FF_TRANS20|FF_ANIMATE|FF_RANDOMANIM,
	var1 = 9,
	var2 = 1,
	tics = 13
}

states[S_AETHER_ARCANEBOOSTER] = {
	sprite = SPR_AARO,
	frame = FF_FULLBRIGHT|FF_ANIMATE|M,
	var1 = 3,
	var2 = 2,
	tics = TICRATE*8
}

states[S_AETHER_GENESISBEAM] = {
	sprite = SPR_ALZR,
	frame = FF_FULLBRIGHT|FF_ANIMATE,
	var1 = 1,
	var2 = 2,
	tics = -1
}

local blessing_frames = 8
local blessing_frametics = 2
local blessing_totaltics = blessing_frames * blessing_frametics
function A_AetherBlessBurst(actor, var1, var2)
	-- handle frames
	actor.threshold = $ and $+1 or 1
	local frame = max(0, min(blessing_frames - 1, actor.threshold / blessing_frametics))
	local frameflags = (actor.frame & ~FF_FRAMEMASK)
	
	actor.frame = frame | frameflags
	if (actor.threshold == blessing_totaltics)
		P_RemoveMobj(actor)
		return
	end
	
	-- track target
	local target = (actor.target and actor.target.valid) and actor.target or actor.tracer
	if not (target and target.valid) then return end
	
	-- little hack to make A_CapeChase work when dead
	local old_health = target.health
	target.health = 69
	A_CapeChase(actor)
	target.health = old_health
end

states[S_AETHER_BLESSBURST] = {
	sprite = SPR_BLES,
	frame = FF_FULLBRIGHT,
	action = A_AetherBlessBurst,
	tics = 1,
	nextstate = S_AETHER_BLESSBURST,
}

-- death state for the light ball
local lightorb_range = FRACUNIT*96
local lightorb_tumblelaunch = FRACUNIT*11
local lightorb_tumbletics = TICRATE*2
local lightorb_tumblethrust = FRACUNIT*9

local function lightorb_blockmap(ref, found, range)
	if not (range) then return true end	-- no range given...
	
	-- dont target these no matter what
	if (ref == found) then return end	-- not ourself
	if (ref == ref.target) then return end	-- not our target (owner)
	if not ((found and found.valid) or found.health) then return end	-- gotta be alive
	if not (P_CheckSight(ref, found)) then return end	-- no LoS
	
	-- affect nearby objects!
	local dist = FixedHypot(FixedHypot(found.x - ref.x, found.y - ref.y), found.z - ref.z)
	if not (dist <= range) then return end	-- too far away
	
	if not (found.player)
		if not (found.flags & (MF_SHOOTABLE|MF_ENEMY)) then return end	-- not a valid mobj
		P_DamageMobj(found, ref, ref.target, 1, 0)
	elseif (CBW_Battle)
		if (found.player.powers[pw_invulnerability] or found.player.powers[pw_super])	-- dont burst these
		or (found.player.intangible)	-- intangible
		or (CBW_Battle.MyTeam(ref.target.player, found.player))	-- same team
			return
		end
		
		-- tumble them!
		local angle = R_PointToAngle2(ref.x, ref.y, found.x, found.y)
		local launch = lightorb_tumblelaunch / CBW_Battle.WaterFactor(found)
		local thrust = FixedMul(ref.scale, lightorb_tumblethrust)
		
		P_SetObjectMomZ(found, launch)
		CBW_Battle.DoPlayerTumble(found.player, lightorb_tumbletics, angle, thrust, true)
	end
end

function A_AetherLightballDeath(actor, var1, var2)
	-- damaging burst
	if not (actor.aether_noburst)
		-- spawn particles
		actor.color = SKINCOLOR_GOLDENROD
		AetherBlessSparkles(actor, FRACUNIT, 20, FRACUNIT*16)
		S_StartSound(mo, sfx_algtbl)
		
		-- burst away things in a radius
		local range = lightorb_range
		searchBlockmap("objects", function(ref, found)
			return lightorb_blockmap(ref, found, range)
		end, actor, actor.x - range, actor.x + range, actor.y - range, actor.y + range)
		
		actor.aether_bursted = true	-- easier identifier than a state check
		actor.fuse = TICRATE	-- give the death sound enough time to play
		return
	end
	
	-- regular death
	actor.state = S_INVISIBLE
end

states[S_AETHER_LIGHTBALL_DEATH] = {
	sprite = SPR_NULL,
	frame = 0,
	action = A_AetherLightballDeath,
	tics = -1,
	nextstate = S_NULL,
}

--isolated for safekeeping
SafeFreeslot("MT_ZUMASPREAD", "S_ZUMASPREAD1", "S_ZUMASPREAD2")
SafeFreeslot("SPR_SHCB")

mobjinfo[MT_ZUMASPREAD] = {
	height = 24*FRACUNIT,
	radius = 48*FRACUNIT,
	spawnstate = S_ZUMASPREAD1,
	speed = 15*FRACUNIT,
	damage = 3,
	deathstate = S_INAZUMA_FX,
	xdeathstate = S_INAZUMA_FX,
	painchance = 3*TICRATE,
	seesound = sfx_s3k5e,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY|MF_PAPERCOLLISION
}

states[S_ZUMASPREAD1] = {
	tics = 8,
	sprite = SPR_SHCB,
	frame =  FF_FULLBRIGHT|FF_PAPERSPRITE|FF_ANIMATE,
	action = A_Boss3ShockThink,
	var1 = 4,
	var2 = 2,
	nextstate = S_ZUMASPREAD2
}

states[S_ZUMASPREAD2] = {
	tics = 8,
	sprite = SPR_SHCB,
	frame =  3|FF_FULLBRIGHT|FF_PAPERSPRITE|FF_ANIMATE,
	action = A_Boss3ShockThink,
	var1 = 4,
	var2 = 2,
	nextstate = S_ZUMASPREAD1
}

SafeFreeslot("S_SILVERHORN_HUG", "S_SILVERHORN_HEART")
states[S_SILVERHORN_HUG] = {
	sprite = SPR_PLAY,
	frame = SPR2_TAL0,
	tics = 4,
	action = A_SetPAnim,
	var2 = PA_IDLE,
	nextstate = S_SILVERHORN_HUG
}

states[S_SILVERHORN_HEART] = {
	sprite = SPR_LHRT,
	frame = FF_FULLBRIGHT,
	tics = 2,
	nextstate = S_NULL
}