
addHook("NetVars", function(n)
	-- Silverhorn.LocalData["game"] = n($)
	FrameAnimSH.netvars(n)
	MobjMoverSH.netvars(n)
	HitDisplaySH.netvars(n)
	Silverhorn.MapAC_GalleryWallLines = n($)
end)

addHook("MapLoad", function(mapnum)
	HitDisplaySH.clearall()
	Silverhorn.FailedEntry_DisableMindscapeTitleOnMapLoad()
	Silverhorn.SaveMindscapeBrightnessLevels(mapnum)
	Silverhorn.CollectMindscapeSpecialObjects(mapnum)
	Silverhorn.LoadGalleryWallLines()
	for player in players.iterate
		Silverhorn.UndoForceEnableAnalogMode(player)
	end

	-- TODO: nextlevel = credits map conflict
	if mapheaderinfo[mapnum].mindscape then
	-- if mapheaderinfo[gamemap].mindscape and not (MindscapeSessionFlags & MS_ENTEREDMINDSCAPE) then
		-- G_SetCustomExitVars(MS_LASTGAMEMAP, 1)
		-- G_ExitLevel()
		-- for player in players.iterate do
		-- 	P_DoPlayerExit(player)
		-- 	player.exiting = 1
		-- end
		-- print("Red Crewmate has been ejected into space.")
	end

	-- (Aether's Castle - no hud) (consolodate this hud file into this hook)
	if (mapheaderinfo[mapnum].aetherscastle) then
		EvActionSH.SetInternalHudStatus({"time", "score", "rings", "lives"}, false)
	end

end)

addHook("MapChange", function(mapnum)
	EventSH.MapReloadClearEvents()
	HitDisplaySH.clearall()
	Silverhorn.FailedEntry_EnableMindscapeTitleOnMapChange()

	-- Keep the screen faded on change
	if mapheaderinfo[mapnum].mindscape and not (MindscapeSessionFlags & MS_SEENINTRO) then
		EvActionSH.fadescreen("full", 31, 1)
	end

	-- temporary until hud changes can be designated as temporary per map
	-- if (MindscapeSessionFlags & MS_INMINDSCAPE) then
		EvActionSH.SetInternalHudStatus({"time", "score", "rings", "lives"}, true)
	-- end

	Silverhorn.MapAC_GalleryWallLines = nil

end)

addHook("GameQuit", function()
	Silverhorn.MapAC_GalleryWallLines = nil
end)

addHook("ThinkFrame", function()
	-- if not (mapheaderinfo[gamemap].mindscape or mapheaderinfo[gamemap].silverhorn_endingmap) then return end
	MobjMoverSH.Thinker()
	FrameAnimSH.Thinker()
	HitDisplaySH.meterupdate()
	EventSH.RunEvents()

	CreditMaps.WarpToMap()
	Silverhorn.LoadGallery() -- Emergency use
end)

addHook("SeenPlayer", EvActionSH.seenamesoff)

addHook("LinedefExecute", Silverhorn.ShowGalleryImage, "SHENCARD")

addHook("ViewpointSwitch", function(...)
	if (mapheaderinfo[gamemap].aetherscastle) then
		return Silverhorn.GalleryViewpoint(...)
	end
end)


-- ======
-- HUD
-- ======

for _,hudtype in pairs({"game", "scores"}) do
	hud.add(function(v, stplyr, cam)
		EvActionSH.hudcontrol(v, stplyr, cam)
	end, hudtype)
end

hud.add(function(v, stplyr, cam)
	HitDisplaySH.meterdisplay(v, stplyr, cam)
end, "game")

-- ---------------------------------------------

