freeslot(
	"MT_EMERALDDISPLAY",
	"S_EMERALDDISPLAY1",
	"S_EMERALDDISPLAY2",
	"SPR_EDIS",
	"SFX_EDPLCE"
)

sfxinfo[sfx_edplce].caption = "Emerald placed"

mobjinfo[MT_EMERALDDISPLAY] = {
	--$Name "Emerald Display"
	--$Sprite EDISA0
	--$Flags1Text Invisible Wireframe
	--$Flags8Text Invert Floating
	--$AngleText Type 1-14
	spawnstate = S_EMERALDDISPLAY1,
	doomednum = 3023,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	spawnhealth = 999,
	flags = MF_NOGRAVITY|MF_SPECIAL,
}

states[S_EMERALDDISPLAY1] = {
    sprite = SPR_NULL,
    frame = A|FF_FULLBRIGHT,
	tics = -1,
	nextstate = S_EMERALDDISPLAY1
}

states[S_EMERALDDISPLAY2] = {
    sprite = SPR_NULL,
    frame = A|FF_FULLBRIGHT,
	tics = -1,
	nextstate = S_EMERALDDISPLAY2
}

local placedchaos = 0
local placedsol = 0

addHook("MapLoad", function(mapnum)
	placedchaos = 0
	placedsol = 0
end)

addHook("NetVars", function(network)
	placedchaos = network($)
	placedsol = network($)
end)

local spawnlist = {
	[1] = A|FF_FULLBRIGHT,
	[2] = B|FF_FULLBRIGHT,
	[3] = C|FF_FULLBRIGHT,
	[4] = D|FF_FULLBRIGHT,
	[5] = E|FF_FULLBRIGHT,
	[6] = F|FF_FULLBRIGHT,
	[7] = G|FF_FULLBRIGHT,
	[8] = H|FF_FULLBRIGHT,
	[9] = I|FF_FULLBRIGHT,
	[10] = J|FF_FULLBRIGHT,
	[11] = K|FF_FULLBRIGHT,
	[12] = L|FF_FULLBRIGHT,
	[13] = M|FF_FULLBRIGHT,
	[14] = N|FF_FULLBRIGHT,
}

addHook("MapThingSpawn", function(mo, mt)
	mo.eid = mt.angle
	if not(mt.options & MTF_EXTRA)
	   mo.frame = spawnlist[mo.eid] or $
	   mo.sprite = SPR_EDIS
	end
end, MT_EMERALDDISPLAY)

addHook("TouchSpecial", function(mo, pmo)
    if mo and mo.valid and pmo and pmo.valid 
        if ((emeralds & EMERALD1)and mo.eid == 1)
		   mo.state = S_EMERALDDISPLAY2
		   mo.frame = A|FF_FULLBRIGHT
		   mo.sprite = SPR_CEMG
		   mo.flags = MF_NOGRAVITY|MF_NOCLIP
		   S_StartSound(mo, sfx_edplce)
		   placedchaos = $ | EMERALD1
		elseif ((emeralds & EMERALD2)and mo.eid == 2)
	       mo.state = S_EMERALDDISPLAY2
		   mo.frame = B|FF_FULLBRIGHT
		   mo.sprite = SPR_CEMG
		   mo.flags = MF_NOGRAVITY|MF_NOCLIP
		   S_StartSound(mo, sfx_edplce)
		   placedchaos = $ | EMERALD2
		elseif ((emeralds & EMERALD3)and mo.eid == 3)
	       mo.state = S_EMERALDDISPLAY2
		   mo.frame = C|FF_FULLBRIGHT
		   mo.sprite = SPR_CEMG
		   mo.flags = MF_NOGRAVITY|MF_NOCLIP
		   S_StartSound(mo, sfx_edplce)
		   placedchaos = $ | EMERALD3
		elseif ((emeralds & EMERALD4)and mo.eid == 4)
	       mo.state = S_EMERALDDISPLAY2
		   mo.frame = D|FF_FULLBRIGHT
		   mo.sprite = SPR_CEMG
		   mo.flags = MF_NOGRAVITY|MF_NOCLIP	
		   S_StartSound(mo, sfx_edplce)
		   placedchaos = $ | EMERALD4
		elseif ((emeralds & EMERALD5)and mo.eid == 5)
	       mo.state = S_EMERALDDISPLAY2
		   mo.frame = E|FF_FULLBRIGHT
		   mo.sprite = SPR_CEMG
		   mo.flags = MF_NOGRAVITY|MF_NOCLIP
		   S_StartSound(mo, sfx_edplce)
		   placedchaos = $ | EMERALD5
		elseif ((emeralds & EMERALD6)and mo.eid == 6)
	       mo.state = S_EMERALDDISPLAY2
		   mo.frame = F|FF_FULLBRIGHT
		   mo.sprite = SPR_CEMG
		   mo.flags = MF_NOGRAVITY|MF_NOCLIP
		   S_StartSound(mo, sfx_edplce)
		   placedchaos = $ | EMERALD6
		elseif ((emeralds & EMERALD7)and mo.eid == 7)
	       mo.state = S_EMERALDDISPLAY2
		   mo.frame = G|FF_FULLBRIGHT
		   mo.sprite = SPR_CEMG
		   mo.flags = MF_NOGRAVITY|MF_NOCLIP	
		   S_StartSound(mo, sfx_edplce)
		   placedchaos = $ | EMERALD7
		end   
		if not(pmo.player.solemeralds == nil)
		   if(((pmo.player.solemeralds & (1 << (1 - 1)))or(mpemeraldsave & (1 << (1 - 1))))and mo.eid == 8)
	          mo.state = S_EMERALDDISPLAY2
		      mo.frame = A|FF_FULLBRIGHT
		      mo.sprite = SPR_SEM1
		      mo.flags = MF_NOGRAVITY|MF_NOCLIP	
			  S_StartSound(mo, sfx_edplce)
			  placedsol = $ | EMERALD1
		   elseif(((pmo.player.solemeralds & (1 << (2 - 1)))or(mpemeraldsave & (1 << (2 - 1))))and mo.eid == 9)
	          mo.state = S_EMERALDDISPLAY2
		      mo.frame = A|FF_FULLBRIGHT
		      mo.sprite = SPR_SEM2
		      mo.flags = MF_NOGRAVITY|MF_NOCLIP
			  S_StartSound(mo, sfx_edplce)
			  placedsol = $ | EMERALD2
		   elseif(((pmo.player.solemeralds & (1 << (3 - 1)))or(mpemeraldsave & (1 << (3 - 1))))and mo.eid == 10)
	          mo.state = S_EMERALDDISPLAY2
		      mo.frame = A|FF_FULLBRIGHT
		      mo.sprite = SPR_SEM3
		      mo.flags = MF_NOGRAVITY|MF_NOCLIP
			  S_StartSound(mo, sfx_edplce)
			  placedsol = $ | EMERALD3
		   elseif(((pmo.player.solemeralds & (1 << (4 - 1)))or(mpemeraldsave & (1 << (4 - 1))))and mo.eid == 11)
	          mo.state = S_EMERALDDISPLAY2
		      mo.frame = A|FF_FULLBRIGHT
		      mo.sprite = SPR_SEM4
		      mo.flags = MF_NOGRAVITY|MF_NOCLIP
			  S_StartSound(mo, sfx_edplce)
			  placedsol = $ | EMERALD4
		   elseif(((pmo.player.solemeralds & (1 << (5 - 1)))or(mpemeraldsave & (1 << (5 - 1))))and mo.eid == 12)
	          mo.state = S_EMERALDDISPLAY2
		      mo.frame = A|FF_FULLBRIGHT
		      mo.sprite = SPR_SEM5
		      mo.flags = MF_NOGRAVITY|MF_NOCLIP
			  S_StartSound(mo, sfx_edplce)
			  placedsol = $ | EMERALD5
		   elseif(((pmo.player.solemeralds & (1 << (6 - 1)))or(mpemeraldsave & (1 << (6 - 1))))and mo.eid == 13)
	          mo.state = S_EMERALDDISPLAY2
		      mo.frame = A|FF_FULLBRIGHT
		      mo.sprite = SPR_SEM6
		      mo.flags = MF_NOGRAVITY|MF_NOCLIP
			  S_StartSound(mo, sfx_edplce)
			  placedsol = $ | EMERALD6
		   elseif(((pmo.player.solemeralds & (1 << (7 - 1)))or(mpemeraldsave & (1 << (7 - 1))))and mo.eid == 14)
	          mo.state = S_EMERALDDISPLAY2
		      mo.frame = A|FF_FULLBRIGHT
		      mo.sprite = SPR_SEM7
		      mo.flags = MF_NOGRAVITY|MF_NOCLIP
			  S_StartSound(mo, sfx_edplce)
			  placedsol = $ | EMERALD7
		   end
        end
		return true
	end
end, MT_EMERALDDISPLAY)

local colorlist = {
	[1] = SKINCOLOR_MINT,
	[2] = SKINCOLOR_BUBBLEGUM,
	[3] = SKINCOLOR_SAPPHIRE,
	[4] = SKINCOLOR_SKY,
	[5] = SKINCOLOR_ORANGE,
	[6] = SKINCOLOR_SALMON,
	[7] = SKINCOLOR_AETHER,
	[8] = SKINCOLOR_MINT,
	[9] = SKINCOLOR_BUBBLEGUM,
	[10] = SKINCOLOR_SAPPHIRE,
	[11] = SKINCOLOR_SKY,
	[12] = SKINCOLOR_ORANGE,
	[13] = SKINCOLOR_SALMON,
	[14] = SKINCOLOR_AETHER,
}

addHook("MobjThinker", function(mo)
	if not ((mo and mo.valid) and mo.health) then return end
	    local amb = 1
	    if mo.flags2 & MF2_AMBUSH
	       amb = -1
	    end
	    if mo.state == S_EMERALDDISPLAY2
		   if leveltime%72==0
		      P_SetObjectMomZ(mo, ((1*FRACUNIT)/2)*amb, false)
			  mo.cycle = true
		   elseif leveltime%36==0
		   and mo.cycle == true
		      P_SetObjectMomZ(mo, ((-1*FRACUNIT)/2)*amb, false)
		   end
		end
		///Sparkle code from Rushchars
		if mo.state == S_EMERALDDISPLAY2 and (P_RandomRange(1, 4) == 1)
			local spark = P_SpawnMobjFromMobj(mo, P_RandomRange(30, -30)*FRACUNIT, P_RandomRange(30, -30)*FRACUNIT, P_RandomRange(30, -30)*FRACUNIT, MT_BOXSPARKLE)
			spark.colorized = true
			spark.color = colorlist[mo.eid] or $
			spark.frame = $ | FF_FULLBRIGHT
			if P_RandomRange(0, 2) != 0
				spark.scale = P_RandomRange(1,2)*FRACUNIT
			else
				spark.scale = FRACUNIT - FRACUNIT/4
			end
		end
end, MT_EMERALDDISPLAY)

//Transform the player on the emerald altar
//In Mindscape, this is used to give the player rings for Phase 3
addHook("LinedefExecute", function(line, mo)
	local player = mo.player
	if not player then return end
	local sol = player.solchar
	
	if mapheaderinfo[gamemap].mindscape
		player.rings = max($, 500)
			
	elseif sol and All7Emeralds(placedsol) and not player.powers[pw_super]
		player.rings = max($, 200)
		Silverhorn.SolTransformation(player)
		
	elseif All7Emeralds(placedchaos) and player.charflags & SF_SUPER
		player.rings = max($, 200)
		if not player.powers[pw_super]
			mo.z = $ + P_MobjFlip(mo)*mo.scale
			P_DoSuperTransformation(player, false)
		end
	end
end, "ALTARTRANS")