-- ============================================================
-- Mindscape
-- Boss 2
-- by Altalune
-- ============================================================

freeslot(
	"S_CCH_TORCH", -- Torch sway
	"S_LSTND_HOLE", -- Black Hole
	"sfx_portfr", -- Portal Fire
	"sfx_portlp", -- Portal Fire (LOOP)
	"sfx_tlosth", -- Torch Lost
	"sfx_kchg5", -- Beam Sound
	"sfx_dawrld", -- (The World)
	"SPR_FTHK", -- Thok Copy
	"SPR_FMFR" -- Light beam
)

-- Constants
local MAX_BOSS_HP = 50
local Ph2_Skyfire_FireTime = 40/4
local Ph2_CrashCountdown_Scale = 6*FU
local Ph2_MeteorDamageRadius = 1400*FU
local Arena_TagID = 7900
local Arena_Outer_TagID = 7901
local Arena_Sky_TagID = 500
local Arena_Sky_Light_TagID = 501
local ColorShift_Boss_Transform_Particle = {SKINCOLOR_ROSY, SKINCOLOR_BLACK, SKINCOLOR_SEAFOAM}
local ColorShift_MegaLaser_Default = {SKINCOLOR_MAGENTA,SKINCOLOR_MAGENTA,SKINCOLOR_NEON,SKINCOLOR_NEON,SKINCOLOR_MAGENTA,SKINCOLOR_MAGENTA,SKINCOLOR_ROSY,SKINCOLOR_ROSY,SKINCOLOR_BUBBLEGUM,SKINCOLOR_BUBBLEGUM,SKINCOLOR_ROSY,SKINCOLOR_ROSY}
local ColorShift_MegaLaser_GFlame = {SKINCOLOR_AQUA,SKINCOLOR_AQUA,SKINCOLOR_AQUA,SKINCOLOR_AQUA,SKINCOLOR_AQUA,SKINCOLOR_AQUA,SKINCOLOR_SEAFOAM,SKINCOLOR_SEAFOAM,SKINCOLOR_SEAFOAM,SKINCOLOR_SEAFOAM,SKINCOLOR_SEAFOAM,SKINCOLOR_SEAFOAM}
local ColorShift_MegaLaser_FinalStand = {SKINCOLOR_RED,SKINCOLOR_RED,SKINCOLOR_RED,SKINCOLOR_FLAME,SKINCOLOR_FLAME,SKINCOLOR_FLAME,SKINCOLOR_SALMON,SKINCOLOR_SALMON,SKINCOLOR_SALMON,SKINCOLOR_PEACHY,SKINCOLOR_PEACHY,SKINCOLOR_PEACHY,SKINCOLOR_SALMON,SKINCOLOR_SALMON,SKINCOLOR_SALMON,SKINCOLOR_FLAME,SKINCOLOR_FLAME,SKINCOLOR_FLAME}
local ColorShift_Boss_Default = {SKINCOLOR_MINT, SKINCOLOR_AQUA, SKINCOLOR_SEAFOAM, SKINCOLOR_TEAL}
local ColorShift_Boss_Neuro = {SKINCOLOR_SAPPHIRE, SKINCOLOR_YELLOW, SKINCOLOR_AETHER, SKINCOLOR_BLUE}
local ColorShift_Boss_Omni = {SKINCOLOR_LAVENDER,SKINCOLOR_NEON,SKINCOLOR_VIOLET,SKINCOLOR_RASPBERRY}
local ColorShift_Boss_Sky = {SKINCOLOR_MINT, SKINCOLOR_GREEN}
local ColorShift_Boss_MEGA = {SKINCOLOR_LIME, SKINCOLOR_EMERALD, SKINCOLOR_MINT, SKINCOLOR_SEAFOAM, SKINCOLOR_AQUA}
local ColorShift_Boss_Crash = {SKINCOLOR_JET, SKINCOLOR_BLACK}

-- Arena
-- (coordinates are self contained in the map until UDMF args/stringargs are available)
-- 1
local ARENA_1_CENTER = {x=22450*FU, y=-8576*FU, z=5520*FU}
local MAX_ARENA_RADIUS = 2300*FU
local ARENA_1_RADIUS_INNER = 682*FU
local ARENA_1_RADIUS_OUTER = 2080*FU
local ARENA_1_RADIUS_TP = 2480*FU
local ARENA_1_TP_LENGTH = 13344*FU
-- Our (ph1) arena bounds begin and end here: ((20207,-6347) , (24656,-10770))
local ARENA_1_RECT = {x1=20207, y1=-6347, x2=24656, y2=-10770}
-- 2
local ARENA_2_FLOOR = 5880*FU
local ARENA_2_CENTER = {x=22450*FU, y=-22032*FU, z=5880*FU}
local ARENA_2_RECT = {x1=19120, y1=-18704, x2=25776, y2=-25360}
local ARENA_2_RAD = 2480*FU -- new: 2480 -- 4600/4720*FU -- old: 4430
local ARENA_2_RAD_INNER = 0
local ARENA_2_RAD_OUTER = 2480*FU
local ARENA_2_METEORDISTANCE = 4000*FU
local ARENA_2_METEORHEIGHT = 2000*FU
local ARENA_2_VOID = {x=17408*FU, y=-16384*FU, z=5880*FU}
local ARENA_2_SUCTION_RAD = 1540*FU
local ARENA_2_SUCTION_DANGER_RAD = 720*FU

local Facc_Move_Patterns = {
	-- Introductory set,
	{
		-- Neuro Charge (An attack that tests dash reaction time)
		"facciolo_ph2_charge",
		-- Burst 3Z Inferno (An attack that tests top speed management)
		"facciolo_ph2_flamethrower",
		-- Omnislash (An attack that tests movement and reaction speed)
		"facciolo_ph2_omnislash",
		"facciolo_ph2_omnislash",
		-- Grid Laser
		"facciolo_ph2_p1laser",
	},

	-- Start of second half
	{
		-- Psycho Meteor (All range attack)
		"facciolo_ph2_meteor",
	},

	-- More aggressive set
	{
		-- "facciolo_ph2_spinslash", -- (TBD)
		-- "facciolo_ph2_swordwave", -- (TBD)
		-- "facciolo_ph2_darkcolumn", -- (TBD)

		"facciolo_ph2_omnislash",
		"facciolo_ph2_flamethrower",
		-- 3
		"facciolo_ph2_skyfire",
		-- ==
		"facciolo_ph2_charge",
		"facciolo_ph2_omnislash",
		-- 2
		"facciolo_ph2_bladecrash",
		-- ==
		"facciolo_ph2_omnislash",
		"facciolo_ph2_p1laser",
		-- 1
		"facciolo_ph2_megalaser",
		-- ==
		"facciolo_ph2_p1laser",
		"facciolo_ph2_p1laser",
		"facciolo_ph2_meteor",
		-- 0.
		"facciolo_ph2_mindcrash"

		-- Old (Referenced)
		-- =============================
		-- "facciolo_ph2_omnislash",
		-- "facciolo_ph2_flamethrower",
		-- "facciolo_ph2_skyfire",
		-- "facciolo_ph2_charge",
		-- "facciolo_ph2_omnislash",
		-- "facciolo_ph2_omnislash",
		-- "facciolo_ph2_p1laser",
		-- "facciolo_ph2_p1laser",
		-- "facciolo_ph2_p1laser",

		-- Psycho Meteor (All range attack)
		-- "facciolo_ph2_meteor",

		-- Dark Column (The end.)
		-- "facciolo_ph2_blackhole",
		-- =============================
	}
}

-- Counts how many players are in a game and adds to a value to use for number scaling
local function numplayers_multiplier(addamount, testplayeramount)

	local multiplier = 0
	local playercount = 0

	-- if you have over 6 players stop scaling
	if testplayeramount then
		for i=1, testplayeramount do
			if playercount > 6 then break end
			playercount = $1+1
			multiplier = $1+addamount
		end
	else
		for player in players.iterate do
			if playercount > 6 then break end
			if player.bot then continue end
			playercount = $1+1
			multiplier = $1+addamount
		end
	end

	return multiplier
end

local function isMobjValid(mo)
	return (mo and mo.valid)
end

-- Allows zero values or an alternative if value is nil
local function notnil(value, altvalue)
	return (value and not nil) and value or altvalue
end

-- Custom Random function that uses leveltime in case the random seed desynched
local function RandomRange_P(min, max)
	if min == max then return min end -- What's the point if there's no range?

	-- Well this won't work if min isn't actually min!
	if min > max then
		local oldmax = max
		max = min
		min = oldmax
	end

	-- Get a mapthing's positioning based off of the leveltime
	local position = 0
	local thing = mapthings[leveltime % (#mapthings + 1)]
	if thing then
		if check == 0 then
			position = thing.x
		elseif check == 1 then
			position = thing.y
		else
			position = thing.z
		end

		--Add each player's lives and skin
		for player in players.iterate do
			position = $1 * player.skin * player.lives
		end

		if position < 0 then
			position = abs($1 + INT32_MAX)
		end
	end

	-- Get our value
	local factor = position or leveltime
	local value = (factor % (max - min))
	return value + min
end
EventSH.RandomRange_P = RandomRange_P


-- Random Choice port
local function RANDOMCHOICE(choices, vanillarandom)
	local RandomKey = 0
	if vanillarandom then
		RandomKey = P_RandomRange(1, #choices)
	else
		RandomKey = RandomRange_P(1, #choices)
	end
    if type(choices[RandomKey]) == "function" then
        choices[RandomKey]()
    else
        return choices[RandomKey]
    end
end
EventSH.RANDOMCHOICE = RANDOMCHOICE

-- Thrusts forward like P_InstaThrust but also uses the z position
local function P_InstaThrustZ(mo, dest, speed)

	P_InstaThrust(mo, mo.angle, speed)

	local dist = P_AproxDistance(dest.x - mo.x, dest.y - mo.y) / speed
	mo.momz = (dest.z-mo.z) / (dist+1)
end

-- Picks a player at random
local function P_PickRandomPlayer(playertable)

    local playerlist = playertable or {}

    if not playertable then
        for player in players.iterate do
            table.insert(playerlist, player)
        end
    end

    local randomTarget = RANDOMCHOICE(playerlist)

    if (randomTarget and randomTarget.valid) then
        return randomTarget.mo
    else
		return nil -- no target found
    end

end
Silverhorn.PickRandomPlayer = P_PickRandomPlayer

-- Find a player that exists, and if one doesn't exist, retry until found
-- (Check if they are close to the units specified and return the closest player)
-- (alttarget is used if getting a target fails)
local function Facc_GetNearbyTarget(mo, closedist, alttarget)

	local target = P_PickRandomPlayer()

	-- Target the arena center if no player target can be found at all
	-- if not target and target.valid then target = ARENA_2_CENTER end

	if (target) then

		local dist = P_AproxDistance(target.x - mo.x, target.y - mo.y)

		if dist < closedist then
			return target
		end
	else
		return alttarget
	end
end
Silverhorn.GetNearbyTarget = Facc_GetNearbyTarget

-- Gets the distance between start (x,y), and determines if the object is between the inner and outer distances
local function Facc_IsInBounds(start, target, indist, outdist)

	local dist = P_AproxDistance(target.x - start.x, target.y - start.y)

	if (dist >= indist and dist <= outdist) then
		return true
	else
		return false
	end

end

-- Called any time a target might need to be verified
local function Facc_VerifyTarget(mo, alttarget)
	if not isMobjValid(mo) then return end

	if not (mo.target and mo.target.valid) -- not a valid target
	or not Facc_IsInBounds(ARENA_2_CENTER, mo.target, 0, ARENA_2_RAD+600*FU) then -- target is not in vicinity
		-- print("Getting new target...")
		-- Get a new target, and if that fails, set a dummy target directly in the boss center
		mo.target = Facc_GetNearbyTarget(ARENA_2_CENTER, ARENA_2_RAD+600*FU) or alttarget or (mo.facc and mo.facc.nulltarget)
		return false
	else
		-- mo.target = $1
		-- there is a target so return a status just in case?
		return true
	end
end

-- Sets the boss's frame or state
local function Facc_SetCharFrame(mobj, frame)
	mobj.frame = R_Char2Frame(tostring(frame))
end

-- Sets the boss's animation (idle|slash_front|slash|slash_flip|slam1|slam2|charge|dash|breath|hold1|hold2|throw)
function Silverhorn.SetFaccAnimation(mobj, animname, params)

	params = notnil($1, {})

	-- Animation frame database (stop SLADE lookups!)
	local anims = {
		["idle"] = {frstart="A", frend="D", loopa=1, delay=2},
		["slash_front"] = {frstart="E", frend="L", loopa=1, delay=2, loopfr="H"},
		["slash"] = {frstart="M", frend="P", delay=2},
		["slash_flip"] = {frstart="Q", frend="T", delay=2},
		["slam1"] = {frstart="j", frend="m", loopa=1, delay=2},
		["slam2"] = {frstart="n", frend="q", loopa=1, delay=2},
		["charge"] = {frstart="Y", frend="1", loopa=1, delay=2},
		["dash"] = {frstart="U", frend="X", loopa=1, delay=2},
		["breath"] = {frstart="2", frend="5", loopa=1, delay=2},
		["hold1"] = {frstart="6", frend="9", loopa=1, delay=2},
		["hold2"] = {frstart="a", frend="d", loopa=1, delay=2},
		["throw"] = {frstart="e", frend="i", loopa=1, delay=2, loopfr="f"},
		["defeat1"] = {frstart="s", frend="v", loopa=1, delay=2},
		["defeat2"] = {frstart="O", frend="O", loopa=1, delay=5, sprite=SPR_FACC},
	}

	-- Get animation set range
	local u_anim = anims[animname] or anims["idle"]

	-- Get animation range parameters
	local param = {
		loopalways = u_anim.loopa,
		delay = u_anim.delay,
		loopframe = u_anim.loopfr,
	}

	-- Animation
	FrameAnimSH.add("_facc", mobj, u_anim.sprite or SPR_MNRV, u_anim.frstart, u_anim.frend, param)
end

-- Toggles the mobj's sprite drawing
local function Facc_SetVisibility(mobj, isvisible)

	if not isMobjValid(mobj) then return end

	if (isvisible) then
		mobj.facc.isntseen = false
		mobj.flags2 = $1 &~ MF2_DONTDRAW
	else
		mobj.facc.isntseen = true
		mobj.flags2 = $1|MF2_DONTDRAW
	end
end

-- Sets the boss's invlunerability status
local function Facc_SetInvincible(mobj, tg)
	if not isMobjValid(mobj) then return end

	if (mobj.facc) then mobj.facc.invincible = tg end
end

-- Sets ability to be locked onto
local function Facc_SetLockon(mobj, tg)
	if not isMobjValid(mobj) then return end
	if tg then mobj.flags2 = $1 &~ MF2_INVERTAIMABLE else mobj.flags2 = $1|MF2_INVERTAIMABLE end
end

EventSH.new("facciolo_ph2_setinvuln", {
function(c,e)
	c.maxtime = $1-1

	-- Flash a warning object
	if c.maxtime % 5 == 0 then
		S_StartSound(nil, sfx_s3k5c)
		S_StartSound(nil, sfx_s3k5c)
		local inv = P_SpawnMobj(c.boss.x, c.boss.y, c.boss.z, MT_THOK)
		-- (Mobj settings)
		inv.scale = 2*FU
		inv.destscale = $1 + 5*FU
		inv.scalespeed = 2*FU
		inv.tics = 6
		inv.fuse = 6
		-- (Render settings)
		inv.frame = 0
		inv.spriteyoffset = (c.has_invinc) and -16*FU or 8*FU
		inv.renderflags = RF_FULLBRIGHT
		-- Set sprite by context
		inv.sprite = (c.has_invinc) and SPR_BBEM or SPR_AUR_
		inv.color = (c.has_invinc) and SKINCOLOR_CRIMSON or SKINCOLOR_MINT
		inv._facc2 = true -- Set as boss object
	end
	EventSH.waitUntil(e, c.maxtime == 0)
end,
function(c,e)
	-- Change status
	if (c.has_invinc) then
		-- Set invulnerability
		Facc_SetInvincible(c.boss, true)
		Facc_SetLockon(c.boss, c.has_lockon or false)
	else
		-- Revert
		Facc_SetInvincible(c.boss, false)
		Facc_SetLockon(c.boss, c.has_lockon or true)
	end
	S_StartSound(nil, sfx_facret)
end,})

-- Sets a timed boss invulnerability switch
local function Facc_SetInvulnerability(bossmobj, isinvinicible, haslockon, maxsetuptime)
	EventSH.start("facciolo_ph2_setinvuln", {
		boss = bossmobj,
		has_invinc = isinvinicible,
		has_lockon = haslockon,
		maxtime = maxsetuptime or 15,
	})
end

-- Useful for resetting any movement axis instead of all at once (unless needed)
local function Facc_ResetMomentum(mobj, momaxis)

	if not isMobjValid(mobj) then return end

	mobj.momx = 0
	mobj.momy = 0
	mobj.momz = 0
	-- for _,ma in pairs(momaxis) do
	-- 	print(ma)
	-- 	mobj["mom"..tostring(ma)] = 0
	-- end
end


local function Facc_CreateWarning(spawnx, spawny, spawnz, decaytime, extramobj)

	-- c.skypos = EvActionSH.coordinategetoffset(c, "msboss", rx, ry, 0)
	local warningmobj = P_SpawnMobj(spawnx, spawny, spawnz, MT_PUSH)

	warningmobj.sprite = SPR_MNRR
	warningmobj.frame = R_Char2Frame("B")
	warningmobj.renderflags = $1 | RF_FULLBRIGHT
	warningmobj.fuse = decaytime or 10*TICRATE

	extramobj = notnil($1, {})

	if (extramobj["mobj"]) then
		local exm = P_SpawnMobjFromMobj(warningmobj, 0, 0, 0, extramobj.mobj)
		exm.scale = (extramobj.scale or FU) + exm.radius
		exm.frame = $1 | FF_TRANS50
		exm.renderflags = warningmobj.renderflags | (extramobj.renderflags or 0)
		exm.fuse = warningmobj.fuse
	end

	return warningmobj
end

-- Creates a warning pattern in a line
local function Facc_CreateWarningLine(spawnlocation, spawnangle, spawnscale, dist, limit, decaytime)
	if not spawnlocation and spawnlocation.valid then return end

	for i = 1, dist, limit do

		local fx = P_ReturnThrustX(spawnlocation, spawnangle, i*FU)
		local fy = P_ReturnThrustY(spawnlocation, spawnangle, i*FU)

		local warn = Facc_CreateWarning(spawnlocation.x + fx, spawnlocation.y + fy, spawnlocation.z, decaytime)
		warn.scale = spawnscale or FRACUNIT
	end
end

-- Creates a warning pattern in a circle
local function Facc_CreateWarningCircle(spawnlocation, spawnradius, limit, spawnscale, decaytime)
	if not spawnlocation and spawnlocation.valid then return end

	for i = 1, 360, limit do

		local fx = P_ReturnThrustX(nil, FixedAngle(i*FU), spawnradius)
		local fy = P_ReturnThrustY(nil, FixedAngle(i*FU), spawnradius)

		local warn = Facc_CreateWarning(
			spawnlocation.x + fx,
			spawnlocation.y + fy,
			spawnlocation.z,
			decaytime)
		warn.scale = spawnscale or FRACUNIT

	end
end
Silverhorn.CreateWarning = Facc_CreateWarning

-- Throws an object at a target that also accounts for the height of the target
local function P_TossObject(spawner, target, firespeed, objecttype, scale, args)

	if not isMobjValid(spawner) then return end

	-- offset z (height)
	local offz = (args and args.hz ~= 0) and args.hz or 0

	-- offset individual object angle
	local offa = (args and args.angle ~= 0) and args.angle or 0

	-- offset rotation angle and distance
	local offrang = (args and args.rangle ~= 0) and args.rangle or 0
	local offdst = (args and args.disto ~= 0) and args.disto or 0

	local zmove = (args and args.zmove) and args.zmove or false

	-- use target (or directly in front if none)
	if not target then
		target = {
			x=spawner.x + FixedMul(P_ReturnThrustX(spawner.angle + offrang, spawner.radius + 96*FRACUNIT), spawner.scale),
			y=spawner.y + FixedMul(P_ReturnThrustY(spawner.angle + offrang, spawner.radius + 96*FRACUNIT), spawner.scale),
			z=spawner.z + FixedMul(offz, spawner.scale),
			valid=true,
		}
	end

	-- adjust scale and tossed mobj spawn
	local ssx = spawner.x + FixedMul(P_ReturnThrustX(spawner.angle + offrang, offdst), spawner.scale)
	local ssy = spawner.y + FixedMul(P_ReturnThrustY(spawner.angle + offrang, offdst), spawner.scale)
	local ssz = spawner.z + FixedMul(offz, spawner.scale)

	local tossed = P_SpawnMobj(
		ssx,
		ssy,
		ssz,
	objecttype)

	-- set scale
	tossed.scale = scale or FU

	tossed.fuse = (args and args.fuse) or 6*TICRATE

	-- Adjust speed to scale
	local speed = FixedMul(firespeed, spawner.scale)

	-- determines if the object should track z height or act like a normal shot
	if (zmove) then

		-- Set fired mobj momentum in the direction of the target
		local a = R_PointToAngle2(ssx, ssy, target.x, target.y)

		tossed.angle = a + offa -- offset angle
		tossed.momx = FixedMul(speed, cos(a))
		tossed.momy = FixedMul(speed, sin(a))

		-- Set fired z momentum in the direction of the target z position
		local dist = P_AproxDistance(target.x - ssx, target.y - ssy) / speed + 1
		tossed.momz = (target.z-ssz) / dist

		-- tossed.flags = $|MF_GRENADEBOUNCE|MF_BOUNCES
	else
		local a = (target) and R_PointToAngle2(ssx, ssy, target.x, target.y) or R_PointToAngle2(tossed.x, tossed.y, target.x, target.y)

		tossed.angle = a + offa
		P_InstaThrust(tossed, tossed.angle, speed)
	end
	return tossed
end

-- transform particle
EventSH.new("facciolo_transformparticle", {
function(vc,e)
	vc.particle_store = {}
end,
function(vc,e)
	local rx = RANDOMCHOICE({-256, -128, 128, 256}, true)*FU
	local ry = RANDOMCHOICE({-256, -128, 128, 256}, true)*FU
	local rz = RANDOMCHOICE({-256, -128, 128, 256}, true)*FU
	local prtc = P_SpawnMobj(vc.boss.x+rx, vc.boss.y+ry, vc.boss.z+rz, MT_PUSH)
	prtc.color = RANDOMCHOICE(ColorShift_Boss_Transform_Particle, true)
	prtc.sprite = SPR_FTHK
	prtc.frame = $|TR_TRANS10
	prtc.blendmode = AST_ADD
	prtc.scale = 0
	prtc.destscale = FU*5
	prtc.scalespeed = FU/16
	prtc.flags = $1|(MF_NOCLIP|MF_NOCLIPHEIGHT)

	prtc.angle = R_PointToAngle2(prtc.x, prtc.y, vc.boss.x, vc.boss.y)
	P_InstaThrustZ(prtc, vc.boss, 2*FU)
	prtc.tics = 100
	prtc._facc2 = true -- Set as boss object

	-- Insert particle
	table.insert(vc.particle_store, prtc)

	EventSH.wait(e, (10*TICRATE)+1)
end,
function(vc,e)
	for _, mobj in ipairs(vc.particle_store) do
		if (mobj and mobj.valid and mobj.type == MT_PUSH) then
			P_SetOrigin(mobj, mobj.x, mobj.y-ARENA_1_TP_LENGTH, mobj.z) -- 2.2.11 Fix
		end
	end
end,
function(vc,e)
	EventSH.wait(e, 1)
end,
function(vc,e)
	-- =============================
	-- Move the entire scene
	-- Explode particles outward
	-- =============================
	for _, mobj in ipairs(vc.particle_store) do
		if not (mobj and mobj.valid) then continue end
		if (mobj.type == MT_PUSH) then
			P_InstaThrust(mobj, -mobj.angle, 128*FU)
			mobj.destscale = 1
			mobj.scalespeed = FU/4
			mobj.tics = 95
		end
	end
	vc.particle_store = {}
end,
})

-- transform rumble
EventSH.new("facciolo_transformrumble", {
function(vc,e)
	vc.cut_timer = 0
end,
function(vc,e)
	-- special case to make the boss disappear sometime after rumbling for a bit
	if vc.cut_timer > 4*TICRATE then
		Facc_SetVisibility(vc.boss, false)
	end
	-- Increase timer and rumble more
	vc.cut_timer = $1+1
	if (leveltime % (3*TICRATE) == 3) then S_StartSound(nil, sfx_rumble) end
	P_StartQuake(vc.cut_timer*FU/20, 4)
	EventSH.wait(e, 10*TICRATE)
end,
})

-- Particle charging effect similar to metal sonic
EventSH.new("facciolo_chargeparticle", {
function(c,e,caller)
	-- Default colors if none
	if not c.chargecolors then c.chargecolors = ColorShift_Boss_Default end
	-- Randomize position
	local rx = RANDOMCHOICE({-512, -256, 256, 512}, true)*FU
	local ry = RANDOMCHOICE({-512, -256, 256, 512}, true)*FU
	local rz = RANDOMCHOICE({-512, -256, 256, 512}, true)*FU
	local prt = P_SpawnMobj(caller.x+rx, caller.y+ry, (caller.z+caller.height/2)+rz, MT_THOK)
	prt.color = RANDOMCHOICE(c.chargecolors, true)
	prt.sprite = c.prtsprite or SPR_FTHK --SPR_THOK
	prt.frame = R_Char2Frame("A")|TR_TRANS10
	prt.blendmode = AST_ADD
	prt.renderflags = $1|RF_FULLBRIGHT
	prt.scale = 0
	prt.destscale = FU*4
	prt.scalespeed = FU/8
	prt.angle = R_PointToAngle2(prt.x, prt.y, caller.x, caller.y)
	P_InstaThrustZ(prt, {x=caller.x, y=caller.y, z=caller.z+caller.height/2}, 12*FU)
	prt.tics = 35
	prt._facc2 = true -- Set as boss object

	EventSH.waitUntil(e, not e) -- loop forever until stopped
end,
})

-- Function to set a custom charge effect
local function Facc_ChargingUp(isCharge, mobj, colors, sprite)
	if isCharge then
		EventSH.start("facciolo_chargeparticle", {chargecolors=colors or nil, prtsprite=sprite}, mobj)
	else
		EventSH.destroy("facciolo_chargeparticle")
	end
end

-- Multi mover test
-- =================
-- TODO: unused?
EventSH.new("facciolo_moving", {
function(c,e)
	if not c.mobj and c.mobj.valid then EventSH.stop(e) end
	EventSH.setloop(e, "repeat")
	MobjMoverSH.moveto("faccmove", c.mobj, {x=c.positions[c.posnum].x,y=c.positions[c.posnum].y,z=c.positions[c.posnum].z}, c.args or {})
	c.posnum = $1+1
end,
function(c,e)
	MobjMoverSH.waitmovedone(e, "faccmove")
end,
function(c,e)
	if (c.posnum <= #c.positions) then
		EventSH.gotoloop(e, "repeat")
	else
		EventSH.signal("Facc_Move")
	end
end})

local function Facc_Move(mo, positions, args)
	EventSH.start("facciolo_moving", {mobj=mo, posnum=1, positions=positions or {x=mo.x,y=mo.y,z=mo.z}, args=args})
end

-- Focus attachment
-- ==================================================
EventSH.new("_facc_attach_focus", {
function(c,e)
	-- if not c.mobj and mobj.valid then return end
	if c.destmobj and c.destmobj.valid then
		P_MoveOrigin(c.mobj, c.destmobj.x, c.destmobj.y, c.destmobj.z) -- 2.2.11 Fix
		-- P_TeleportMove(c.mobj, c.destmobj.x, c.destmobj.y, c.destmobj.z)
	end

	EventSH.waitUntil(e, not e) -- loop forever until stopped
end})

local function Facc_DetachFocus()
	EventSH.destroy("_facc_attach_focus")
end

local function Facc_AttachFocus(source, dest)
	if not source and source.valid then return end
	Facc_DetachFocus()
	EventSH.start("_facc_attach_focus", {mobj=source, destmobj=dest})
end


-- Focus mover
-- ==================================================
EventSH.new("_facc_move_focus", {
function(c,e)
	MobjMoverSH.moveto("faccmove_focus", c.fmobj, {x=c.newpos.x,y=c.newpos.y,z=c.newpos.z}, {speed=c.speed, ease=c.easingtype or "inoutsine"})
end,
function(c,e)
	MobjMoverSH.waitmovedone(e, "faccmove_focus")
end,
function(c,e)
	EventSH.signal("Facc_MoveFocusPoint")
end})

local function Facc_MoveFocusPoint(source, x, y, z, movespeed, easetype) --, arc)
	if not source and source.valid then return end
	EventSH.start("_facc_move_focus", {fmobj=source, newpos={x=notnil(x,source.x),y=notnil(y,source.y),z=notnil(z,source.z)}, speed=movespeed or 8*FU, easingtype=easetype or "inoutsine", arc=arc})
end

local function Facc_CreateFocusPoint(source, duration)
	if not source and source.valid then return end

	local mo = P_SpawnMobj(source.x, source.y, source.z, MT_THOK)
	mo.frame = $1|TR_TRANS50
	mo.tics = duration or 2*TICRATE

	return mo
end

-- Previous teleport added into its own function
-- ==================================================
EventSH.new("_facc_move_teleport", {
function(c,e)
	-- has a destination, skip
	if c.newx or c.newy or c.newz then
		c.dest_x = notnil(c.newx, c.warpermobj.x)
		c.dest_y = notnil(c.newy, c.warpermobj.y) -- (_target.x and not nil) and _target.x or _frontx,
		c.dest_z = notnil(c.newz, c.warpermobj.z)
		return
	end

	-- Set new random coordinates in the general arena range, and wait until it's not OOB
	c.dest_x = P_RandomRange(ARENA_2_RECT.x1, ARENA_2_RECT.x2)*FU
	c.dest_y = P_RandomRange(ARENA_2_RECT.y1, ARENA_2_RECT.y2)*FU
	c.dest_z = c.warpermobj.floorz

	EventSH.waitUntil(e, Facc_IsInBounds(ARENA_2_CENTER, {x=c.dest_x,y=c.dest_y}, ARENA_2_RAD_INNER, ARENA_2_RAD_OUTER))
end,
function(c,e)
	Facc_SetVisibility(c.warpermobj, false)

	-- Set invulnerability
	Facc_SetInvincible(c.warpermobj, true)
	Facc_SetLockon(c.warpermobj, false)

	S_StartSound(nil, sfx_facwrp)
	S_StartSoundAtVolume(nil, sfx_s3k8a, 32)
end,
function(c,e)
	EventSH.wait(e, 25)
end,
function(c,e)
	if (c.usemove) then
		-- use moving
		local distspeed = R_PointToDist2(c.warpermobj.x, c.warpermobj.y, c.dest_x, c.dest_y)

		-- SFX
		S_StartSound(nil, sfx_facmov)

		MobjMoverSH.moveto("faccmove", c.warpermobj, {x=c.dest_x,y=c.dest_y,z=c.dest_z}, {speed=FixedDiv(distspeed, 25*FU), ease="inoutsine"})
	else
		-- use warping
		-- 2.2.11 Fix
		P_SetOrigin(c.warpermobj, c.dest_x, c.dest_y, c.dest_z+2*FU) -- set new position above floor
		P_SetOrigin(c.warpermobj, c.dest_x, c.dest_y, c.dest_z) -- Snap to the floor

		Facc_SetVisibility(c.warpermobj, true)

		-- Revert invulnerability (TTP)
		Facc_SetInvincible(c.warpermobj, false)
		Facc_SetLockon(c.warpermobj, true)
	end
end,
function(c,e)
	if (c.usemove) then
		MobjMoverSH.waitmovedone(e, "faccmove")
	else
		EventSH.wait(e, 1*TICRATE)
	end
	--Facc_SetCharFrame(c.warpermobj, c.exitframe or "B")

	Silverhorn.SetFaccAnimation(c.warpermobj, "idle")
end,
function(c,e)
	if (c.usemove) then
		Facc_SetVisibility(c.warpermobj, true)

		-- Revert invulnerability (MTP)
		Facc_SetInvincible(c.warpermobj, false)
		Facc_SetLockon(c.warpermobj, true)
	end

	EventSH.signal("warp_finished" .. (c.identifier or ""))
end})

local function Facc_Teleport(mobj, usemoving, nx, ny, nz, eframe, iden)
	EventSH.start("_facc_move_teleport", {identifier=iden, warpermobj=mobj, usemove=usemoving, exitframe=eframe, newx=nx, newy=ny, newz=nz})
end




-- Attack Shortcuts
-- ==================================================

-- Creates portals
local function Facc_MakePortal(source, offx, offy, offz, startscale, dscale, sproffy)
	if not source and source.valid then return end

	local portal = P_SpawnMobj(source.x+notnil(offx, 0), source.y+notnil(offy, 0), source.z+notnil(offz, 0), MT_FACCIOLO2_SPACEPORTAL)

	-- portal.scale = 5*FU
	portal.colorized = true
	portal.color = SKINCOLOR_PLUM --SKINCOLOR_KETCHUP
	portal.scale = notnil(startscale, 0)
	portal.destscale = notnil(dscale, 5*FU)
	portal.angle = R_PointToAngle2(portal.x, portal.y, source.x, source.y)+ANGLE_90
	portal.renderflags = RF_PAPERSPRITE
	portal.spriteyoffset = sproffy or 0
	portal._facc2 = true -- Set as boss object

	return portal
end


-- Shoots a horizontal or vertical sword beam (hover/dash)
local function Facc_FireOmniShot(mo, target, btype)

	local tossmo = (notnil(btype, 0) >= 1) and MT_FACCIOLO2_SWORDBEAM_V or MT_FACCIOLO2_SWORDBEAM_V

	if (leveltime % 8 == 0) then
		local swordbeam_hv = P_TossObject(mo, target, 30*FU, tossmo, 4*FU, {zmove=true})
		swordbeam_hv._facc2 = true -- Set as boss object
		P_StartQuake(8*FU, 15)

		-- SFX
		S_StartSound(nil, sfx_facswd)
		S_StartSoundAtVolume(nil, sfx_facsls, 60)

		--Animation
		A_FaceTarget(mo)
		if mo.facslash then
			--slash
			Silverhorn.SetFaccAnimation(mo, "slash")
			mo.facslash = false
		else
			--flip
			Silverhorn.SetFaccAnimation(mo, "slash_flip")
			mo.facslash = true
			swordbeam_hv.mirrored = true
		end
	end
end

-- Returns coordinates in a cirle around a centerpoint's radius
local function Facc_MakeRadiusPoints(centerpoint, distance, startangle, anglerange, maxangle)
	local t = {}
	for i=0, maxangle or 360, anglerange or 45 do
		table.insert(t, {
			x=centerpoint.x+P_ReturnThrustX((startangle or 0)+FixedAngle(i*FU), distance),
			y=centerpoint.y+P_ReturnThrustY((startangle or 0)+FixedAngle(i*FU), distance),
			z=centerpoint.z,
		})
	end
	return t
end

-- Just fire a regular fireball
local function Facc_P1Fireball(mo, target, speed, scale)

	local fireball = P_TossObject(mo, target, speed, MT_FACCIOLO_FIREBALL, scale, {disto=64*FU, hz=64*FU})
		fireball.facciolo = mo
	return fireball
end

-- Fire ph-1 Lasers in pattern movement
EventSH.new("atk_laser", {
function(c,e)
	-- Attack Setup
	c.unitsmoved = 0
end,
function(c,e)
	EventSH.setloop(e, "laser_repeat")
end,
function(c,e)
	c.unitsmoved = $1 + (c.unitspace or 64*FU)

	-- you can make slices from the radius!
	for i=0, (c.maxangle or 0), (c.anglestep >= 16 and c.anglestep or 16) do
		if i >= 360 then break end
		local laser = P_SpawnMobj(
			c.boss.x+P_ReturnThrustX(c.boss.angle+FixedAngle(i*FU), c.unitsmoved),
			c.boss.y+P_ReturnThrustY(c.boss.angle+FixedAngle(i*FU), c.unitsmoved),
			c.boss.ceilingz,
			MT_FACCIOLO_LASER_SPAWN)

		laser.facciolo = c.boss -- mandatory ph1 variable
		laser.fuse = 6*TICRATE -- mandatory ph1 variable
		laser.laserloudness = 64
		laser.laserph2 = true
		laser.color = SKINCOLOR_AQUA
		laser._facc2 = true -- Set as boss object
		-- laser.scale = 3*FU
	end
	P_StartQuake(5*FU, 5)
	EventSH.wait(e, notnil(c.waittime, 0), true)
end,
function(c,e)
	if (c.unitsmoved >= ARENA_2_RAD+80*FU) then return end
	EventSH.gotoloop(e, "laser_repeat")
end,
function(c,e)
	-- print("end")
end,
})

-- Spawns a phase 1 laser in a line + group in a grid-like formation
local function Facc_GridLaser(mo, spaces, step, maxang, waittime)
	EventSH.start("atk_laser", {boss=mo, unitspace=spaces, anglestep=step, maxangle=maxang, waittime=waittime})
end


-- Starts a visual countdown for the final move in the move pool
local function Facc_StartCrashCountdown(container)
	EventSH.start("arena_crash_countdown", container)
end

-- Tells the visual countdown to start, advance or reset itself when it hits zero
local function Facc_AdvanceCrashCountdown()
	EventSH.signal("trigger_crash_countdown")
end




-- Callable Boundary Checker
-- ===========================
-- Checks if facciolo is in the arena, and if not, places him back in a location
EventSH.new("IS_FACCIOLO_IN_BOUNDS?", {
function(c,e)
	-- print("IN BOUNDS")
	EventSH.waitUntil(e, not Facc_IsInBounds(ARENA_2_CENTER, c.boss, ARENA_2_RAD_INNER + (c.off_radiusin or 0), ARENA_2_RAD_OUTER + (c.off_radiusout or 100*FU)))
end,
function(c,e)
	-- Left defined bounds signal
	EventSH.signal("Facc_BoundCheckDone")
end,
function(c,e)
	if (c.boss and c.boss.valid) then
		if (c.disappearexit) then
			Facc_SetVisibility(c.boss, false)
		end
		if (c.manualwarp) then
			if c.usemove then
				local distspeed = R_PointToDist2(c.boss.x, c.boss.y, c.newpos.x, c.newpos.y)
				MobjMoverSH.moveto("faccmove", c.boss, {x=c.newpos.x,y=c.newpos.y,z=c.newpos.z}, {speed=FixedDiv(distspeed, 20*FU), ease="inoutsine"})
			else
				-- Teleport if can do it safely
				P_SetOrigin(c.boss, c.newpos.x, c.newpos.y, c.newpos.z) -- 2.2.11 Fix
			end
		end
	end
end,
function(c,e)
	-- Returned inside bounds signal
	EventSH.signal("Facc_BoundWarpDone")
end})

-- Out of bounds check, that re-locates the mobj when it leaves a set boundary zone.
-- Extras: (usemover): Uses MobjMoverSH instead. | (disappear): Becomes invisible when re-located. | (skipwarp): Skips over the re-location and let's the user perform it manually.
local function Facc_BoundCheck(mo, relocatex, relocatey, relocatez, extra)
	extra = notnil($, {})
	EventSH.start("IS_FACCIOLO_IN_BOUNDS?", {boss=mo, usemove=extra.usemover, disappearexit=extra.disappear, manual=extra.skipwarp, off_radiusin=extra.radin, off_radiusout=extra.radout, newpos={x=notnil(relocatex,0),y=notnil(relocatey,0),z=notnil(relocatez,0)} })
end

-- ===============================================
EventSH.new("arena_check", {
function(c,e)
	EventSH.setloop(e, "bgm_repeat")
end,
function(c,e)
	if leveltime & 512 == 0 then
		P_LinedefExecute(8010) -- Change Skybox
		local music = Silverhorn.UltimateMode() and "PS2ULT" or "PHASE2"
		EvActionSH.SetCurrentMusic(true, music, true)
	end
	EventSH.wait(e, 1, true)
end,
function(c,e)
	EventSH.gotoloop(e, "bgm_repeat")
end})

local function Facc_AreaCheck(checker)
	EventSH.start("arena_check", checker)
end
-- ===============================================


-- Function to set the player viewtarget
-- ===============================================
local totalTransitionTime = 3*TICRATE/2

EventSH.new("object_focus", {
function(c,e)
	c.transitionTime = 0
	c.transitionAngles = {}

	for player in players.iterate do
		local mo = player.mo
		if not mo then
			continue
		end

		c.transitionAngles[#player] = mo.angle
	end
end,
function(c,e,caller)
	if not isMobjValid(caller) then return end

	local mobj = caller

	if c.transitionTime < totalTransitionTime then
		c.transitionTime = $1+1
	end

	-- Look at the boss
	for player in players.iterate do
		local pNum = #player

		if not player.mo
		or c.transitionAngles[pNum] == nil then
			Silverhorn.UndoForceEnableAnalogMode(player)
			continue
		end

		-- Only trigger if the player is in the arena bounds
		if Facc_IsInBounds({x=ARENA_1_CENTER.x, y=ARENA_1_CENTER.y, z=ARENA_1_CENTER.z}, player.mo, 0*FU, 2080*FU)
		or Facc_IsInBounds({x=ARENA_2_CENTER.x, y=ARENA_2_CENTER.y, z=ARENA_2_CENTER.z}, player.mo, 0*FU, ARENA_2_RAD+600*FU) then

			local t = c.transitionTime*FRACUNIT/totalTransitionTime
			local angle = R_PointToAngle2(player.mo.x, player.mo.y, mobj.x, mobj.y)
			local cam = player == secondarydisplayplayer and camera2
				or player == displayplayer and camera

			c.transitionAngles[pNum] = ease.inoutsine(t, 0, angle - $) + $
			player.mo.angle = c.transitionAngles[pNum]
			Silverhorn.ForceEnableAnalogMode(player)

			if not cam then continue end

			local aim = R_PointToAngle2(0, 0, FixedHypot(mobj.x - cam.x, mobj.y - cam.y), mobj.z - cam.z)
			angle = c.transitionAngles[pNum]

			local offdist = notnil(c.distoffset, 220)

			-- P_TeleportCameraMove(cam, cam.x+(player.mo.x-offdist*cos(angle+FixedAngle(0*FRACUNIT))-cam.x)/4, cam.y+(player.mo.y-offdist*sin(angle+FixedAngle(0*FRACUNIT))-cam.y)/4, cam.z)
			P_TeleportCameraMove(cam, player.mo.x-offdist*cos(angle+FixedAngle(0*FRACUNIT)), player.mo.y-offdist*sin(angle+FixedAngle(0*FRACUNIT)), cam.z)
			cam.angle = angle
			cam.aiming = ease.inoutsine(t, 0, aim - $) + $
			cam.height = (notnil(c.height)) and (ease.inoutsine(t, 0, c.height - $) + $) or ($1)
		else
			Silverhorn.UndoForceEnableAnalogMode(player)
		end
	end
	EventSH.waitUntil(e, not e)
end,
})

local function Facc_ViewTargetDistance(newdst)
	EventSH.searchtable(function(_, searchev)
		if searchev.name == "object_focus" then searchev.vars.distoffset = newdst end
	end)
end
local function Facc_ViewTargetHeight(newhigh)
	EventSH.searchtable(function(_, searchev)
		if searchev.name == "object_focus" then searchev.vars.height = newhigh end
	end)
end

local function Facc_ViewTarget(isTargeting, mobj, distance)
	if isTargeting then
		EventSH.destroy("object_focus")
		EventSH.start("object_focus", {distoffset=distance}, mobj)
	else
		EventSH.destroy("object_focus")
	end
end











EventSH.new("facciolo_phase2", {
-- ===========================
-- 	S-0 Intermission Setup
-- ===========================
function(c,e)

	c.boss.state = S_FACCIOLO2_INTO
	MindscapeSessionFlags = $ | MS_BEATPHASEONE

	Facc_ResetMomentum(c.boss)

	c.boss.frame = R_Char2Frame("I")
end,
function(vc,e)
	-- Turn weather off since it affects stuff we need to do
	P_SwitchWeather(PRECIP_NONE)
end,
function(vc,e)
	EventSH.wait(e, 2)
end,
function(vc,e)
	-- Stops music
	for player in players.iterate do
		S_FadeOutStopMusic(5000, player)
	end
	-- Kill all lights
	P_FadeLight(65535, 150, 10*TICRATE, true, true)
	P_FadeLight(Arena_Sky_TagID, 216, 10*TICRATE, true, true)
	P_FadeLight(Arena_Sky_Light_TagID, 216, 10*TICRATE, true, true)
	P_FadeLight(Arena_TagID, 240, 10*TICRATE, true, true)
	P_FadeLight(Arena_Outer_TagID, 240, 10*TICRATE, true, true)
end,
function(vc,e)
	EventSH.wait(e, 2)
end,
function(vc,e)
	EventSH.wait(e, 2*TICRATE)
end,
-- ===========================
--  Transformation Scene
-- ===========================
function(vc,e)
	startmindtext(1001)
	EventSH.start("facciolo_transformparticle", vc)
	EventSH.start("facciolo_transformrumble", vc)
	Facc_ViewTarget(true, vc.boss)
end,
function(vc,e)
	EventSH.wait(e, 10*TICRATE)
end,
function(vc,e)
	-- Restore old post-pain static sprite frame behavior
	vc.boss.state = S_FACCIOLO2_IDLE
	vc.boss.facc.ph2_introover = true

	EvActionSH.doforall(function(play)
		P_FlashPal(play, 1, 2)
		EvActionSH.forceplayerreborn(play) -- Re-alive dead players
	end)

	P_LinedefExecute(8010) -- Change Skybox
	P_LinedefExecute(14400) -- Set new multiplayer teleporter

	-- SFX
	S_StartSound(nil, sfx_bkpoof)
	P_StartQuake(16*FU, 15)

end,
function(vc,e)
	-- =============================
	-- Move to new area if in circle
	-- =============================
	EvActionSH.doforall(function(player)
		if Facc_IsInBounds({x=ARENA_1_CENTER.x, y=ARENA_1_CENTER.y, z=ARENA_1_CENTER.z}, player.mo, 0*FU, ARENA_1_RADIUS_TP) then
			P_SetOrigin(player.mo, player.mo.x, player.mo.y-ARENA_1_TP_LENGTH, ARENA_2_FLOOR) -- 2.2.11 Fix
			-- P_TeleportCameraMove(camera, camera.x, camera.y-ARENA_1_TP_LENGTH, camera.z)
		end
	end)
	-- =============================
	-- Move the entire scene
	-- Warp boss
	-- =============================
	P_SetOrigin(vc.boss, vc.boss.x, vc.boss.y-ARENA_1_TP_LENGTH, vc.boss.z) -- 2.2.11 Fix
end,
function(vc,e)
	-- Give this process 5 frames to work with
	EventSH.wait(e, 5)
end,
function(vc,e)
	-- Switch weather back on and end effects
	P_SwitchWeather(PRECIP_STORM_NORAIN)
	-- P_SwitchWeather(PRECIP_STORM)
	EventSH.destroy("facciolo_transformparticle")
	EventSH.destroy("facciolo_transformrumble")
end,
function(vc,e)
	EventSH.start("facciolo_ph2_setup", vc)
end,
})


-- ===========================
--  S-1 - Setup
-- ===========================
EventSH.new("facciolo_ph2_setup", {
function(c,e)
	-- Map Anchors
	EvActionSH.coordinateanchor(c, "msboss", ARENA_2_CENTER.x, ARENA_2_CENTER.y, ARENA_2_CENTER.z)
	c.anchor_arena_center = EvActionSH.coordinategetoffset(c, "msboss", 0, 0, 0)

	EvActionSH.coordinateanchor(c, "msboss_void", ARENA_2_VOID.x, ARENA_2_VOID.y, ARENA_2_VOID.z)
	c.anchor_arena_void = EvActionSH.coordinategetoffset(c, "msboss_void", 0, 0, 0)


	-- Setup focus object (boss is still a good option)
	c.focuspoint = Facc_CreateFocusPoint(c.boss, FRACUNIT*TICRATE)
	c.focuspoint.state = S_INVISIBLE
	Facc_ViewTarget(true, c.focuspoint)

	-- Resets the boss's active and damage status
	Facc_SetInvincible(c.boss, false)
	Facc_SetLockon(c.boss, true)
	Facc_SetVisibility(c.boss, true)
	c.boss.facc.active = 2
	c.boss.flags2 = $1 &~ MF2_FRET

	-- Spawn nulltarget
	if (c.boss and c.boss.facc) then
		c.boss.facc.nulltarget = P_SpawnMobj(c.boss.x+64*FU, c.boss.y+64*FU, c.boss.floorz, MT_THOK)
		c.boss.facc.nulltarget.state = S_INVISIBLE
	end

	c.playermultiplier = 0

	-- Set move counters
	c.nextmove = 0
	c.attackset = 1
	c.final_stand = 0 -- Tracks midpoint
	c.crashenabler = false
	c.crashadvance_meteor = false
end,
function(c,e)
	-- Set animation
	Silverhorn.SetFaccAnimation(c.boss, "idle")
	-- Dialogue
	startmindtext(1002)
	-- Set BGM
	local music = Silverhorn.UltimateMode() and "PS2ULT" or "PHASE2"
	EvActionSH.SetCurrentMusic(true, music, true)
	EvActionSH.SetMapMusicFlags("reload")
	-- Sets certain things when the player is in the arena
	Facc_AreaCheck(c)
	-- Start phase 2 pattern
	EventSH.start("facciolo_ph2_1", c)
end})


EventSH.new("atk_moonreaver_slam", {
function(c,e)
	Facc_VerifyTarget(c.boss)

	--slam1
	Silverhorn.SetFaccAnimation(c.boss, "slam1")
	P_StartQuake(20*FU, 15)

	-- SFX
	S_StartSound(nil, sfx_s3kb6)
	MobjMoverSH.moveto("faccmove", c.boss, {x=c.boss.target.x,y=c.boss.target.y,z=c.boss.target.floorz}, {speed=64*FU, varc=320*FU})
	Facc_AttachFocus(c.focuspoint, c.boss)
end,
function(c,e)
	MobjMoverSH.waitmovedone(e, "faccmove")
end,
function(c,e)
	c.boss.momz = 0
	--slam2
	Silverhorn.SetFaccAnimation(c.boss, "slam2")

	-- SFX
	S_StartSound(nil, sfx_s3k59)
	P_StartQuake(35*FU, 1*TICRATE)
	-- TODO: I don't think it needs a shockwave but shrug
	InazumaProjectileStream(c.boss, SKINCOLOR_MAGENTA)
end,
function(c,e)
	EventSH.signal("Facc_SlamAttack")
end})

local function Facc_SlamAttack(container)
	EventSH.start("atk_moonreaver_slam", container)
end

-- ===========================
--  A-0 - Moonreaver Slam
-- ===========================
EventSH.new("facciolo_ph2_1", {
function(c,e)
	-- Reset target
	c.boss.target = nil

	-- SFX
	S_StartSound(nil, sfx_s3kc0s)
end,
function(c,e)
	-- Wait until a target is available
	c.boss.target = Facc_GetNearbyTarget({x=ARENA_2_CENTER.x,y=ARENA_2_CENTER.y}, ARENA_2_RAD+600*FU)
	EventSH.waitUntil(e, c.boss.target)
	A_FaceTarget(c.boss)
end,
-- New barrier introduction
-- ===================================================
function(c,e)
	EventSH.wait(e, 1*TICRATE)
end,
function(c,e)
	Facc_SetInvulnerability(c.boss, true)
end,
function(c,e)
	EventSH.wait(e, 1*TICRATE)
end,
-- ===================================================
function(c,e)
	Facc_AttachFocus(c.focuspoint, c.boss)
	Facc_SlamAttack(c)
end,
function(c,e)
	EventSH.waitSignal(e, "Facc_SlamAttack")
end,
function(c,e)
	EventSH.wait(e, 1*TICRATE)
end,
function(c,e)
	-- End intermission (and start main loop)
	c.intermission = false

	Facc_SetInvulnerability(c.boss, false, false)
	-- Facc_SetLockon(c.boss, false)

	-- Display meter
	HitDisplaySH.remove("Facciolo")
	c.playermultiplier = numplayers_multiplier(16)

	c.boss.facc.health = MAX_BOSS_HP
	if Silverhorn.UltimateMode() then
		c.boss.facc.health = $*3 + c.playermultiplier
	else
		c.boss.facc.health = $ + c.playermultiplier
	end

	c.boss.facc.health_mid_ref = c.boss.facc.health/2

	local bossname = (Silverhorn.UltimateMode() and "Chaos Moonreaver" or "Moonreaver Facciolo")
	HitDisplaySH.shownew(c.boss.facc, HitDisplaySH.facciolo(bossname, c.boss.facc.health, c.boss))

	EventSH.start("facciolo_ph2_teleport", c)
end,})


-- ===========================
--  A-1 -  Moonreaver (Blade)
-- ===========================
EventSH.new("facciolo_ph2_teleport", {
function(c,e)
	c.warpcount = 0

	-- TODO: delete ph2
	-- swap on half
	-- if c.boss and c.boss.facc and c.boss.facc.health < (c.boss.facc.health_mid_ref) then
	-- 	if c.attackset < 2 then
	-- 		c.attackset = 2
	-- 	else
	-- 		c.attackset = 3
	-- 		c.halfcounter = 1
	-- 	end
	-- end

	-- c.nextmove = (c.nextmove >= #Facc_Move_Patterns[c.attackset]) and 1 or $1+1
	Facc_AttachFocus(c.focuspoint, c.boss)
end,
function(c,e)
	EventSH.setloop(e, "warp_repeater")
end,
function(c,e)
	Silverhorn.SetFaccAnimation(c.boss, "idle")
	Facc_Teleport(c.boss, true)
	c.boss.target = Facc_GetNearbyTarget({x=ARENA_2_CENTER.x,y=ARENA_2_CENTER.y}, ARENA_2_RAD+600*FU)
end,
function(c,e)
	EventSH.waitSignal(e, "warp_finished")
end,
function(c,e)
	Facc_VerifyTarget(c.boss)
	A_FaceTarget(c.boss)
	EventSH.wait(e, 25)
end,
function(c,e)
	--Animation
	if c.warpcount >= 2 then
		--front slash
		Silverhorn.SetFaccAnimation(c.boss, "slash_front")
	elseif c.facslash then
		--slash
		Silverhorn.SetFaccAnimation(c.boss, "slash")
		c.facslash = false
	else
		--slash flip
		Silverhorn.SetFaccAnimation(c.boss, "slash_flip")
		c.facslash = true
	end
end,
function(c,e)
	EventSH.wait(e, 3)
end,
function(c,e)
	Facc_VerifyTarget(c.boss)

	-- Projectile
	if c.warpcount < 2 then
		local swordbeam = P_TossObject(c.boss, c.boss.target, 32*FU, MT_FACCIOLO2_SWORDBEAM_V, 4*FU, {zmove=true})
		swordbeam._facc2 = true -- Set as boss object
		swordbeam.mirrored = c.facslash
	else
		for mobjcount = 0, 1 do
			local swordbeam = P_TossObject(c.boss, c.boss.target, 32*FU, MT_FACCIOLO2_SWORDBEAM_V, 4*FU, {zmove=true})
			swordbeam._facc2 = true -- Set as boss object
			swordbeam.mirrored = not mobjcount
		end
	end

	-- SFX
	S_StartSound(nil, sfx_facswd)
	S_StartSound(swordbeam, sfx_facsls)
end,
function(c,e)
	EventSH.wait(e, 22)
end,
function(c,e)
	c.warpcount = $1+1
	if (c.warpcount < 3) then
		EventSH.gotoloop(e, "warp_repeater")
	end
end,
function(c,e)

	-- swap on half
	if c.boss and c.boss.facc and c.boss.facc.health < (c.boss.facc.health_mid_ref) then
		-- TODO: change
		if c.attackset < 2 then
			c.attackset = 2
			c.crashenabler = true
		else
			c.attackset = 3
			c.final_stand = 1
			-- Enable countdown
			if c.crashenabler then
				Facc_StartCrashCountdown(c)
				c.crashenabler = false
			end
			c.crashadvance_meteor = true
		end
	end

	c.nextmove = (c.nextmove >= #Facc_Move_Patterns[c.attackset]) and 1 or $1+1
	EventSH.start(Facc_Move_Patterns[c.attackset][c.nextmove], c)
end})


-- ===========================
--  A-1 - Moonreaver (Neuro Charge)
-- ===========================
EventSH.new("facciolo_ph2_charge", {
function(c,e)
	Facc_AttachFocus(c.focuspoint, c.boss)
	-- idle
	Silverhorn.SetFaccAnimation(c.boss, "idle")
	Facc_Teleport(c.boss, true, ARENA_2_CENTER.x, ARENA_2_CENTER.y, ARENA_2_CENTER.z+150*FU) -- slightly above ground
end,
function(c,e)
	EventSH.waitSignal(e, "warp_finished")
end,
function(c,e)
	-- Kill movement and remove damage
	-- Facc_SetInvincible(c.boss, false)
	Facc_ResetMomentum(c.boss)
end,
function(c,e)
	Facc_ChargingUp(true, c.boss, ColorShift_Boss_Neuro)
	S_StartSound(nil, sfx_facftl)
	-- Animation
	-- charge
	Silverhorn.SetFaccAnimation(c.boss, "charge")
end,

function(c,e)
	-- Create Main Exit portal
	c.transferportal = Facc_MakePortal(c.boss, 0, 0, 1024*FU, 0, 8*FU)
	c.transferportal.renderflags = RF_FLOORSPRITE
	c.transferportal.facciolo = true -- removal id flag

	S_StartSound(nil, sfx_portop)
end,
function(c,e)
	EventSH.wait(e, 2*TICRATE)
end,
function(c,e)
	Facc_ChargingUp(false)
	MobjMoverSH.moveto("faccmove", c.boss, {x=c.transferportal.x,y=c.transferportal.y,z=c.transferportal.z-240*FU}, {speed=10*FU, ease="inback"})
end,
function(c,e)
	MobjMoverSH.waitmovedone(e, "faccmove")
end,
function(c,e)
	-- Facc has left the arena
	MobjMoverSH.stop("faccmove")

	-- Close portal
	Facc_SetVisibility(c.boss, false)
	-- dash
	Silverhorn.SetFaccAnimation(c.boss, "dash")

	-- Set invulnerability
	Facc_SetInvincible(c.boss, true)
	Facc_SetLockon(c.boss, false)

	S_StartSound(nil, sfx_s3kb3)
	S_StartSound(nil, sfx_portcl)

	-- TODO: has a valid error when it goes away...
	c.transferportal.fuse = 6*TICRATE
	c.transferportal.destscale = 0
	c.transferportal.scalespeed = FU/5

	-- Create portal information
	c.portallist = {} -- List of portals
	c.portalnext = 1 -- counter for how many portals he choses
	c.hewilldothisxtimes = P_RandomRange(3, 5) -- "He will do this 3-5 times."
	c.hedidthisxtimes = 0 -- how many times the charge attack sequence was performed before moving on
end,
function(c,e)
	-- Ground Transition
	Facc_ViewTargetDistance(512) -- set distance
	Facc_DetachFocus() -- cinematic transition camera
	Facc_MoveFocusPoint(c.focuspoint, c.boss.x, c.boss.y, c.boss.floorz, 14*FU)

	-- Pick target
	c.boss.target = Facc_GetNearbyTarget({x=ARENA_2_CENTER.x,y=ARENA_2_CENTER.y}, ARENA_2_RAD+600*FU)
end,
function(c,e)
	EventSH.wait(e, 2*TICRATE)
end,
function(c,e)
	-- (Cutting point)
	-- Randomly decides how many portals are made to be chosen from (Max: 5)
	local RangeAngle = 90
	local Distance = 2096*FU
	local StartAngle = FixedAngle(P_RandomRange(1, 360)*FU)
	local index = 1

	for angle=0, RangeAngle, RangeAngle/5 do
		local pt = Facc_MakePortal(c.boss,
			P_ReturnThrustX(nil, StartAngle + FixedAngle(angle*FU), Distance),
			P_ReturnThrustY(nil, StartAngle + FixedAngle(angle*FU), Distance),
			(c.boss.floorz-c.boss.z)+150*FU+4*FU, 1, 1, -32*FU)
		-- Disable thinkers
		pt.facc = 1
		c.portallist[index] = pt
		index = $1+1
	end
end,
function(c,e)
	EventSH.wait(e, 1*TICRATE)
end,
function(c,e)
	-- Repeats until the chosen number is finished
	EventSH.setloop(e, "portalrepeat")
end,
function(c,e)
	local chosenport = c.portallist[c.portalnext]
	chosenport.color = SKINCOLOR_AQUA
	chosenport.destscale = 4*FU
	chosenport.scalespeed = FU/6 --10

	-- print(string.format("Times: [%d/%d]", c.hedidthisxtimes, c.hewilldothisxtimes))

	local distspeed = R_PointToDist2(c.boss.x, c.boss.y, chosenport.x, chosenport.y)
	Facc_MoveFocusPoint(c.focuspoint, chosenport.x, chosenport.y, chosenport.floorz, FixedDiv(distspeed, 25*FU), "inoutsine")

	-- Set new exit destination
	P_SetOrigin(c.boss, chosenport.x, chosenport.y, chosenport.floorz + 2*FU) -- 2.2.11 Fix

end,
function(c,e)
	EventSH.wait(e, 20)
end,
function(c,e)
	-- Intense Screenshake
	P_StartQuake(8*FU, 15)

	S_StartSound(nil, sfx_portop)
	S_StartSound(nil, sfx_facdsh)

	Facc_SetVisibility(c.boss, true)

	-- Open the next available portal (maximum amount set)
	local chosenport = c.portallist[min(c.portalnext+1, c.hewilldothisxtimes)]
	chosenport.color = SKINCOLOR_AQUA
	chosenport.destscale = 4*FU
	chosenport.scalespeed = FU/10 --10

	-- Face target
	Facc_VerifyTarget(c.boss)
	A_FaceTarget(c.boss)

	-- Set boundary-leave check
	if (c.hedidthisxtimes == c.hewilldothisxtimes) then
		Facc_BoundCheck(c.boss, ARENA_2_CENTER.x, ARENA_2_CENTER.y, ARENA_2_CENTER.z, {radin=140*FU, radinskipwarp=true,disappear=true})
	else
		Facc_BoundCheck(c.boss, ARENA_2_CENTER.x, ARENA_2_CENTER.y, ARENA_2_CENTER.z, {skipwarp=true,disappear=true})
	end
end,
function(c,e)
	-- nyoom
	P_InstaThrust(c.boss, c.boss.angle, 160*FU)
	EventSH.waitSignal(e, "Facc_BoundCheckDone")
end,
function(c,e)
	-- Facc has left once more
	local exitportal = Facc_MakePortal(c.boss, 0, 0, 128*FU, 6*FU, FU/256, -32*FU)
	exitportal.color = SKINCOLOR_SEAFOAM
	exitportal.scalespeed = FU/6
	exitportal.fuse = 7*TICRATE

	S_StartSound(nil, sfx_portcl)

	-- Set everything that the bound checker would do manually now
	Facc_ResetMomentum(c.boss)
	Facc_SetVisibility(c.boss, false)
	local chosenport = c.portallist[c.portalnext]
	P_SetOrigin(c.boss, chosenport.x, chosenport.y, chosenport.floorz) -- 2.2.11 Fix
end,
function(c,e)
	-- Increase count
	c.portalnext = $1 + 1
	c.hedidthisxtimes  = $1 + 1

	-- Repeat again until limit reached.
	if (c.hedidthisxtimes < c.hewilldothisxtimes) then
		EventSH.gotoloop(e, "portalrepeat")
	end
end,
function(c,e)
	EventSH.wait(e, 1*TICRATE)
end,
function(c,e)
	-- Close remaining
	for i=1, #c.portallist do
		c.portallist[i].destscale = 0
		c.portallist[i].scalespeed = FU/10
		c.portallist[i].fuse = 6*TICRATE

		-- SFX
		S_StartSoundAtVolume(c.portallist[i], sfx_portcl, 40)
	end

	-- SFX
	-- S_StartSound(nil, sfx_portcl)

	-- Roll the number
	c.portalchance = RANDOMCHOICE({1,1,1,1,1,1,0,0,0,0})
end,
-- =================
function(c,e)
	if not c.portalchance then return end
	-- Make a visual splat portal
	Facc_VerifyTarget(c.boss)
	c.finalportal = Facc_MakePortal(c.boss.target, 0, 0, 0, 0, 4*FU)
	c.finalportal.renderflags = RF_FLOORSPRITE
	S_StartSound(nil, sfx_portop)
	S_StartSound(nil, sfx_facftl)
end,
function(c,e)
	if not c.portalchance then return end

	-- get another target if target goes AWOL
	Facc_VerifyTarget(c.boss)

	P_MoveOrigin(c.finalportal, c.boss.target.x, c.boss.target.y, c.boss.target.floorz) -- 2.2.11 Fix
	P_StartQuake(8*FU, 15)
	EventSH.wait(e, 4*TICRATE)
end,
function(c,e)
	if not c.portalchance then return end
	S_StartSound(nil, sfx_chrg3)
	Facc_MoveFocusPoint(c.focuspoint, c.finalportal.x, c.finalportal.y, c.finalportal.floorz, 32*FU, "inoutsine")
end,
function(c,e)
	if not c.portalchance then return end
	-- Throw random fire from the floor
	local portalfire = P_SpawnMobj(c.finalportal.x, c.finalportal.y, c.finalportal.z, MT_FACCIOLO_FIRE)
	portalfire.scale = FU/2
	portalfire.destscale = RANDOMCHOICE({2,4,6}, true)*FU
	portalfire.scalespeed = FU/9
	portalfire.tics = 6*TICRATE
	portalfire.blendmode = AST_ADD
	portalfire.frame = $1|TR_TRANS50

	portalfire.momz = 96*FU
	portalfire.momx = 6*cos(leveltime*ANG20)
	portalfire.momy = 6*sin(leveltime*ANG20)
	portalfire._facc2 = true -- Set as boss object

	EvActionSH.PlaySoundRate(portalfire, sfx_facbrr, 6, 40)
	P_StartQuake(13*FU, 15)
	EventSH.wait(e, 5*TICRATE)
end,
function(c,e)
	if not c.portalchance then return end
	-- Close extra
	c.finalportal.destscale = 0
	c.finalportal.scalespeed = FU/10
	c.finalportal.fuse = 6*TICRATE
	S_StartSound(nil, sfx_portcl)
end,
-- =================
function(c,e)
	EventSH.wait(e, 2*TICRATE)
end,
function(c,e)
	-- Revert invulnerability
	Facc_SetInvulnerability(c.boss, false)

	Facc_ViewTargetDistance(nil) -- clear distance

	EventSH.start("facciolo_ph2_teleport", c)
end,})


-- ===========================
--  A-2 - Moonreaver (Flame)
-- ===========================
EventSH.new("facciolo_ph2_flamethrower", {
function(c,e)
	-- Attach focus
	Facc_AttachFocus(c.focuspoint, c.boss)

	-- Kill movement and remove damage
	-- Facc_SetInvincible(c.boss, false)
	Facc_ResetMomentum(c.boss)
	Facc_Teleport(c.boss, true, ARENA_2_CENTER.x, ARENA_2_CENTER.y, ARENA_2_CENTER.z)
end,
function(c,e)
	EventSH.waitSignal(e, "warp_finished")
end,
function(c,e)
	-- Start charge and target a player position
	Facc_ChargingUp(true, c.boss)

	-- SFX
	S_StartSound(nil, sfx_facftl)
	--Animation
	-- charge
	Silverhorn.SetFaccAnimation(c.boss, "charge")
end,
function(c,e)
	P_StartQuake(5*FU, 1)
	EventSH.wait(e, 3*TICRATE)
end,
function(c,e)

	-- Set invulnerability
	Facc_SetInvulnerability(c.boss, true)

	Facc_ViewTargetDistance(512) -- set distance
	Facc_ViewTargetHeight(256*FU) -- height
	Facc_DetachFocus() -- give software view breathing room
	Facc_MoveFocusPoint(c.focuspoint, c.boss.x, c.boss.y, c.boss.floorz-300*FU, 40*FU)

	P_StartQuake(16*FU, 8)

	-- SFX
	S_StartSound(nil, sfx_facfdh)
	S_StartSound(nil, sfx_chrg3)

	--Animation
	-- breath
	Silverhorn.SetFaccAnimation(c.boss, "breath")
	Facc_ChargingUp(false)

	-- Set target
	c.boss.target = Facc_GetNearbyTarget({x=ARENA_2_CENTER.x,y=ARENA_2_CENTER.y}, ARENA_2_RAD+600*FU)
end,
function(c,e)
	local speedfire = abs(50*cos(leveltime*FixedAngle(4*FU)))

	-- get another target if target goes AWOL
	Facc_VerifyTarget(c.boss)

	-- Face Target
	A_FaceTarget(c.boss)

	-- Spread shot (good luck server- don't kill your entire party!)
	for i=-7, 7, 7 do
		local flame = P_TossObject(c.boss, nil, speedfire, MT_FACCIOLO_FIRE, FU, {angle=FixedAngle(i*FU), disto=64*FU, hz=64*FU})
		flame.scale = 0
		flame.destscale = 6*FU
		flame.scalespeed = FU/9
		flame.tics = 7*TICRATE
		flame.blendmode = AST_ADD
		flame.frame = $1|TR_TRANS50
		flame._facc2 = true -- Set as boss object
	end

	-- SFX
	EvActionSH.PlaySoundRate(nil, sfx_facbrr, 40, 1)
	-- S_PlaySoundRate(nil, sfx_facbrr, 8, 4)
	-- S_PlaySoundRate(nil, sfx_facflm, 50, 3)

	EventSH.wait(e, 10*TICRATE)
end,
-- =================
function(c,e)
	-- Roll the number
	c.burstchance = RANDOMCHOICE({1,1,1,0,0,0,0,0,0,0,})

	-- if we ended up getting a non 0 value, he has a random chance of firing off one burst shot before ending
	if (c.burstchance) then
		S_StartSoundAtVolume(nil, sfx_chrg4, 255)
		S_StartSoundAtVolume(nil, sfx_chrg4, 255)
		Facc_ChargingUp(true, c.boss)
		--Animation
		-- charge
		Silverhorn.SetFaccAnimation(c.boss, "charge")
	end
end,
function(c,e)
	if not (c.burstchance) then return end
	Facc_VerifyTarget(c.boss)
	A_FaceTarget(c.boss)
	EventSH.wait(e, 3*TICRATE)
end,
function(c,e)
	if not (c.burstchance) then return end
	Facc_VerifyTarget(c.boss)
	Facc_ChargingUp(false, c.boss)

	-- Fire surprise fireballs
	if (leveltime % 8 == 0) then
		P_StartQuake(16*FU, 8)
		-- breath
		Silverhorn.SetFaccAnimation(c.boss, "breath")

		local flame = P_TossObject(c.boss, c.boss.target, 60*FU, MT_FACCIOLO_DEATHBALL, FU, {disto=64*FU, zmove=true, hz=10*FU})
		flame.scale = 3*FU
		flame.tics = 3*TICRATE
		flame.blendmode = AST_ADD
		flame.frame = $1|TR_TRANS20
		flame.colorized = true
		flame.color = SKINCOLOR_MAGENTA
		flame.flags = $1|MF_PAIN
		flame._facc2 = true -- Set as boss object
	elseif leveltime % 8 == 6 then
		-- charge
		Silverhorn.SetFaccAnimation(c.boss, "charge")
	end
	EvActionSH.PlaySoundRate(nil, sfx_facfdh, 8)

	EventSH.wait(e, 1*TICRATE)
end,
-- =================
function(c,e)
	-- Revert
	Facc_MoveFocusPoint(c.focuspoint, c.boss.x, c.boss.y, c.boss.z, 40*FU)
	if c.burstchance then
		-- breath
		Silverhorn.SetFaccAnimation(c.boss, "breath")
	else
		--idle
		Silverhorn.SetFaccAnimation(c.boss, "idle")
	end

	-- Revert invulnerability
	Facc_SetInvulnerability(c.boss, false)
end,
function(c,e)
	EventSH.wait(e, 2*TICRATE)
end,
function(c,e)

	-- Reset view
	Facc_ViewTargetDistance(nil)
	Facc_ViewTargetHeight(nil)
	Facc_AttachFocus(c.focuspoint, c.boss)

	EventSH.start("facciolo_ph2_teleport", c)
end,
})


-- ===========================
--  A-3 - Moonreaver (Omnislash)
-- ===========================
EventSH.new("facciolo_ph2_omnislash", {
function(c,e)
	-- Kill movement and remove damage
	Facc_ResetMomentum(c.boss)
end,
function(c,e)

	-- Setup
	c.omnivantagepoints = Facc_MakeRadiusPoints(ARENA_2_CENTER, 1024*FU, nil, 90)

	-- Combined second total
	c.secondcounter = 0
	c.hewilldothisforxseconds = RANDOMCHOICE({5*TICRATE,10*TICRATE})
end,
function(c,e)
	-- Start charge and target a player position
	Facc_ChargingUp(true, c.boss, ColorShift_Boss_Omni)

	-- SFX
	S_StartSound(nil, sfx_facftl)
	--Animation
	-- charge
	Silverhorn.SetFaccAnimation(c.boss, "charge")
	c.boss.target = Facc_GetNearbyTarget({x=ARENA_2_CENTER.x,y=ARENA_2_CENTER.y}, ARENA_2_RAD+600*FU)
end,
function(c,e)
	P_StartQuake(2*FU, 1)
	EventSH.wait(e, 2*TICRATE)
end,
function(c,e)

	-- Set invulnerability
	Facc_SetInvulnerability(c.boss, true)

	-- SFX
	S_StartSound(nil, sfx_chrg2)

	Facc_ChargingUp(false)
	EventSH.setloop(e, "omni_repeat")
end,
function(c,e)
	-- Start time
	c.secondcounter = $1+1
	Facc_VerifyTarget(c.boss)
	Facc_FireOmniShot(c.boss, c.boss.target)
	EventSH.wait(e, 2*TICRATE)
end,
function(c,e)
	--Reset Animation
	--idle
	Silverhorn.SetFaccAnimation(c.boss, "idle")

	-- without easing this would have looked very bad
	if (c.secondcounter < c.hewilldothisforxseconds) then
		local cur = P_RandomRange(1, #c.omnivantagepoints)
		local distspeed = R_PointToDist2(c.boss.x, c.boss.y, c.omnivantagepoints[cur].x, c.omnivantagepoints[cur].y)
		-- Facc_Move(c.boss,{{x=c.omnivantagepoints[cur].x, y=c.omnivantagepoints[cur].y, z=c.omnivantagepoints[cur].z+RANDOMCHOICE({0,64,128})*FU}}, {ease="inoutback", speed=FixedDiv(distspeed, 40*FU)})
		MobjMoverSH.moveto("faccmove", c.boss, {x=c.omnivantagepoints[cur].x, y=c.omnivantagepoints[cur].y, z=c.omnivantagepoints[cur].z+RANDOMCHOICE({0,64,128})*FU}, {ease="inoutback", noangle=true, speed=FixedDiv(distspeed, 40*FU)})
	end

end,
function(c,e)
	-- Move to new locations and keep attacking
	if (c.secondcounter < c.hewilldothisforxseconds) then
		Facc_VerifyTarget(c.boss)
		A_FaceTarget(c.boss)
		-- if c.boss.target then A_FaceTarget(c.boss) end
		MobjMoverSH.waitmovedone(e, "faccmove")
	end
end,
function(c,e)
	if (c.secondcounter < c.hewilldothisforxseconds) then
		EventSH.gotoloop(e, "omni_repeat")
	end
end,
function(c,e)

	-- Roll the number
	c.divechance = RANDOMCHOICE({1,1,1,1,1,0,0,0,0,0,})

	-- Facciolo has a 50/50 chance of immediately diving at you after finishing
	if (c.divechance) then
		Facc_VerifyTarget(c.boss)
		Facc_SlamAttack(c, true)
	end

	-- Revert invulnerability
	Facc_SetInvulnerability(c.boss, false)

end,
function(c,e)
	if not (c.divechance) then return end
	-- wait for dive finish if we do it
	EventSH.waitSignal(e, "Facc_SlamAttack")
end,
function(c,e)
	EventSH.wait(e, 2*TICRATE)
end,
function(c,e)

	EventSH.start("facciolo_ph2_teleport", c)
end})


-- ===========================
--  A-4 - Moonreaver (P1 Fireball)
-- ===========================

EventSH.new("atk_sky_fire", {
function(c,e)
	-- Set time
	c.time = Ph2_Skyfire_FireTime

	EventSH.wait(e,c.waitoffset*2 or 1, true)
end,
function(c,e)

	local rx = P_RandomRange(-2500, 2500)*FU
	local ry = P_RandomRange(-2500, 2500)*FU

	c.skypos = EvActionSH.coordinategetoffset(c, "msboss", rx, ry, 0)
	c.warns = Facc_CreateWarning(c.skypos.x, c.skypos.y, c.skypos.z)

	c.ceilingz = c.warns.ceilingz

	EvActionSH.PlaySoundRate(nil, sfx_s3k51, 5)
end,
function(c,e)
	EventSH.wait(e, 2*TICRATE)
end,
function(c,e)
	EventSH.setloop(e, "repeat")
	EventSH.wait(e, 1, true)
end,
function(c,e)
	local ofx = P_RandomRange(-280, 280)*FU
	local ofy = P_RandomRange(-280, 280)*FU

	local eb = P_SpawnMobj(c.skypos.x + ofx, c.skypos.y + ofy, c.ceilingz - 96*FU, MT_FACCIOLO2_ENERGYBALL)
	eb.momz = -160*FU
	eb._facc2 = true -- Set as boss object
end,
function(c,e)
	c.time = $1 - 1

	if (c.time) then
		EventSH.gotoloop(e, "repeat")
	end
end,
function(c,e)
	EvActionSH.setmobjvisible(c.warns, false)
end})

EventSH.new("atk_sky_fire_2", {
function(c,e)

	EventSH.wait(e,c.waitoffset*6 or 1, true)
end,
function(c,e)
	-- Pick random location inside
	local rx = P_RandomRange(-2200, 2200)*FU
	local ry = P_RandomRange(-2200, 2200)*FU

	c.fieldrand = EvActionSH.coordinategetoffset(c, "msboss", rx, ry, 0)
	c.warns = Facc_CreateWarning(c.fieldrand.x, c.fieldrand.y, c.fieldrand.z, 3*TICRATE)

	-- S_StartSound(nil, sfx_alart)
end,
function(c,e)
	-- Fire a mega-ball
	P_StartQuake(20*FU, 4)

	local flame = P_TossObject(c.boss, c.fieldrand, 60*FU, MT_FACCIOLO2_ENERGYBALL, FU, {disto=64*FU, zmove=true, hz=10*FU})
	flame.state = S_FACCIOLO_DEATHBALL
	flame.scale = 3*FU
	flame.tics = 3*TICRATE
	flame.blendmode = AST_ADD
	flame.frame = $1|TR_TRANS20
	flame.colorized = true
	flame.color = SKINCOLOR_MAGENTA
	flame.flags = $1|MF_PAIN|MF_NOCLIP|MF_NOCLIPHEIGHT
	flame._facc2 = true -- Set as boss object

	EvActionSH.PlaySoundRate(nil, sfx_facfdh, 2)

end})

EventSH.new("facciolo_ph2_skyfire", {
function(c,e)
	-- Attach focus
	Facc_AttachFocus(c.focuspoint, c.boss)

	--Animation
	Silverhorn.SetFaccAnimation(c.boss, "charge")

	-- Set invulnerability
	Facc_SetInvulnerability(c.boss, true)

	Facc_ChargingUp(true, c.boss, ColorShift_Boss_Sky)
	S_StartSound(nil, sfx_facftl)

	c.boss.target = Facc_GetNearbyTarget({x=ARENA_2_CENTER.x,y=ARENA_2_CENTER.y}, ARENA_2_RAD+600*FU)
end,
function(c,e)
	MobjMoverSH.moveto("faccmove", c.boss, {x=c.boss.x,y=c.boss.y,z=c.boss.z+400*FU}, {speed=3*FU, ease="inoutback"})
end,
function(c,e)
	MobjMoverSH.waitmovedone(e, "faccmove")
end,
function(c,e)
	Facc_ChargingUp(false)
	Facc_ChargingUp(true, c.boss, nil, SPR_FFLF)
	EventSH.wait(e, 15, true)
end,
function(c,e)
	local p = P_SpawnMobj(c.boss.x + P_RandomRange(-256,256)*FU, c.boss.y + P_RandomRange(-256,256)*FU, c.boss.z + P_RandomRange(-256,256)*FU, MT_PUSH)
	p.fuse = 3*TICRATE
	p.sprite = SPR_FFLF
	p.frame = 0 | FF_TRANS50
	p.scale = 5*FU
	p.renderflags = $1 | RF_FULLBRIGHT
	p.blendmode = AST_ADD
	p.rollangle = ANGLE_180
	p.momz = $1 + 128*FU
	p._facc2 = true -- Set as boss object

	P_StartQuake(10*FU, 2)
	EvActionSH.PlaySoundRate(nil, sfx_s3k4e, 6)

	EventSH.wait(e, 3*TICRATE)
end,
function(c,e)
	Facc_DetachFocus()

	-- Set view
	Facc_ViewTargetDistance(512)
	Facc_ViewTargetHeight(256*FU)

	local cpos = EvActionSH.coordinategetoffset(c, "msboss", 0, 0, 0)
	Facc_MoveFocusPoint(c.focuspoint, cpos.x, cpos.y, cpos.z, 50*FU)
end,
function(c,e)
	-- Boss has left again
	Facc_ChargingUp(false)
	P_StartQuake(32*FU, 3)
	c.boss.momz = 256*FU

	EventSH.wait(e, 15, true)
end,
function(c,e)
	EventSH.wait(e, 2*TICRATE, true)
end,
function(c,e)

	for i = 1, 45, 1 do
		c.waitoffset = i
		EventSH.start("atk_sky_fire", c)
	end
end,
function(c,e)
	EventSH.wait(e, 4*TICRATE)
end,
function(c,e)
	local p = EvActionSH.coordinategetoffset(c, "msboss", 4000*FU, 0, 1024*FU)
	local p2 = EvActionSH.coordinategetoffset(c, "msboss", 0, 0, 0)
	EvActionSH.movemobjto(c.boss, p)

	Silverhorn.SetFaccAnimation(c.boss, "breath")
	Facc_ChargingUp(true, c.boss, nil, SPR_FFLF)
	EvActionSH.setmobjlookat(c.boss, p2)

	Facc_MoveFocusPoint(c.focuspoint, c.boss.x, c.boss.y, c.boss.z, 50*FU)
end,
function(c,e)
	EventSH.wait(e, 2*TICRATE)
end,
function(c,e)
	for i = 1, 22, 1 do
		c.waitoffset = i
		EventSH.start("atk_sky_fire_2", c)
	end
end,
function(c,e)
	EventSH.wait(e, 4*TICRATE)
end,
function(c,e)
	Facc_AttachFocus(c.focuspoint, c.boss)

	-- Incoming!
	local og = EvActionSH.coordinategetoffset(c, "msboss", 0, 0, 0)

	-- (at random speed)
	c.randspeed = P_RandomRange(32, 96)
	MobjMoverSH.moveto("faccmove", c.boss, og, {speed=c.randspeed*FU, harc=3000*FU, ease="incubic"})
	Silverhorn.SetFaccAnimation(c.boss, "dash")

	local warns = Facc_CreateWarning(og.x, og.y, og.z, 3*TICRATE)
	warns.scale = 2*FRACUNIT
end,
function(c,e)
	P_StartQuake(32*FU, 5)
	EvActionSH.setplayerviewroll(true, FixedAngle(FU/14), true)
	MobjMoverSH.waitmovedone(e, "faccmove")
end,
function(c,e)
	Silverhorn.SetFaccAnimation(c.boss, "slam2")

	P_StartQuake(50*FU, 2*TICRATE)
	S_StartSound(nil, sfx_s3k59)
	Facc_ChargingUp(false)

	InazumaProjectileStream(c.boss, SKINCOLOR_MAGENTA)

	-- Revert invulnerability
	Facc_SetInvulnerability(c.boss, false)
end,
function(c,e)
	EventSH.wait(e, 3*TICRATE)
end,
function(c,e)

	-- Reset view
	Facc_ViewTargetDistance(nil)
	Facc_ViewTargetHeight(nil)
	EvActionSH.setplayerviewroll(true, 0)

	-- Advance Countdown
	Facc_AdvanceCrashCountdown()

	EventSH.start("facciolo_ph2_teleport", c)
end,})

-- ===========================
--  A-5 - Moonreaver (P1 Laser Lines)
-- ===========================
local patt_laser = {
	{padding=256*FU, step=16, max=45, time=1},
	{padding=256*FU, step=16, max=90, time=1},
	{padding=256*FU, step=32, max=180, time=1},
	{padding=256*FU, step=45, max=360, time=1},
	{padding=320*FU, step=90, max=360, time=1},
	-- {padding=512*FU, step=90, max=360, time=1},
	--
	{padding=256*FU, step=180, max=360, time=4},
	{padding=128*FU, step=90, max=360, time=0},
	{padding=256*FU, step=45, max=360, time=2},
	{padding=150*FU, step=32, max=180, time=0},
	{padding=128*FU, step=16, max=90, time=1},
	{padding=128*FU, step=16, max=45, time=0},
	-- {padding=512*FU, step=10, max=30, time=35},
}

EventSH.new("facciolo_ph2_p1laser", {
function(c,e)
	-- Attach focus
	Facc_AttachFocus(c.focuspoint, c.boss)

	-- Kill movement and move to center
	Facc_ResetMomentum(c.boss)
	Facc_Teleport(c.boss, true, ARENA_2_CENTER.x, ARENA_2_CENTER.y, ARENA_2_CENTER.z)

	-- Set view
	Facc_ViewTargetDistance(512)
	Facc_ViewTargetHeight(96*FU)
	-- Facc_ViewTargetHeight(75)

	-- Set
	c.lasersjustlikeph1 = P_RandomRange(1, 4)
	c.lasercounter = 0
	c.laserpattern = 1

	Facc_ChargingUp(true, c.boss, ColorShift_Boss_Sky)

	-- SFX
	S_StartSound(nil, sfx_chrg4)

	--Animation
	-- charge
	Silverhorn.SetFaccAnimation(c.boss, "charge")

	c.boss.target = Facc_GetNearbyTarget({x=ARENA_2_CENTER.x,y=ARENA_2_CENTER.y}, ARENA_2_RAD+600*FU)
end,
function(c,e)
	EventSH.wait(e, 2*TICRATE)
end,
function(c,e)
	-- this looked cool so i made it turn off after he gets there
	Facc_ChargingUp(false)
end,
function(c,e)
	Facc_VerifyTarget(c.boss)
	A_FaceTarget(c.boss)
	EventSH.wait(e, 1*TICRATE)
end,
function(c,e)
	-- Set invulnerability
	Facc_SetInvulnerability(c.boss, true)
end,
function(c,e)
	-- Roll number and facetarget
	Facc_VerifyTarget(c.boss)
	A_FaceTarget(c.boss)
	c.laserpattern = P_RandomRange(1, #patt_laser)
	EventSH.setloop(e, "grid_repeat")
end,
function(c,e)
	-- SFX
	S_StartSound(nil, sfx_faclfr)

	--Animation
	-- hold
	Silverhorn.SetFaccAnimation(c.boss, "hold1")

	Facc_GridLaser(c.boss, patt_laser[c.laserpattern].padding, patt_laser[c.laserpattern].step, patt_laser[c.laserpattern].max, patt_laser[c.laserpattern].time)
end,
function(c,e)
	EventSH.wait(e, 2*TICRATE)
end,
function(c,e)
	-- facciolo will keep firing lasers until the limit is reached
	c.lasercounter = $1+1
	if (c.lasercounter <= c.lasersjustlikeph1) then
		-- SFX
		S_StartSound(nil, sfx_chrg2)

		EventSH.gotoloop(e, "grid_repeat")
	--Reset Animation
	else
		--idle
		Silverhorn.SetFaccAnimation(c.boss, "idle")
	end
end,
function(c,e)
	-- Revert invulnerability
	Facc_SetInvulnerability(c.boss, false)

	EventSH.wait(e, 3*TICRATE, true)
end,
function(c,e)
	-- Reset view
	Facc_ViewTargetDistance(nil)
	Facc_ViewTargetHeight(nil)
	EventSH.start("facciolo_ph2_teleport", c)
end,})


-- ===========================
--  A-4 - Moonreaver (Meteor)
-- ===========================
EventSH.new("facciolo_ph2_meteor", {
function(c,e)

	-- Object settings
	c.MeteorMoveSpeed = 30*FU
	c.MeteorGrowthSize = 4*FU
	c.SmallOrbScale = FU
	c.SmallOrbColor = false
	c.MeteorTimer = 0

	-- c.MeteorMoveSpeed = (c.final_stand == 1) and 92*FU or 30*FU
	-- c.SmallOrbScale = (c.final_stand == 1) and (2*FU-FU/8) or FU
	-- c.SmallOrbColor = (c.final_stand == 1) and true or false

	-- Set invulnerability
	Facc_SetInvulnerability(c.boss, true)

	--Animation
	--charge
	Silverhorn.SetFaccAnimation(c.boss, "charge")

	-- Set view
	-- ===============================================
	-- if (c.final_stand) then
		-- Facc_ViewTargetDistance(1600)
		-- Facc_ViewTargetHeight(512*FU)
	-- else
		Facc_ViewTargetDistance(1024)
	-- end
	-- ===============================================


	c.boss.target = Facc_GetNearbyTarget({x=ARENA_2_CENTER.x,y=ARENA_2_CENTER.y}, ARENA_2_RAD+600*FU)

	-- Move very very far away from harm
	local distspeed = R_PointToDist2(c.boss.x, c.boss.y, ARENA_2_CENTER.x+ARENA_2_METEORDISTANCE, ARENA_2_CENTER.y)
	MobjMoverSH.moveto("faccmove", c.boss, {x=ARENA_2_CENTER.x+ARENA_2_METEORDISTANCE, y=ARENA_2_CENTER.y, z=ARENA_2_CENTER.z+ARENA_2_METEORHEIGHT}, {ease="inoutback", speed=FixedDiv(distspeed, 40*FU)})
end,
function(c,e)
	EventSH.wait(e, 3*TICRATE)
end,
function(c,e)
	Facc_VerifyTarget(c.boss)
	A_FaceTarget(c.boss)

	--Animation
	--hold2
	Silverhorn.SetFaccAnimation(c.boss, "hold2")

	-- Create big meteor
	c.bigmeteor = P_SpawnMobj(c.boss.x,c.boss.y, c.boss.z+c.boss.height+512*FU, MT_FACCIOLO2_ENERGYBALL)
	c.bigmeteor.scale = 0
	c.bigmeteor.destscale = 5*FU
	c.bigmeteor.scalespeed = FU/45
	c.bigmeteor.colorized = true
	c.bigmeteor.color = SKINCOLOR_KETCHUP
	c.bigmeteor._facc2 = true -- Set as boss object

	S_StartSoundAtVolume(nil, sfx_dbchrg, 255)
end,
function(c,e)
	-- Tosses smaller energy sphres from the center one that is growing
	EventSH.setloop(e, "orb_repeat")
end,
function(c,e)
	Facc_VerifyTarget(c.boss)

	local smallorb = P_SpawnMobj(c.bigmeteor.x, c.bigmeteor.y, c.bigmeteor.z, MT_FACCIOLO2_ENERGYBALL)
	smallorb.scale = c.SmallOrbScale -- bigger scale after half
	smallorb.fuse = 6*TICRATE -- sometimes they get stuck on the floor when other forces outside of main char exist
	smallorb._facc2 = true -- Set as boss object

	-- Final Stand
	-- ===============================================
	if (c.final_stand) then
		smallorb.colorized = true
		smallorb.color = SKINCOLOR_KETCHUP
		smallorb.scale = $1 + 2*FU
	end
	-- ===============================================

	local distspeed = R_PointToDist2(c.boss.x, c.boss.y, c.boss.target.x, c.boss.target.y)

	-- SFX
	S_StartSoundAtVolume(nil, sfx_s3k4e, 90)
	-- S_StartSoundAtVolume(nil, sfx_facslm, 128)

	-- I created the ability to move objects under the duplicate names just for this ...
	MobjMoverSH.moveto("move_meteor", smallorb,
		{x=c.boss.target.x, y=c.boss.target.y, z=c.boss.target.floorz},
		{varc=512*FU, harc=RANDOMCHOICE({-1024, 1024}, true)*FU, ease="inquad", speed=FixedDiv(distspeed, 32*FU)}, true)
end,
function(c,e)
	EventSH.wait(e, 1)
end,
function(c,e)
	-- Repeat until size reached
	if (c.bigmeteor.scale <= c.MeteorGrowthSize) then
		EventSH.gotoloop(e, "orb_repeat")
	end
end,
function(c,e)
	-- Send out big energy ball
	-- SFX
	S_StartSoundAtVolume(nil, sfx_chrg4, 30)
	S_StartSoundAtVolume(nil, sfx_dbfire, 255)

end,
-- ===============================================
-- Final Stand
-- ===============================================
function(c,e)
	if not (c.final_stand) then return end
	-- Reset time
	c.MeteorTimer = 0

	local t = P_SpawnMobj(c.bigmeteor.x, c.bigmeteor.y, c.bigmeteor.z, MT_FACCIOLO2_BIGALERT)
	t.fuse = 6*TICRATE
	t.spriteyoffset = -13*FU
	t.colorized = true
	t.color = SKINCOLOR_WHITE
	t.blendmode = AST_ADD
	t.frame = $1 | FF_TRANS40
	t.scale = 40*FU
	t.destscale = 1
	t.scalespeed = FU/2
	t._facc2 = true -- Set as boss object
	EventSH.wait(e, 3*TICRATE, true)
end,
function(c,e)
	if not (c.final_stand) then return end
	EvActionSH.doforall(function(pf) P_FlashPal(pf, 1, 3)	end)
end,
function(c,e)
	if not (c.final_stand) then return end

	Facc_VerifyTarget(c.boss)

	local mgcols = ColorShift_MegaLaser_FinalStand
	if (c.MeteorTimer % 10 == 0) then
		-- Create FX
		local fx = P_SpawnMobjFromMobj(c.bigmeteor, 0, 0, -32*FU, MT_THOK)
		fx.state = S_UNA_FORCE_BREAK2
		fx.scale = 8*FU
		fx.destscale = 14*FU
		fx.scalespeed = FU/2
		fx.color = SKINCOLOR_FLAME
		fx.blendmode = AST_ADD
		fx._facc2 = true -- Set as boss object

		-- Fire!
		Silverhorn.FireMegaLaser(c.bigmeteor, c.boss.target, 50*FU, {colors=mgcols, length=25, firedist=6400*FU, spawnscale=8*FU})
		Facc_CreateWarning(c.boss.target.x, c.boss.target.y, c.boss.target.floorz, 2*TICRATE)

		S_StartSound(nil, sfx_portfr)
		P_StartQuake(20*FU, 15)
	end

	c.MeteorTimer = $1 + 1

	EventSH.wait(e, 3*TICRATE)
end,
-- ===============================================
function(c,e)
	if (c.final_stand) then
		EventSH.wait(e, 1*TICRATE)
	else
		EventSH.wait(e, 3*TICRATE)
	end
end,
function(c,e)
	Facc_VerifyTarget(c.boss)

	c.bigmeteor.destscale = 16*FU
	c.bigmeteor.scalespeed = FU/32
	c.bigmeteor.fuse = 20*TICRATE -- ... just in case

	c.bigmeteor.facciolo = c.boss
	P_StartQuake(20*FU, 35)

	-- ALERT!!!
	-- -- (Dynamic)
	-- for i = 0, 1024, 1024 do
	-- 	Facc_CreateWarning(c.boss.target.x, c.boss.target.y, c.boss.target.floorz+(i*FU), 6*TICRATE, {mobj=MT_FACCIOLO2_BIGALERT, renderflags=(RF_FLOORSPRITE), scale=16*FU})
	-- end

	-- (Simplified)
	Facc_CreateWarning(c.boss.target.x, c.boss.target.y, c.boss.target.floorz, 6*TICRATE, {mobj=MT_FACCIOLO2_BIGALERT, renderflags=(RF_FLOORSPRITE), scale=16*FU})
	Facc_CreateWarningCircle({x=c.boss.target.x, y=c.boss.target.y, z=c.boss.target.floorz, valid=true}, Ph2_MeteorDamageRadius, 16, FU - FU/64, 6*TICRATE)


	-- Attach focus
	Facc_AttachFocus(c.focuspoint, c.bigmeteor)

	--Throw animation
	Silverhorn.SetFaccAnimation(c.boss, "throw")

	-- Toss it!
	MobjMoverSH.moveto("move_meteor", c.bigmeteor,
		{x=c.boss.target.x, y=c.boss.target.y, z=c.boss.target.floorz},
		{varc=512*FU, harc=RANDOMCHOICE({-1024, 1024}, true)*FU, ease="inquad", speed=c.MeteorMoveSpeed}, true)

	-- SFX
	S_StartSound(nil, sfx_facbrr)
end,
function(c,e)
	P_StartQuake(20*FU, 90)
	MobjMoverSH.waitmovedone(e, "move_meteor")
end,
function(c,e)
	EventSH.wait(e, 2*TICRATE)
end,
function(c,e)
	Facc_DetachFocus()
	Facc_MoveFocusPoint(c.focuspoint, c.boss.x, c.boss.y, c.boss.z, 50*FU)
	--idle
	Silverhorn.SetFaccAnimation(c.boss, "idle")
end,
function(c,e)
	EventSH.wait(e, 3*TICRATE)
end,
function(c,e)

	-- Revert invulnerability
	Facc_SetInvulnerability(c.boss, false)

	-- Reset view
	Facc_ViewTargetDistance(nil)
	Facc_ViewTargetHeight(nil)

	-- Advance Countdown
	Facc_AdvanceCrashCountdown()

	EventSH.start("facciolo_ph2_teleport", c)
end})

freeslot(
	"sfx_fcrys",
	"SPR_MNRR",
	"S_SPEAR_INT",
	"S_SPEAR_RISE",
	"S_SPEAR_END"
)
sfxinfo[sfx_fcrys].caption = "Crystal Crash"
sfxinfo[sfx_fcrys].flags = SF_TOTALLYSINGLE

-- \\ Spawn & Setup effect \\
states[S_SPEAR_INT] = {SPR_MNRR, B, 1, function(mo)
	if not mo.statetimer then mo.statetimer = 2*TICRATE end
	if not mo.firstuse then mo.firstuse = false end
	-- mo.spriteyscale = 0
	-- mo.spritexscale = 0
end, 0, 0, S_SPEAR_RISE}

states[S_SPEAR_RISE] = {SPR_MNRR, A, 1, function(mo)
	if not mo.statetimer then
		mo.state = S_SPEAR_END
		return
	end

	if not mo.firstuse then
		mo.blendmode = AST_ADD
		mo.color = SKINCOLOR_ICY
		mo.colorized = true
		mo.renderflags = $1|RF_FULLBRIGHT
		if mo.tracer then S_StartSound(nil, sfx_fcrys) end

		mo.firstuse = true
	end
	mo.flags = $1 | MF_PAIN
	mo.height = 110*FU
	mo.radius = 96*FU
	mo.spriteyscale = min($1 + FU, 6*FU)
	mo.spritexscale = FU*3


	mo.statetimer = $1 - 1
end, 0, 0, S_SPEAR_RISE}
states[S_SPEAR_END] = {SPR_NMNRR, A, 1, nil, 0, 0, S_NULL}

EventSH.new("facciolo_ph2_bladecrash", {
function(c,e)

	Facc_AttachFocus(c.focuspoint, c.boss)
	--idle
	Silverhorn.SetFaccAnimation(c.boss, "idle")

	local loc = EvActionSH.coordinategetoffset(c, "msboss", 0, 0, 128*FU)
	MobjMoverSH.moveto("faccmove", c.boss, {x=c.boss.x,y=c.boss.y,z=c.boss.z+800*FU}, {speed=6*FU, ease="inoutback"})

	-- Set invulnerability
	Facc_SetInvulnerability(c.boss, true)

	--Animation
	--charge
	Silverhorn.SetFaccAnimation(c.boss, "charge")

	Facc_ChargingUp(true, c.boss)
	S_StartSound(nil, sfx_facftl)

	c.boss.target = Facc_GetNearbyTarget({x=ARENA_2_CENTER.x,y=ARENA_2_CENTER.y}, ARENA_2_RAD+600*FU)
end,
function(c,e)
	Facc_VerifyTarget(c.boss)
	A_FaceTarget(c.boss)
	MobjMoverSH.waitmovedone(e, "faccmove")
end,
function(c,e)
	EventSH.wait(e, 20)
end,
function(c,e)
	Facc_ChargingUp(false)
	S_StartSound(nil, sfx_facslm)
	--slam2
	Silverhorn.SetFaccAnimation(c.boss, "slam2")
	MobjMoverSH.moveto("faccmove", c.boss, {x=c.boss.x,y=c.boss.y,z=c.boss.floorz}, {noangle=true, speed=140*FU})
end,
function(c,e)
	MobjMoverSH.waitmovedone(e, "faccmove")
end,
function(c,e)
	for i = 1, 32, 3 do
		for ang = 0, 360, 16 do
		-- for ang = -45, 45, 8 do

			local p = P_SpawnMobj(
				c.boss.x + P_ReturnThrustX(c.boss, c.boss.angle + FixedAngle(ang*FU), (128*i)*FU),
				c.boss.y + P_ReturnThrustY(c.boss, c.boss.angle + FixedAngle(ang*FU), (128*i)*FU),
				c.boss.z, MT_PUSH)
			p.state = S_SPEAR_INT
			p.tics = i*3
			p.angle = FixedAngle(ang*FU)
			p._facc2 = true -- Set as boss object
			if (ang == 0) then p.tracer = c.boss end
		end
	end

	P_StartQuake(20*FU, 90)
end,
function(c,e)
	-- Revert invulnerability
	Facc_SetInvulnerability(c.boss, false)

	EventSH.wait(e, 3*TICRATE, true)
end,
function(c,e)
	-- Advance Countdown
	Facc_AdvanceCrashCountdown()

	EventSH.start("facciolo_ph2_teleport", c)
end,})




EventSH.new("atk_megalaser", {
function(c,e)

	-- (Safe spawner)
	c.spawner = P_SpawnMobj(c.source.x, c.source.y, c.source.z, MT_PUSH)
	c.spawner.flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
	c.spawner.scale = c.spawnscale

	c.megalist = {}
end,
function(c,e)

	local seg = P_SpawnMobj(
		c.spawner.x,
		c.spawner.y,
		c.spawner.z,
		c.mobjtype or MT_PUSH)

	-- Set collision
	seg.radius = 45*FU
	seg.height = 45*FU
	seg.flags = (MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIP|MF_PAIN)

	seg.sprite = SPR_WTHK

	-- Adjust speed to scale
	local speed = FixedMul(c.firespeed, c.spawner.scale)

	seg.scale = c.spawner.scale

	-- Ignores destination and fires forward
	if c.forwardfire then
		c.dest = {
			x=c.source.x + P_ReturnThrustX(nil, c.source.angle + (c.forwardoffa or 0), 128*FU),
			y=c.source.y + P_ReturnThrustY(nil, c.source.angle + (c.forwardoffa or 0), 128*FU),
			z=c.source.z
		}
	end

	-- Set segment mobj momentum in the direction of the target
	local direction = R_PointToAngle2(c.spawner.x, c.spawner.y, c.dest.x, c.dest.y)
	local dx = FixedMul(speed, cos(direction))
	local dy = FixedMul(speed, sin(direction))
	seg.momx = dx
	seg.momy = dy

	-- Set seg z momentum in the direction of the target z position
	local dist = P_AproxDistance(c.dest.x - c.spawner.x, c.dest.y - c.spawner.y) / speed + 1
	seg.momz = (c.dest.z - c.spawner.z) / dist


	-- Removes the object based on distance from where it started converting the value to its fuse
	if c.firedist then
		c.fusetime =  EvActionSH.DistToTics(c.firedist, c.firespeed, seg.scale)
	else
		c.fusetime = c.firefuse
	end

	seg.tics = c.fusetime
	seg.fuse = c.fusetime

	-- Fun stuff
	seg.color = c.colors[(leveltime % #c.colors)+1]
	seg.renderflags = c.rendflags
	seg.blendmode = c.blendmode
	seg.spriteyoffset = $1 - 16*FU

	if (c.attachsource) then
		P_MoveOrigin(c.spawner, c.source.x, c.source.y, c.source.z) -- 2.2.11 Fix
	end
	-- for num = 1, #c.megalist do
	-- 	if (c.megalist[num] and c.megalist[num].valid) then

	-- 	end
	-- end

	EventSH.wait(e, c.firelength)
end,
function(c,e)
	c.spawner.fuse = 5
end,
})

function Silverhorn.FireMegaLaser(source, destination, speed, params)

	params = notnil($1, {})

	local t = {}
	-- Settings
	t["source"] = source
	t["safesource"] = false
	t["dest"] = {x=destination.x, y=destination.y, z=destination.z}
	t["destref"] = destination
	t["mobjtype"] = params.mobjtype or nil
	t["spawnscale"] = params.spawnscale or FRACUNIT
	t["firespeed"] = speed or FRACUNIT
	t["firefuse"] = params.firefuse or 256
	-- t["firedist"] = params.firedist or nil -- distance segments go by adjusting their fuse
	t["firedist"] = params.firedist or nil -- distance segments go from the source before automatically disappearing
	t["rendflags"] = params.rend or RF_FULLBRIGHT
	t["blendmode"] = params.blend or AST_COPY
	t["colors"] = params.colors or ColorShift_MegaLaser_Default
	t["firelength"] = params.length or 16
	t["attachsource"] = params.attachsource
	t["forwardfire"] = params.forwardfire
	t["forwardoffa"] = params.forwardoffa
	t["sprx"] = params.sprx
	t["spry"] = params.spry

	EventSH.start("atk_megalaser", t)
end



EventSH.new("facciolo_ph2_megalaser", {
function(c,e)
	-- Setup
	c.portmegalist = {}
	c.portmegalist_alt = {}
	c.fmegacolor_g = ColorShift_MegaLaser_GFlame
	c.mega_count = 1
	c.mega_repeat_count = 2
	c.mega_bc_set = 1
	c.mega_offsets = {}
end,
function(c,e)
	local loc = EvActionSH.coordinategetoffset(c, "msboss", 0, 0, 32*FU)

	-- Facc_DetachFocus()
	-- Facc_MoveFocusPoint(c.focuspoint, loc.x, loc.y, loc.z, 60*FU)

	Facc_Teleport(c.boss, true, loc.x, loc.y, loc.z)

	EventSH.wait(e, 3*TICRATE, true)
end,
function(c,e)
	Facc_ChargingUp(true, c.boss, ColorShift_Boss_MEGA)
	Silverhorn.SetFaccAnimation(c.boss, "charge")
	S_StartSound(nil, sfx_facftl)

end,
function(c,e)

	-- Set view 1
	Facc_ViewTargetDistance(512)
	Facc_ViewTargetHeight(300*FU)
	Facc_DetachFocus()

	-- Creation of master ports again
	for ang = 0, 360, 360/6 do
		local port = Facc_MakePortal(c.boss,
			P_ReturnThrustX(nil, FixedAngle(ang*FU), 420*FU),
			P_ReturnThrustY(nil, FixedAngle(ang*FU), 420*FU),
			-c.boss.height, 1, 3*FU, -32*FU)
		port.angle = $1 + ANGLE_180

		local frontpos = {
			x=port.x + P_ReturnThrustX(nil, port.angle-ANGLE_90, 1200*FU),
			y=port.y + P_ReturnThrustY(nil, port.angle-ANGLE_90, 1200*FU),
			z=c.boss.floorz
		}

		Facc_CreateWarningLine(port, port.angle - ANGLE_90, FU, 2000, 300, 2*TICRATE)

		-- TODO: the sequence handles this on its own, remove exitloc or set as nil
		table.insert(c.portmegalist, {port=port, exitloc=frontpos})
	end
	S_StartSound(nil, sfx_portop)

	local ref_transfer = EvActionSH.coordinategetoffset(c, "msboss", 0, 0, 720*FU)
	MobjMoverSH.moveto("faccmove", c.boss, ref_transfer, {speed=10*FU, ease="inoutback"})
end,
function(c,e)
	P_StartQuake(6*FU, 30)
	EventSH.wait(e, 2*TICRATE, true)
end,
function(c,e)
	-- Fully charged
	Facc_ChargingUp(false)
	Silverhorn.SetFaccAnimation(c.boss, "hold1")

	for _, mega in ipairs(c.portmegalist) do
		Silverhorn.FireMegaLaser(mega.port, mega.exitloc, 15*FU, {colors=ColorShift_MegaLaser_GFlame, length=4*TICRATE+20, firedist=3456*FU, forwardfire=true, forwardoffa=-ANGLE_90, spawnscale=8*FU, attachsource=true})
	end
	c.nocheese = P_SpawnMobj(c.boss.x, c.boss.y, c.boss.floorz, MT_GHOST)
	c.nocheese.fuse = 5*TICRATE+6
	c.nocheese.tics = 5*TICRATE+6
	S_StartSound(nil, sfx_portfr)
	P_StartQuake(96*FU, 15)
end,
function(c,e)
	-- round and around and around and around and around
	local center = EvActionSH.coordinategetoffset(c, "msboss", 0, 0, 300*FU)

	for _, mega in ipairs(c.portmegalist) do

		local vec = R_PointToAngle2(c.boss.x, c.boss.y, mega.port.x, mega.port.y)

		-- 2.2.11 Fix
		P_MoveOrigin(mega.port,
			c.boss.x + P_ReturnThrustX(nil, vec + FixedAngle(1*FU), 420*FU),
			c.boss.y + P_ReturnThrustY(nil, vec + FixedAngle(1*FU), 420*FU),
			mega.port.z)

		mega.port.angle = R_PointToAngle2(mega.port.x, mega.port.y, center.x, center.y) - ANGLE_90

	end
	-- no standing in the center to avoid this.
	P_RadiusAttack(c.nocheese, c.boss, 640*FU, DMG_SPIKE, false)
	P_StartQuake(32*FU, 8)
	EvActionSH.PlaySoundRate(nil, sfx_portlp, 28) -- SFX LOOP

	EventSH.wait(e, 5*TICRATE)
end,
function(c,e)
	-- Come back downth
	local ref_transfer = EvActionSH.coordinategetoffset(c, "msboss", 0, 0, 32*FU)
	MobjMoverSH.moveto("faccmove", c.boss, ref_transfer, {speed=15*FU, ease="inoutback"})
	EventSH.wait(e, 1*TICRATE, true)
end,
function(c,e)
	-- Close remaining (MEGA)
	for i=1, #c.portmegalist do
		c.portmegalist[i].port.destscale = 0
		c.portmegalist[i].port.scalespeed = FU/10
		c.portmegalist[i].port.fuse = 2*TICRATE
		S_StartSoundAtVolume(c.portmegalist[i].port, sfx_portcl, 40)
	end
	Silverhorn.SetFaccAnimation(c.boss, "idle")
	EventSH.wait(e, 1*TICRATE, true)
end,
-- ========================================
-- Site A
-- ========================================
function(c,e)
	-- A moment of nothing
	-- but it not nothing
	Facc_ChargingUp(true, c.boss, ColorShift_Boss_MEGA)
	Silverhorn.SetFaccAnimation(c.boss, "charge")
	-- S_StartSound(nil, sfx_facftl)

	-- Create big
	c.portmegalist = {}
	c.mega_offsets = {-1500, 0, 1500}

	local site_a = EvActionSH.coordinategetoffset(c, "msboss", 2600*FU, 0, 900*FU)
	site_a.valid = true

	for i = 1, #c.mega_offsets, 1 do
		local mega_site = Facc_MakePortal(site_a, 0, c.mega_offsets[i]*FU, 0, 1, 6*FU, -32*FU)
		mega_site.angle = EvActionSH.getlookangle(site_a, c.anchor_arena_center) + ANGLE_90
		table.insert(c.portmegalist, mega_site)
	end
	S_StartSound(nil, sfx_chrg4)


	-- Set view 2
	Facc_ViewTargetDistance(1024)
	Facc_ViewTargetHeight(300*FU)

	Facc_MoveFocusPoint(c.focuspoint, site_a.x, site_a.y, site_a.z, 30*FU, "inoutsine")
end,
function(c,e)
	P_StartQuake(32*FU, 8)
	EventSH.wait(e, 3*TICRATE, true)
end,
function(c,e)
	-- Set invlunerability
	Facc_SetInvulnerability(c.boss, false)
	EventSH.wait(e, 1*TICRATE, true)
end,
function(c,e)
	local faraway = EvActionSH.coordinategetoffset(c, "msboss", 0, 0, 2048*FU)

	Facc_Teleport(c.boss, true, faraway.x, faraway.y, faraway.z)
	Facc_ChargingUp(false)
	Facc_SetVisibility(c.boss, false)

	Silverhorn.SetFaccAnimation(c.boss, "throw")
end,
function(c,e)
	-- Get a target
	c.boss.target = Facc_GetNearbyTarget(c.anchor_arena_center, ARENA_2_RAD+600*FU)
end,
function(c,e)
	EventSH.settag(e, "repeat")
end,
function(c,e)
	Facc_VerifyTarget(c.boss)

	-- S_StartSound(nil, sfx_chrg3)
	S_StartSound(nil, sfx_portfr)
	P_StartQuake(20*FU, 8)
	Silverhorn.FireMegaLaser(c.portmegalist[c.mega_count], c.boss.target, 40*FU, {colors=c.fmegacolor_g, length=2*TICRATE, firedist=6000*FU, forwardoffa=-ANGLE_90, spawnscale=8*FU})

	-- Count
	c.mega_count = $1 + 1

	EventSH.wait(e, 10, true)
end,
function(c,e)
	EventSH.gototaguntil(e, "repeat", (c.mega_count > 3))
end,
function(c,e)
	-- Close A (FMEGA)
	for i=1, #c.portmegalist do
		c.portmegalist[i].destscale = 0
		c.portmegalist[i].scalespeed = FU/5
		c.portmegalist[i].fuse = 1*TICRATE
	end
	S_StartSound(nil, sfx_portcl)

	c.mega_offsets = {} -- Refresh
	-- ==============================================
end,
-- ========================================
-- Site B & C
-- ========================================
function(c,e)

	-- Open B & C
	c.portmegalist = {}
	c.mega_count = 1
	c.mega_offsets = {{-2460, -1500, -512, 515, 1500, 2460}, {4096, 2048, 1024, 0, -1024, -2048, -4096}}

	-- Set view
	Facc_ViewTargetDistance(1024)
	Facc_ViewTargetHeight(512*FU)

	local site_b = EvActionSH.coordinategetoffset(c, "msboss", 2600*FU, 0, -128*FU)
	Facc_MoveFocusPoint(c.focuspoint, site_b.x, site_b.y, site_b.z, 30*FU, "inoutsine")

end,
function(c,e)
	EventSH.settag(e, "repeat_site")
end,
function(c,e)
	local site_b = EvActionSH.coordinategetoffset(c, "msboss", 2600*FU, 0, -128*FU)
	site_b.valid = true

	for i = 1, #c.mega_offsets[c.mega_bc_set], 1 do
		local mega_site = Facc_MakePortal(site_b, 0, c.mega_offsets[c.mega_bc_set][i]*FU, 0, 1, 6*FU, -32*FU)

		mega_site.angle = EvActionSH.getlookangle(site_b, c.anchor_arena_center) + ANGLE_90

		Facc_CreateWarningLine(mega_site, mega_site.angle - ANGLE_90, FU, 5000, 800, 2*TICRATE)

		table.insert(c.portmegalist, mega_site)
	end

	-- Wait only on the first time
	if (c.mega_bc_set == 1) then
		EventSH.wait(e, 2*TICRATE, true)
	elseif (c.mega_bc_set == 2) then
		EventSH.wait(e, 1*TICRATE+10, true)
	end
end,
function(c,e)
	EventSH.settag(e, "repeat_bc")
end,
function(c,e)
	-- Line Fire
	S_StartSound(nil, sfx_portfr)
	P_StartQuake(20*FU, 8)
	Silverhorn.FireMegaLaser(c.portmegalist[c.mega_count], c.boss, 40*FU, {colors=c.fmegacolor_g, length=1*TICRATE+15, firedist=6000*FU, forwardfire=true, forwardoffa=-ANGLE_90, spawnscale=11*FU})

	-- Count
	c.mega_count = $1 + 1

	EventSH.wait(e, 6, true)
end,
function(c,e)
	EventSH.gototaguntil(e, "repeat_bc", (c.mega_count > #c.mega_offsets[c.mega_bc_set]))
end,
function(c,e)
	-- Close BC (FMEGA)
	for i=1, #c.portmegalist do
		c.portmegalist[i].destscale = 0
		c.portmegalist[i].scalespeed = FU/2
		c.portmegalist[i].fuse = 2*TICRATE
	end
	S_StartSound(nil, sfx_portcl)
	c.portmegalist = {}

	-- Count
	c.mega_repeat_count = $1 - 1
	c.mega_bc_set = $1 + 1
	c.mega_count = 1

	EventSH.gototaguntil(e, "repeat_site", (c.mega_repeat_count == 0))
end,
function(c,e)
	-- Reset view
	Facc_ViewTargetDistance(nil)
	Facc_ViewTargetHeight(nil)

	-- Revert invulnerability
	Facc_SetInvulnerability(c.boss, false)

	Facc_SetVisibility(c.boss, true)

	Facc_MoveFocusPoint(c.focuspoint, c.anchor_arena_center.x, c.anchor_arena_center.y, c.anchor_arena_center.z, 35*FU, "inoutsine")
	Facc_Teleport(c.boss, false, c.anchor_arena_center.x, c.anchor_arena_center.y, c.anchor_arena_center.z)

	EventSH.wait(e, 3*TICRATE, true)
end,
function(c,e)
	-- Advance Countdown
	Facc_AdvanceCrashCountdown()

	EventSH.start("facciolo_ph2_teleport", c)
end,})





states[S_CCH_TORCH] = {SPR_NULL, A, 1, function(mo)
	if mo.valid then
		if not mo.spawnrate then mo.spawnrate = 6 end
		if not mo.fuserate then mo.fuserate = 2*TICRATE end
		if not mo.last_stand then mo.last_stand = false end

		mo.scale = Ph2_CrashCountdown_Scale

		if leveltime % mo.spawnrate == 0 then
			local flm = P_SpawnGhostMobj(mo)
			flm.sprite = SPR_FFLF
			flm.blendmode = AST_ADD
			flm.momz = -4*FU
			flm.destscale = 0
			flm.scalespeed = FU/32
			flm.fuse = mo.fuserate
			flm.momx = 2*cos(FixedAngle(3*FU) * leveltime)
			flm.momy = 2*sin(FixedAngle(3*FU) * leveltime)
			flm.colorized = true
			flm.color = mo.color
		end
		if mo.last_stand and leveltime % 5 == 0 then
			local flare = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_PUSH)
			flare.sprite = SPR_FTHK
			flare.spriteyoffset = -16*FU
			flare.frame = 1 | FF_TRANS60
			flare.color = SKINCOLOR_CRIMSON
			flare.scale = 1
			flare.destscale = 32*FU
			flare.scalespeed = FU
			flare.fuse = 10
			flare._facc2 = true -- Set as boss object
		end
	end
end, 0, 0, S_CCH_TORCH}


-- Shows a visual countdown in the arena
EventSH.new("arena_crash_countdown", {
function(c,e)
	-- (Signaling this the first time starts the actual visual countdown, while the rest count or loop it)
	EventSH.waitSignal(e, "trigger_crash_countdown")
end,
function(c,e)
	-- Setup
	c.crash_mobjs = {}
	c.crash_countdown = 3
	c.crash_colors = {
		SKINCOLOR_CRIMSON,
		SKINCOLOR_APRICOT,
		SKINCOLOR_SEAFOAM,
	}
end,
function(c,e)
	EventSH.setloop(e, "reset_countdown")
end,
function(c,e)
	-- Create three torches in the arena
	-- if (c.crash_countdown == 4) then
		for i = 256, 768, 768/3 do
			local lit = P_SpawnMobj(
				c.anchor_arena_center.x + P_ReturnThrustX(nil, FixedAngle(i*FU), 512*FU),
				c.anchor_arena_center.y + P_ReturnThrustY(nil, FixedAngle(i*FU), 512*FU),
				c.anchor_arena_center.z + 768*FU,
				MT_PUSH
			)
			lit.state = S_CCH_TORCH
			lit.color = c.crash_colors[3]
			lit._facc2 = true -- Set as boss object
			table.insert(c.crash_mobjs, lit)
		end
	-- end
end,
function(c,e)
	EventSH.setloop(e, "reduce_count")
end,
function(c,e)
	-- Trigger a mobj removal/reset
	EventSH.waitSignal(e, "trigger_crash_countdown")
end,
function(c,e)
	-- Reset countdown if done
	if not (c.crash_countdown > 0) then
		c.crash_countdown = 3
		c.crash_mobjs = {}
		EventSH.gotoloop(e, "reset_countdown")
	end
end,
function(c,e)
	-- Remove a torch
	for i = 1, #c.crash_mobjs, 1 do

		if (c.crash_countdown == i) then
			local cach_lt = c.crash_mobjs[i]
			cach_lt.fuse = 5
			table.remove(c.crash_mobjs, i)
		end
	end
	-- Alert sound
	for i = 1, 3, 1 do
		S_StartSound(nil, sfx_tlosth)
	end
	-- Count
	c.crash_countdown = $1-1

	-- Set new warning color...
	for i = 1, #c.crash_mobjs, 1 do
		c.crash_mobjs[i].color = c.crash_colors[c.crash_countdown]
	end
end,
function(c,e)
	-- Return to waiting
	EventSH.gotoloop(e, "reduce_count")
end})


EventSH.new("PH2PORT__DM_COUNTER", {
function(c,e)
	-- New settings
	c.fill_effect = $1 or false
	c.fill_waitingtime = $1 or 0
	c.skipmassfade = $1 or false
	c.mass_speed = $1 or (2*FU)
	c.mass_waittime = $1 or (1*TICRATE)
	c.mass_fuse = $1 or (2*TICRATE)
	c.mass_sfx = $1 or nil
	-- =============

	c.transvalue = 0
	c.dmd_state_timer = 0

	S_StartSound(nil, sfx_dmdcol)

	c.mass = P_SpawnMobjFromMobj(c.mobj, 0, 0, 0, MT_PUSH)
	c.mass.tics = 35*TICRATE
	c.mass.sprite = SPR_FTHK
	c.mass.spriteyoffset = -16*FU
	c.mass.color = SKINCOLOR_WHITE
	c.mass.frame = B | FF_TRANS60
	c.mass.scale = 32*FU
	c.mass._facc2 = true -- Set as boss object

end,
function(c,e)
	EventSH.wait(e, 1)
end,
function(c,e)
	c.mass.destscale = 1
	c.mass.scalespeed = FU/2
	c.transvalue = 10
end,
function(c,e)

	if c.dmd_state_timer % 5 == 0 then
		c.transvalue = max(1, $1 - 1)
	end
	c.mass.frame = B | (c.transvalue << FF_TRANSSHIFT)

	c.dmd_state_timer = $1 + 1

	EventSH.wait(e, 64)
end,
function(c,e)
	P_StartQuake(64*FRACUNIT, 7)
	c.mass.frame = R_Char2Frame("A")
	c.mass.color = SKINCOLOR_BLACK

	c.mass.destscale = 200*FU
	c.mass.scalespeed = c.mass_speed + FU/100

	-- (New: play a sound on mass change)
	if c.mass_sfx then S_StartSound(nil, c.mass_sfx) end

	EventSH.wait(e, c.mass_waittime, true)
end,
function(c,e)
	c.mass.fuse = c.mass_fuse

	if c.skipmassfade then return end -- Skip this part

	c.mass.color = SKINCOLOR_BLACK

	if c.dmd_state_timer % 5 == 0 then
		c.transvalue = min($1 + 1, 11)
	end
	c.mass.frame = B | (c.transvalue << FF_TRANSSHIFT)

	c.dmd_state_timer = $1 + 1
	-- c.mass.fuse = --2*TICRATE

	EventSH.wait(e, 64)
end,
function(c,e)
	-- Extra settings post-port
	if not c.fill_effect then return end
	EvActionSH.fadescreen("full", 31, 1)
end,
function(c,e)
	if not c.fill_effect then return end
	EventSH.wait(e, c.fill_waitingtime)
end,
function(c,e)
	if not c.fill_effect then return end
	EvActionSH.fadescreen("clear")
end,})


states[S_LSTND_HOLE] = {SPR_NULL, A, 1, function(mo)
	if mo.valid then
		mo.scale = FU*5
		mo.renderflags = $1 | RF_ABSOLUTEOFFSETS
		mo.sprite = SPR_FTHK
		mo.spritexoffset = 20*FU
		mo.spriteyoffset = 20*FU
		mo.color = SKINCOLOR_JET

		-- Particle 1
		if leveltime % 8 == 0 then
			for iter = 1, 2, 1 do
				-- local wave = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				local wave = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_PUSH)
				wave.renderflags = $1 | (iter == 2 and (RF_ABSOLUTEOFFSETS | RF_FLOORSPRITE) or (RF_ABSOLUTEOFFSETS))
				wave.sprite = SPR_FTHK
				wave.blendmode = AST_REVERSESUBTRACT
				wave.spritexoffset = 20*FU
				wave.spriteyoffset = 20*FU
				wave.frame = 0 | FF_TRANS30
				wave.color = SKINCOLOR_BLACK
				wave.scale = 50*FU
				wave.destscale = 0
				wave.scalespeed = 2*FU
				wave.fuse = 35
				wave._facc2 = true -- Set as boss object
			end
		end

		-- Particle 2
		if leveltime % 1 == 0 then
			local color = {SKINCOLOR_MAGENTA, SKINCOLOR_SEAFOAM, SKINCOLOR_AETHER, SKINCOLOR_CERULEAN, SKINCOLOR_GREY}
			local rx = P_RandomRange(-1024, 1024)*FU
			local ry = P_RandomRange(-1024, 1024)*FU
			local rz = P_RandomRange(-1024, 1024)*FU
			local rc = P_RandomRange(1, #color)

			local bhfx = P_SpawnMobj(mo.x + rx, mo.y + ry, mo.z + rz, MT_PUSH)
			bhfx.sprite = SPR_FTHK
			bhfx.color = color [rc]
			bhfx.scale = 2*FU
			bhfx.flags = $1 | (MF_NOCLIP|MF_NOCLIPHEIGHT)
			bhfx._facc2 = true -- Set as boss object

			local fxdist = R_PointToDist2(bhfx.x, bhfx.y, mo.x, mo.y)
			local fxang = R_PointToAngle2(bhfx.x, bhfx.y, mo.x, mo.y)

			bhfx.angle = fxang
			P_InstaThrustZ(bhfx, mo, 32*FU)

			bhfx.fuse = EvActionSH.DistToTics(fxdist, 32*FU, bhfx.scale)
		end

		-- -- Particle 3
		-- if leveltime % 18 == 0 then
		-- 	for i = 0, 360, 360/32 do
		-- 		local pulled = P_SpawnMobj(
		-- 		mo.x + P_ReturnThrustX(nil, FixedAngle(i*FU), 1640*FU),
		-- 		mo.y + P_ReturnThrustY(nil, FixedAngle(i*FU), 1640*FU),
		-- 		mo.floorz + 4*FU, MT_PUSH)
		-- 		pulled.scale = FU
		-- 		pulled.sprite = SPR_FTHK
		-- 		local plldist = R_PointToDist2(pulled.x, pulled.y, mo.x, mo.y)
		-- 		local pllang = R_PointToAngle2(pulled.x, pulled.y, mo.x, mo.y)
		-- 		pulled.angle = pllang
		-- 		pulled.color = SKINCOLOR_GREY
		-- 		P_InstaThrust(pulled, pulled.angle, 32*FU)
		-- 		pulled.fuse = EvActionSH.DistToTics(plldist, 32*FU, pulled.scale)-32
		-- 	end
		-- end
		-- TODO: Move into library
		local speed = 30*FU
		for player in players.iterate do
				local pmo = player.mo
				if not pmo then continue end

			if Facc_IsInBounds({x=ARENA_2_CENTER.x, y=ARENA_2_CENTER.y, z=ARENA_2_CENTER.z}, pmo, 0*FU, ARENA_2_RAD+600*FU) then

				local xDist = mo.x - pmo.x
				local yDist = mo.y - pmo.y
				local dist = FixedHypot(xDist, yDist)

				if dist < speed then
					P_TryMove(pmo, mo.x, mo.y, true)
					continue
				end

				xDist = FixedMul(FixedDiv($, dist), speed)
				yDist = FixedMul(FixedDiv($, dist), speed)

				P_TryMove(pmo, pmo.x + xDist, pmo.y + yDist, true)
			end
		end
	end
end, 0, 0, S_LSTND_HOLE}


EventSH.new("atk_mindcrash", {
function(c,e)
	-- Setup
	c.statetimer = 0
	c.temp_c = P_SpawnMobj(c.damagelocation.x, c.damagelocation.y, c.damagelocation.z, MT_THOK)
	c.temp_c.state = S_INVISIBLE
	c.temp_c.fuse = 10*TICRATE
end,
-- function(c,e)
-- 	EvActionSH.setplayerviewroll(c.player, FixedAngle(1*FU), true)
-- 	Event.wait(e, 2*TICRATE)
-- end,
function(c,e)
	-- Invalid, quit early
	if not (c.player and c.player.valid) then return end

	if (c.statetimer % 5 == 0) then
		local rx = P_RandomRange(-256, 256)*FU
		local ry = P_RandomRange(-256, 256)*FU
		local rz = P_RandomRange(-96, 96)*FU
		local rs = P_RandomRange(1, 4)*FU
		c.explosion = P_SpawnMobj(c.damagelocation.x + rx, c.damagelocation.y + ry, c.damagelocation.z + rz, MT_SONIC3KBOSSEXPLODE)
		c.explosion.scale = rs
		S_StartSound(c.explosion, sfx_s3kb4, c.player)
		S_StartSound(c.explosion, sfx_s3k4e, c.player)
		P_StartQuake(16*FU, 6)
	end

	if (c.statetimer % 20 == 0)then
		local rand_c_angle = P_RandomRange(0, 360)
		local rand_c_dist = P_RandomRange(128, 380)
		local rz = P_RandomRange(-32, 32)*FU
		EvActionSH.setcamera(c.player, c.temp_c, {
			x=c.damagelocation.x + P_ReturnThrustX(nil, FixedAngle(rand_c_angle*FU), rand_c_dist*FU),
			y=c.damagelocation.y + P_ReturnThrustY(nil, FixedAngle(rand_c_angle*FU), rand_c_dist*FU),
			z=c.damagelocation.z+rz}, 0, 0)
		EvActionSH.cameratrack(c.player, c.temp_c, c.damagelocation)
	end

	-- Set player still
	c.player.mo.state = S_PLAY_PAIN
	EvActionSH.movemobjto(c.player.mo, c.damagelocation)
	c.player.powers[pw_nocontrol] = 1*TICRATE
	c.player.mo.momx = 0
	c.player.mo.momy = 0
	c.player.mo.momz = 0

	-- Remove health
	if c.statetimer % 40 == 0 then
		c.player.rings = $1 - 1
	end

	c.statetimer = $1 + 1

	EventSH.wait(e, 6*TICRATE)
end,
function(c,e)
	-- Invalid, quit early
	if not (c.player and c.player.valid) then return end

	if (c.player.rings <= 0) then
		P_KillMobj(c.player.mo, nil, nil, DMG_INSTAKILL)
	else
		-- Eject survivors
		P_FlashPal(c.player, 1, 5)
		local randomrot = P_RandomRange(0, 360)
		local pointangle = R_PointToAngle2(c.player.mo.x, c.player.mo.y, c.originpoint.x, c.originpoint.y)
		local returnposition = {
			x=c.originpoint.x + P_ReturnThrustX(nil, FixedAngle(randomrot*FU), 900*FU),
			y=c.originpoint.y + P_ReturnThrustY(nil, FixedAngle(randomrot*FU), 900*FU),
			z=c.originpoint.z + 32*FU,
		}
		EvActionSH.movemobjto(c.player.mo, returnposition)
		c.player.mo.angle = pointangle
		c.player.drawangle = pointangle
		P_InstaThrust(c.player.mo, c.player.mo.angle + ANGLE_180, 120*FU)
		c.player.momz = 15*FU
		c.player.mo.state = S_PLAY_PAIN
		c.player.powers[pw_nocontrol] = 1
		EvActionSH.stopcameraview(c.player)
	end
end})

EventSH.new("facciolo_ph2_mindcrash", {
function(c,e)
	-- Setup
	c.crash_colliders = {}
end,
function(c,e)
	local loc = EvActionSH.coordinategetoffset(c, "msboss", 0, 0, 70*FU)

	Facc_Teleport(c.boss, true, loc.x, loc.y, loc.z)

	EventSH.wait(e, 4*TICRATE, true)
end,
function(c,e)
	Facc_ChargingUp(true, c.boss, ColorShift_Boss_Crash)
	Silverhorn.SetFaccAnimation(c.boss, "charge")

	-- Set view
	Facc_DetachFocus()
	-- Facc_ViewTargetDistance(256)
	-- Facc_ViewTargetHeight(32*FU)
end,
function(c,e)
	-- Create bigger unlit torches
	for i = 0, 360, 360/3 do
		local lit = P_SpawnMobj(
			c.anchor_arena_center.x + P_ReturnThrustX(nil, FixedAngle(i*FU), 720*FU),
			c.anchor_arena_center.y + P_ReturnThrustY(nil, FixedAngle(i*FU), 720*FU),
			c.anchor_arena_center.z + 512*FU,
			MT_PUSH)
		-- State exclusive settings
		lit.spawnrate = 1
		lit.fuserate = 20
		lit.last_stand = true
		lit.state = S_CCH_TORCH
		lit.color = SKINCOLOR_KETCHUP
		lit.angle = R_PointToAngle2(lit.x, lit.y, c.anchor_arena_center.x, c.anchor_arena_center.y) + ANGLE_180
		lit._facc2 = true -- Set as boss object

		MobjMoverSH.moveto("move_torch", lit,
			{x=lit.x + P_ReturnThrustX(nil, lit.angle, 1500*FU), y=lit.y + P_ReturnThrustY(nil, lit.angle, 1900*FU), z=lit.z},
			{verta=-512*FU, ease="inquad", speed=60*FU}, true)

		table.insert(c.crash_colliders, lit)
	end
	P_FadeLight(Arena_Sky_Light_TagID, 128, 3*TICRATE, true, true)
end,
function(c,e)
	EventSH.wait(e, 2*TICRATE, true)
end,
function(c,e)
	-- Remove boss from arena temporarily
	local faraway = EvActionSH.coordinategetoffset(c, "msboss", 0, 0, 2048*FU)

	Facc_Teleport(c.boss, true, faraway.x, faraway.y, faraway.z)
	Facc_ChargingUp(false)
end,
function(c,e)
	EventSH.start("PH2PORT__DM_COUNTER", {mobj=c.boss})
	for i = 1, #c.crash_colliders, 1 do

		MobjMoverSH.moveto("move_torch", c.crash_colliders[i],
			{x=c.anchor_arena_center.x, y=c.anchor_arena_center.y, z=c.anchor_arena_center.z},
			{verta=2048*FU, ease="inquad", speed=40*FU}, true)
		c.crash_colliders[i].fuse = 3*TICRATE
	end
end,
function(c,e)
	Facc_SetVisibility(c.boss, false)
	EventSH.wait(e, 2*TICRATE, true)
end,
function(c,e)
	c.blackhole = P_SpawnMobj(c.anchor_arena_center.x, c.anchor_arena_center.y, c.anchor_arena_center.z+64*FU, MT_PUSH)
	c.blackhole.state = S_LSTND_HOLE
	c.blackhole._facc2 = true -- Set as boss object
end,
function(c,e)
	-- Check for players touching 200 units near the center
	EvActionSH.doforall(function(p)
		if Facc_IsInBounds(c.anchor_arena_center, p.mo, 0*FU, 200*FU) then

			-- Player was caught
			local void_loc = {x=c.anchor_arena_void.x,y=c.anchor_arena_void.y,z=c.anchor_arena_void.z + 40*FU}
			EvActionSH.movemobjto(p.mo, void_loc)

			EventSH.start("atk_mindcrash", {player=p, damagelocation=void_loc, originpoint=c.anchor_arena_center})
			return
		end
	end)

	EventSH.wait(e, 8*TICRATE)
end,
function(c,e)
	-- Wait for anyone else to be ejected before continuing
	EventSH.waitUntil(e, not EventSH.exists("atk_mindcrash"))
end,
function(c,e)
	-- print("Success!")
	c.blackhole.fuse = 1
	P_FadeLight(Arena_Sky_Light_TagID, 216, 1*TICRATE, true, true)
end,
function(c,e)
	EventSH.wait(e, 1*TICRATE)
end,
function(c,e)
	-- Return to origin
	local returntocenter = EvActionSH.coordinategetoffset(c, "msboss", 0, 0, 0)
	EvActionSH.movemobjto(c.boss, returntocenter)

	-- Revert invulnerability
	Facc_SetInvulnerability(c.boss, false)
	Facc_SetVisibility(c.boss, true)

end,
function(c,e)
	EventSH.wait(e, 2*TICRATE)
end,
function(c,e)
	-- Reset view and focus
	Facc_ViewTargetDistance(nil) -- clear distance
	Facc_AttachFocus(c.focuspoint, c.boss)

	-- Start the cycle anew...
	EventSH.start("facciolo_ph2_teleport", c)
end})




EventSH.new("ph2_final_d", {
function(c,e)

	EventSH.destroygroup({
		-- "facciolo_ph2_setinvuln",
		-- "facciolo_chargeparticle",
		-- "facciolo_moving",
		-- "facciolo_transformparticle",
		-- "facciolo_transformrumble",
		-- "_facc_attach_focus",
		-- "_facc_move_focus",
		-- "_facc_move_teleport",
		-- "object_focus",
		"IS_FACCIOLO_IN_BOUNDS?",
		"arena_check",
		"PH2PORT__DM_COUNTER",
		"arena_crash_countdown",
		"atk_",
		"facciolo_ph2_",
		"facciolo_",
		-- "facciolo_ph2_setup",
		-- "facciolo_ph2_1",
	}, {find=true})

	-- Clean up all objects
	for mo in mobjs.iterate() do
		if mo.valid and mo._facc2 then
			mo.tics = 1
			mo.fuse = 1
		end
	end
	-- TODO
	-- Silverhorn.CleanupFacc2()

	-- Move back to the center
	EvActionSH.coordinateanchor(c, "msboss", ARENA_2_CENTER.x, ARENA_2_CENTER.y, ARENA_2_CENTER.z)
	c.anchor_arena_center = EvActionSH.coordinategetoffset(c, "msboss", 0, 0, 0)
	EvActionSH.coordinateanchor(c, "msboss_void", ARENA_2_VOID.x, ARENA_2_VOID.y, ARENA_2_VOID.z)
	c.anchor_arena_void = EvActionSH.coordinategetoffset(c, "msboss_void", 0, 0, 0)
	-- ====

	-- Remove anyone still trapped in the void
	EvActionSH.doforall(function(p)
		if (Facc_IsInBounds(c.anchor_arena_void, p.mo, 0, 1024*FU)) then
			EvActionSH.movemobjto(p.mo, EvActionSH.coordinategetoffset(c, "msboss_void", 1360*FU, 0, 0))
		end
	end)

	-- Camera focus
	c.focuspoint = Facc_CreateFocusPoint(c.boss, FRACUNIT*TICRATE)
	c.focuspoint.state = S_INVISIBLE
	Facc_ViewTarget(true, c.focuspoint)

	-- Reset view settings
	Facc_ViewTargetDistance(nil)
	Facc_ViewTargetHeight(nil)
	Facc_AttachFocus(c.focuspoint, c.boss)
	EvActionSH.setplayerviewroll(true, 0)
	EvActionSH.fadescreen("in", 1, 2)

	EvActionSH.SetCurrentMusic(true, "", true)
	EvActionSH.SetMapMusicFlags("reload")

	Silverhorn.SetFaccAnimation(c.boss, "idle")
	Facc_SetInvulnerability(c.boss, true)
	MobjMoverSH.stop("faccmove")
	Facc_ResetMomentum(c.boss)

	S_StartSound(nil, sfx_kboom1)

	-- Freeze all player positions temporarily
	EvActionSH.FreezePlayers(EvActionSH.createplayerlist())

	P_StartQuake(16*FU, 40)
end,
function(c,e)
	-- Reset Levels and remove custom FOF
	P_FadeLight(Arena_Sky_Light_TagID, 216, 1*TICRATE, true, true)
	P_LinedefExecute(5011)
	EventSH.wait(e, 2*TICRATE, true)
end,
function(c,e)
	-- Unfreeze players
	EvActionSH.UnfreezePlayers()


	Facc_Teleport(c.boss, true, c.anchor_arena_center.x, c.anchor_arena_center.y, c.anchor_arena_center.z)

	c.finaldeathstate_timer = 0
	c.finaldeathstate_timer_multiplier = 1
	c.finaldeathstate_angle = 0
	c.finaldeathstate_angle_multiplier = 0
	c.finaldeath_mobjs = {}

end,
function(c,e)
	EventSH.waitSignal(e, "warp_finished")
end,
function(c,e)
	-- Set final animation
	Silverhorn.SetFaccAnimation(c.boss, "defeat1")

	MobjMoverSH.moveto("faccmove", c.boss, {x=c.boss.x,y=c.boss.y,z=c.boss.z+512*FU}, {speed=5*FU, ease="insine"})
end,
function(c,e)
	if c.finaldeathstate_timer % max(1, 8 - c.finaldeathstate_timer_multiplier) == 0 then
		local lite = P_SpawnMobj(c.boss.x, c.boss.y, (c.boss.z + c.boss.height/2), MT_PUSH)
		lite.sprite = SPR_FMFR
		lite.blendmode = AST_ADD
		lite.frame = 0 | FF_TRANS20
		lite.scale = 0
		lite.destscale = (c.finaldeathstate_timer_multiplier * 4)*FU
		-- lite.destscale = 16*FU
		lite.scalespeed = 5*FU
		lite.rollangle = FixedAngle((c.finaldeathstate_angle + c.finaldeathstate_angle_multiplier)*FU)

		S_StartSound(nil, sfx_kchg5)

		c.finaldeathstate_angle = $1 + 45

		table.insert(c.finaldeath_mobjs, lite)
	end

	if c.finaldeathstate_timer % 45 == 0 then
		c.finaldeathstate_angle_multiplier = $1 + 64
		c.finaldeathstate_timer_multiplier = $1 + 1
	end

	for _, litemo in ipairs(c.finaldeath_mobjs) do
		EvActionSH.movemobjto(litemo, {x=c.boss.x, y=c.boss.y, z=(c.boss.z + c.boss.height/2)})
	end

	P_StartQuake((c.finaldeathstate_timer_multiplier * 6)*FU, 10)

	c.finaldeathstate_timer = $1 + 1

	EventSH.wait(e, 5*TICRATE)
end,
function(c,e)
	-- Prepare view
	Facc_DetachFocus()
	EvActionSH.fadescreen("full", 0, 4)
	S_StartSound(nil, sfx_dbboom)

	EventSH.wait(e, 1*TICRATE+5, true)
end,
function(c,e)
	for _, litemo in ipairs(c.finaldeath_mobjs) do
		litemo.fuse = 1
	end
	c.finaldeath_mobjs = {}

	local lite_ring = P_SpawnMobj(c.boss.x, c.boss.y, (c.boss.z + c.boss.height/2), MT_THOK)
	lite_ring.sprite = SPR_FMFR
	lite_ring.blendmode = AST_ADD
	lite_ring.frame = R_Char2Frame("B") | FF_TRANS20
	lite_ring.scale = 1
	lite_ring.destscale = 64*FU
	lite_ring.scalespeed = FU/3
	lite_ring.renderflags = RF_FLOORSPRITE
	lite_ring.momz = 9*FU
	lite_ring.tics = 3*TICRATE

	-- Change animation and swap him out
	Silverhorn.SetFaccAnimation(c.boss, "defeat2")
	EvActionSH.movemobjto(c.boss, {x=c.anchor_arena_center.x, y=c.anchor_arena_center.y, z=c.anchor_arena_center.z+3600*FU})

	EvActionSH.Sq_CreateActor(c, "facciolo_down", nil, SPR_FACC, 4*FU, 6*FU, SKINCOLOR_SLATE, function(mofac) mofac.frame = R_Char2Frame("O") end)
	EvActionSH.movemobjto(c.ac_facciolo_down, {x=c.anchor_arena_center.x, y=c.anchor_arena_center.y, z=c.anchor_arena_center.z})

	P_StartQuake(32*FU, 3*TICRATE)

	Facc_MoveFocusPoint(c.focuspoint, c.ac_facciolo_down.x, c.ac_facciolo_down.y, c.ac_facciolo_down.z+32*FU, 4*FU)

	EvActionSH.fadescreen("in", 0, 6)
end,
function(c,e)
	EventSH.start("ev_kemonee_intro", c)
end})