-- ============================================================
-- Mindscape
-- Collapse
-- by Altalune
-- ============================================================

local FCS_TRAVELSPEED = 120*FU --180
local lobo_colormap = {SKINCOLOR_MINT, SKINCOLOR_MINT, SKINCOLOR_AQUA, SKINCOLOR_AQUA, SKINCOLOR_TEAL, SKINCOLOR_TEAL, SKINCOLOR_MAGENTA, SKINCOLOR_ROSY}
local lobo_laststand_delay_1 = 20
local lobo_laststand_delay_2 = 15
local lobo_laststand_delay_3 = 5

freeslot(
	-- Sounds
    "sfx_bxdmg",
    "sfx_bxhxf",
	"sfx_srbht",
	"sfx_facde2",
    "sfx_hxexit",
	-- Helper States
	"S_UL_HOLOGUIDE",
	-- Projectile States
	"MT_UNA_FORCE", -- Barrier
	"S_UNA_FORCE_SPAWN",
	"S_UNA_FORCE_INIT",
	"S_UNA_FORCE_BLOCK",
	"S_UNA_FORCE_BREAKDELAY",
	"S_UNA_FORCE_BREAK1",
	"S_UNA_FORCE_BREAK2",
	"S_UNA_FORCE_BREAK3",
	"S_UNA_FORCE_BREAK4",
	"S_UNA_FORCE_BREAK5",
	"S_UNA_FORCE_BREAK6",
	"MT_UNA_HEXWALL", -- Hex Barrier
	"S_HEXWALL_INIT",
	"S_HEXWALL_CREATION",
	"S_HEXWALL_BLOCK",
	-- Boss States
	"S_LOBOSHADOW", -- Boss 3
	"S_LOBOSHADOW_STANDBY",
	"S_LOBOSHADOW_EXIT",
	"S_LOBOSHADOW_DISPERSE",
	"S_LOBOSHADOW_REFORM",
	"S_LOBOSHADOW_SHOCK",
	"S_LOBOSHADOW_DEAD1",
	"S_LOBOSHADOW_DEAD2",
	"S_HEXWALL_SETDISP",
	"SPR_ULSB"
)
sfxinfo[sfx_bxhxf].caption = "Barrier Piece Forming"
sfxinfo[sfx_bxdmg].caption = "Barrier Broken [KRTD]"
sfxinfo[sfx_srbht].caption = "Boss Defeat [Sonic Rush]"
sfxinfo[sfx_facde2].caption = "Facciolo death yell"
sfxinfo[sfx_hxexit].caption = "Story portal closure"


local HEXAMOUNT = 10
local HEXSPAWNSOUND = sfx_bxhxf
local HEXDESTROYSOUND = sfx_bxdmg








-- Ultimate transform hologram guide
states[S_UL_HOLOGUIDE] = {SPR_THOK, A, 1, function(mo)
	if mo.valid then
		mo.color = SKINCOLOR_CYAN
		mo.colorized = true
		mo.skin = "inazuma"
		mo.sprite = SPR_PLAY
		mo.sprite2 = SPR2_WAIT
		mo.scale = 2*FU
		mo.frame = $1|TR_TRANS50|FF_FULLBRIGHT

		-- State Action
		if leveltime % 140 == 0 then
			local br = P_SpawnMobj(mo.x, mo.y, mo.z + FixedDiv(mo.height, 2*FU), MT_THOK)
			br.tics = 100
			br.fuse = 100
			br.scale = 0
			br.destscale = FixedMul(mo.scale, FU)
			br.scalespeed = FU/20
			br.state = S_INAZUMA_BARRIER
			br.color = SKINCOLOR_SKY
			br.frame = $1 | TR_TRANS50
			br.spriteyoffset = $1 + 32*FU
		end
		if leveltime % 15 == 0 then
			local hol = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			hol.tics = 100
			hol.fuse = 100
			hol.scale = FixedMul(mo.scale, FU/2)
			hol.scalespeed = FU/20
			hol.destscale = 0
			hol.momz = -3*FU
			hol.color = SKINCOLOR_SKY
		end
	end
end, 0, 0, S_UL_HOLOGUIDE}


-- --------------------
-- Hex Field Core
-- --------------------
mobjinfo[MT_UNA_FORCE] = {
	doomednum = -1,
	spawnstate = S_UNA_FORCE_SPAWN,
	painstate = S_UNA_FORCE_BREAK1,
	deathstate = S_UNA_FORCE_BREAK1,
	spawnhealth = 20,
	radius = 320*FU, -- 100*FU
	height = 320*FU, -- 100*FU (200)
	flags = MF_NOGRAVITY|MF_SHOOTABLE|MF_NOCLIP|MF_NOCLIPHEIGHT
}

-- ==== Spawnstate Executor ====
-- \\ Spawn & Setup effect \\
states[S_UNA_FORCE_SPAWN] = {SPR_NULL, A, 1, nil, 0, 0, S_UNA_FORCE_INIT}
states[S_UNA_FORCE_INIT] = {SPR_NULL, A, 1, function(mo)
	-- Execute a linedef tag if one was attached to this object
	if mo.spawnexectag then
		-- print("Object Spawn Tag: " .. mo.spawnexectag)
		P_LinedefExecute(mo.spawnexectag)
	end
end, 0, 0, S_UNA_FORCE_BLOCK}

-- \\ Main standby \\
states[S_UNA_FORCE_BLOCK] = {SPR_ULSB, A|FF_FULLBRIGHT, 1, nil, 0, 0, S_UNA_FORCE_BLOCK}

-- ==== Deathstate Executor ====
-- \\ Break Delay \\
states[S_UNA_FORCE_BREAKDELAY] = {SPR_ULSB, A|FF_FULLBRIGHT, 1, nil, 0, 0, S_UNA_FORCE_BREAK1}
-- \\ Break \\
states[S_UNA_FORCE_BREAK1] = {SPR_RADF, A|FF_FULLBRIGHT, 3, function(mo)
	-- Destroy all attached objects on object end
	for i=1, #mo.fieldcluster do
		local mfc = mo.fieldcluster[i]
		mfc.state = S_HEXWALL_SETDISP
	end
	-- Play sound
	S_StartSound(nil, HEXDESTROYSOUND)

	-- Execute a linedef tag if one was attached to this object
	if mo.boomexectag then
		P_LinedefExecute(mo.boomexectag)
	end
end, 0, 0, S_UNA_FORCE_BREAK2}

-- ==== Break ====
states[S_UNA_FORCE_BREAK2] = {SPR_RADF, B|FF_FULLBRIGHT, 3, nil, 0, 0, S_UNA_FORCE_BREAK3}
states[S_UNA_FORCE_BREAK3] = {SPR_RADF, C|FF_FULLBRIGHT, 3, nil, 0, 0, S_UNA_FORCE_BREAK4}
states[S_UNA_FORCE_BREAK4] = {SPR_RADF, D|FF_FULLBRIGHT, 3, nil, 0, 0, S_UNA_FORCE_BREAK5}
states[S_UNA_FORCE_BREAK5] = {SPR_RADF, E|FF_FULLBRIGHT, 3, nil, 0, 0, S_UNA_FORCE_BREAK6}
states[S_UNA_FORCE_BREAK6] = {SPR_RADF, F|FF_FULLBRIGHT, 3, nil, 0, 0, S_NULL}

-- --------------------
-- Ultimate Hex Wall
-- --------------------
mobjinfo[MT_UNA_HEXWALL] = {
	doomednum = -1,
	spawnstate = S_HEXWALL_INIT,
	painstate = S_HEXWALL_BLOCK,
	deathstate = S_HEXWALL_BLOCK,
	spawnhealth = 20,
	radius = 64*FU,
	height = 64*FU,
	flags = MF_NOGRAVITY|MF_SOLID|MF_PAPERCOLLISION|MF_NOCLIP|MF_NOCLIPHEIGHT
}
-- \\ Spawn & Setup effect \\
states[S_HEXWALL_INIT] = {SPR_ULSB, B|FF_FULLBRIGHT|FF_PAPERSPRITE, 1, nil, 0, 0, S_HEXWALL_CREATION}
states[S_HEXWALL_CREATION] = {SPR_ULSB, B|FF_FULLBRIGHT|FF_PAPERSPRITE, 1, function(mo)
	-- Create dynamic scale
	mo.destscale = mo._forcemobj.scale
	mo.scalespeed = FU/2
	-- Play spawn sound
	S_StartSound(nil, HEXSPAWNSOUND)
end, 0, 0, S_HEXWALL_BLOCK}
-- \\ Main standby \\
states[S_HEXWALL_BLOCK] = {SPR_ULSB, B|FF_FULLBRIGHT|FF_PAPERSPRITE, 12, function(mo)
	-- FX
	local g = P_SpawnGhostMobj(mo)
	g.blendmode = AST_ADD
	g.tics = 12
	g.destscale = mo.scale + 4*FU
	g.scalespeed = FU/4
end, 0, 0, S_HEXWALL_BLOCK}
-- \\ Destroy delay \\
states[S_HEXWALL_SETDISP] = {SPR_ULSB, B|FF_FULLBRIGHT|FF_PAPERSPRITE, 1, function(mo)
	if not mo.dispdelay then mo.state = S_UNA_FORCE_BREAK2 S_StartSound(mo, sfx_shattr) end
	-- if not mo.dispdelay then mo.state = S_BOSSEXPLODE S_StartSound(mo, sfx_shattr) end
	mo.dispdelay = $1-1
end, 0, 0, S_HEXWALL_SETDISP}

-- --------------------
-- Ultimate Hex Wall Spawner
-- --------------------
addHook("MobjSpawn", function(mo)
	-- Papersprite angle fix
	-- mo.angle = $1 + ANGLE_90
	-- Mobj settings
	mo.nosound = false
	mo.breaktime = 2*TICRATE
	-- mo.breaktime = 10*TICRATE -- blockmap method
	mo.breakref = nil -- Looks for an object that had its deathstate triggered instead
	mo.breakdelay = 1

	-- Linedef exec tags
	mo.spawnexectag = 0
	mo.boomexectag = 0

	-- Fills the table with a set amount of objects to use on spawn
	mo.fieldcluster = {}

	local flip = 1
	local zflip = 1
	local xmultiplier = 1
	local zmultiplier = 1
	for i=1, HEXAMOUNT do

		local cmobj = P_SpawnMobj(mo.x, mo.y, mo.z, MT_UNA_HEXWALL)
		cmobj.tics = FU
		-- cmobj.blendmode = AST_ADD
		cmobj.frame = $1|FF_TRANS30
		cmobj.color = SKINCOLOR_ROSY
		cmobj.angle = mo.angle
		cmobj._forcemobj = mo
		cmobj.dispdelay = i*2 -- Offset the disappearance time
		cmobj.tics = i*3

		-- Create a wall-like shape
		cmobj._foffx = -16*FU-(i*FU*4) -- -128
		cmobj._foffy = ((4*xmultiplier)*flip)*FU -- 32
		-- cmobj._foffz = ((4*zmultiplier)*zflip)*FU -- 32
		cmobj._foffz = (((4*zmultiplier)*zflip)*FU)-40*FU -- 32
		-- Multiply the grid distances
		xmultiplier = $1+4 -- 4
		zmultiplier = $1+2 -- 2
		if (i % 2 == 0) then
            zflip = $1 * -1
        end
		flip = $1 * -1
		-- Add to object list
		table.insert(mo.fieldcluster, cmobj)
	end

	HitDisplaySH.shownew(mo, HitDisplaySH.facciolo("Phantom Eye", mo.health, mo))

end, MT_UNA_FORCE)

-- --------------------
-- Ultimate Hex Wall Thinker
-- --------------------
addHook("MobjThinker", function(mo)
	if not mo.valid then return end

	-- Seeking state
	if (mo.state == S_UNA_FORCE_BLOCK) then

		-- Destroyed state
		if (mo.breakref and mo.breakref.valid) then
			if (mo.breakref.state == mo.breakref.info.deathstate) then
				P_StartQuake(32*FU, TICRATE)
				if not mo.nosound then S_StartSound(nil, sfx_bxdmg) end
				mo.state = S_UNA_FORCE_BREAKDELAY
				mo.tics = mo.breakdelay or 1
				mo.health = 0
			end
		end

	-- Destroyed state
	elseif (mo.state >= S_UNA_FORCE_BREAK1 and mo.state <= S_UNA_FORCE_BREAK6) then
		-- mo.color = SKINCOLOR_MAGENTA
		-- mo.colorized = true
		P_StartQuake(15*FU, 10)
	end

	-- Extra mobj settings
	mo.renderflags = RF_PAPERSPRITE
	mo.rollangle = $1+FixedAngle(2*FU)
	-- mo.angle = ANGLE_45
	-- if leveltime > 4*TICRATE then
	-- 	mo.angle = $1+FixedAngle(2*FU)
	-- end
	mo.blendmode = AST_ADD
	mo.frame = R_Char2Frame("A")
	mo.color = SKINCOLOR_MAGENTA

	-- Keep objects behind the barrier
	local xangle = mo.angle - ANGLE_90
    local yangle = mo.angle
    for _, clustmo in ipairs(mo.fieldcluster) do
        if not clustmo.valid then continue end
        -- clustmo.scale = mo.scale

        local xoff = FixedMul(clustmo._foffx, mo.scale)
        local yoff = FixedMul(clustmo._foffy, mo.scale)
        local zoff = FixedMul(clustmo._foffz, mo.scale)

        P_MoveOrigin(clustmo,
            mo.x + P_ReturnThrustX(mo, xangle, xoff)
            + P_ReturnThrustX(yangle, yoff),
            mo.y + P_ReturnThrustY(mo, xangle, xoff)
            + P_ReturnThrustY(mo, yangle, yoff),
            mo.z + FixedDiv(mo.height, 5*FU) + zoff)
            -- mo.z + mo.height/2 + zoff)
        clustmo.angle = yangle
    end
end, MT_UNA_FORCE)

addHook("ShouldDamage", function(mo, dmgmobj, dmgsource, damage, damagetype)

	if not dmgmobj.type == MT_THOK or dmgmobj.type == MT_INAZUMA_LIGHTNINGBALL then return end

	if not mo.breaktime then
		P_StartQuake(32*FU, TICRATE)
		S_StartSound(nil, sfx_bxdmg)
		mo.state = S_UNA_FORCE_BREAK1
		mo.health = 0
	end
	if (mo.breaktime % 15 == 0) then
		S_StartSoundAtVolume(nil, sfx_s239, 110) -- sfx_kc31,
	end
	mo.breaktime = max(0, $1-1)
	-- mo.breaktime = $1-1

	return false
end, MT_UNA_FORCE)

addHook("MobjDeath", function(mo, killer)
	return true
end, MT_UNA_FORCE)




-- (Facc 3) sprite settings
function Silverhorn.loboshadow_spritesettings(mo)
	mo.color = SKINCOLOR_SEAFOAM
	mo.spriteyoffset = -32*FU
	mo.frame = 0
	mo.blendmode = AST_ADD
	mo.renderflags = $1|RF_FULLBRIGHT
end

-- (Facc 3) flying state
states[S_LOBOSHADOW] = {SPR_THOK, A, 1, function(mo)
	if mo.valid then
		-- Sprite settings
		Silverhorn.loboshadow_spritesettings(mo)
		-- State action
		mo.scale = (4*4)*FU + (2*4)*cos(FixedAngle(20*FU)*leveltime)
		-- Flames are spawned behind the orb
		if leveltime % 3 == 0 then
			-- TODO: spawnmobj...
			local flm = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_GHOST)
			-- local flm = P_SpawnGhostMobj(mo)
			flm.sprite = SPR_FFLF
			flm.frame = $1 | FF_TRANS50
			flm.blendmode = AST_ADD
			flm.momz = 2*FU
			flm.spriteyoffset = -20*FU
			flm.destscale = 0
			flm.scalespeed = FU/5
			flm.tics = -1
			flm.fuse = 4*TICRATE
		end

		if leveltime % (35*2+6) == 0 then
			S_StartSound(mo, sfx_facflt)
		end
	end
end, 0, 0, S_LOBOSHADOW}

-- (Facc 3) Standby state (inactive)
states[S_LOBOSHADOW_STANDBY] = {SPR_THOK, A, 1, function(mo)
	if mo.valid then
		-- State action
		mo.scale = 0
	end
end, 0, 0, S_LOBOSHADOW_STANDBY}

-- (Facc 3) Disappearing state
states[S_LOBOSHADOW_EXIT] = {SPR_THOK, A, 40, function(mo)
	if mo.valid then
		-- Sprite settings
		Silverhorn.loboshadow_spritesettings(mo)
		-- State action
		mo.destscale = 0
		mo.scalespeed = FU/3
	end
end, 0, 0, S_LOBOSHADOW_DISPERSE}

-- (Facc 3) Disappearing state 2 (particle disperse)
states[S_LOBOSHADOW_DISPERSE] = {SPR_THOK, A, 90, function(mo)
	if mo.valid then
		-- State action
		for ang = 1, 360, 16 do
			local tt = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			tt.tics = 60
			tt.scale = FixedMul($1, 4*FU)
			tt.destscale = 0
			tt.scalespeed = FU/8
			tt.renderflags = RF_FULLBRIGHT
			tt.color = SKINCOLOR_SEAFOAM
			tt.blendmode = AST_ADD
			P_InstaThrust(tt, FixedAngle(ang*FU), 54*FU)
		end
		S_StartSound(nil, sfx_facwrp)
	end
end, 0, 0, S_LOBOSHADOW_STANDBY}

-- (Facc 3) Re-forming state
states[S_LOBOSHADOW_REFORM] = {SPR_THOK, A, 1, function(mo)
	if mo.valid then
		if not (mo.statetimer) then mo.statetimer = 1*TICRATE-10 end
		-- State action
		local rx = P_RandomRange(-128, 128)*FU
		local ry = P_RandomRange(-128, 128)*FU
		local rz = P_RandomRange(-128, 128)*FU
		local tt = P_SpawnMobj(mo.x + rx, mo.y + ry, mo.z + rz, MT_THOK)
		tt.tics = 60
		tt.spritescaley = 3*FU
		tt.destscale = 4*FU
		tt.scalespeed = FU/3
		tt.renderflags = RF_FULLBRIGHT
		tt.color = SKINCOLOR_SEAFOAM
		tt.blendmode = AST_ADD

		mo.statetimer = $1-1

		if (mo.statetimer == 1) then
			S_StartSound(nil, sfx_facwrp)
			mo.state = S_LOBOSHADOW
		end
	end
end, 0, 0, S_LOBOSHADOW_REFORM}

-- (Facc 3) Dead shock state
states[S_LOBOSHADOW_SHOCK] = {SPR_THOK, A, -1, function(mo)
	if mo.valid then
		mo.scale = 15*FU
	end
end, 0, 0, S_NULL}

-- (Facc 3) Dead 1 state
states[S_LOBOSHADOW_DEAD1] = {SPR_THOK, A, 1, function(mo)
	if mo.valid then
		-- if not (mo.statetimer) then mo.statetimer = 1*TICRATE-10 end
		-- State action
		local rx = P_RandomRange(-128, 128)*FU
		local ry = P_RandomRange(-128, 128)*FU
		local rz = P_RandomRange(-128, 128)*FU
		local dp = P_SpawnMobj(mo.x + rx, mo.y + ry, mo.z + rz, MT_THOK)
		dp.tics = 60
		dp.spritescaley = 4*FU
		dp.scale = FixedMul(FixedDiv(mo.scale, 4*FU)+1, 2*FU)
		dp.destscale = 0
		dp.scalespeed = FU/10
		dp.renderflags = RF_FULLBRIGHT
		dp.color = SKINCOLOR_SEAFOAM
		dp.blendmode = AST_ADD

		P_InstaThrust(dp, -mo.angle, 60*FU)
		mo.destscale = 0
		mo.scalespeed = FU/16
	end
end, 0, 0, S_LOBOSHADOW_DEAD1}










local function PH3_Create_Hex(container, mobjname,  mobjscale, mobjposition, spawntag, boomtag)
	EvActionSH.Sq_CreateMobjActor(container, mobjname, MT_UNA_FORCE, mobjposition, function(mo)
		mo.kemo = 1
		-- mo.scale = 8*FU
		mo.scale = mobjscale or 4*FU
		mo.blendmode = AST_ADD
		mo.angle = mobjposition.angle+ANGLE_90
		if not mo.spawnexectag then mo.spawnexectag = spawntag end
		if not mo.boomexectag then mo.boomexectag = boomtag end
	end)
end

-- TODO: entire force object rotating on reload with skip.lua
-- End
local function HEXWALLIDS(tagnum, tagtype)

	local HEXIDTAGS = {
		[801] = {8750, 8751},
		[802] = {8760, 8761},
		[803] = {8770, 8771},
	}
	if (HEXIDTAGS[tagnum] and tagtype <= 2) then
		return HEXIDTAGS[tagnum][tagtype]
	else
		print("HEXWALLID is not valid!")
	end
end

-- Starts Ultimate Inazuma's laser
local function STARTULTLASER(player)
	if player and player.valid then
		if player.inazuma then
			player.inazuma.laser = 2
		end
	end
end

-- Ends Ultimate Inazuma's laser early by setting it close to it's cutoff value
local function ULTLASEREARLYEXIT(tics, looping)
	EvActionSH.doforall(function(p)
		if p and p.valid then
			if looping then
				if p.inazuma then
					if p.inazuma.laser > 4*TICRATE then
						p.inazuma.laser = 2*TICRATE
					end
				end
			else
				if p.inazuma then p.inazuma.laser = tics or TICRATE*5 end
			end
		end
	end)
end


EventSH.new("kemonee_laststandattack_00", {
function(c,e)
	c.selftime = 0
end,
function(c,e)
	-- print("Startup wait")
	EventSH.wait(e, c.startdelay)
end,
function(c,e)
	-- print("Get player")
end,
function(c,e)
	if not c.target.valid then return end
	-- print("Fire")
	S_StartSound(nil, sfx_portfr)
	Silverhorn.FireMegaLaser(c.source, c.target, c.speed, {colors=c.colors, length=c.length, firedist=c.firedist, spawnscale=c.scale})
	local warn = Silverhorn.CreateWarning(c.target.x, c.target.y, c.target.z, 2*TICRATE)
	warn.scale = FU/2
end})

local function km_laststandattack_fire(source, target, prefs)
	local t = {}
	t.source = EvActionSH.defvalue(source, {x=0,y=0,z=0})
	t.target = EvActionSH.defvalue(target, {x=0,y=0,z=0})
	t.speed = prefs.speed or 32*FU
	t.colors = prefs.colors
	t.startdelay = prefs.delay or 0
	t.length = prefs.length or 90
	t.firedist = prefs.clipat or 6400*FU
	t.scale = prefs.scale or 4*FU
	EventSH.start("kemonee_laststandattack_00", t)
end


EventSH.new("kemonee_laststand_final_fire", {
function(c,e)
	c.selftime = 0
	c.swap_a = 1
	c.swap_h = 1
	c.sideangle = {-90, 90}
	c.heightalt = {-180, -90, 90, 180}
end,
function(c,e)
	EventSH.setloop(e, "repeat")
	c.ra = c.sideangle[c.swap_a]
	c.rz = c.heightalt[c.swap_h]
end,
function(c,e)
	c.swap_a = $1 + 1
	c.swap_h = $1 + 1
	c.selftime = $1 + lobo_laststand_delay_3
	S_StartSound(displayplayer.mo, sfx_chrg1, displayplayer)
	local direction = c.m_faccioloshadow.angle
	local anglepos = {
		x=c.m_faccioloshadow.x+P_ReturnThrustX(nil, direction+FixedAngle(c.ra * FU), 800*FU),
		y=c.m_faccioloshadow.x+P_ReturnThrustY(nil, direction+FixedAngle(c.ra * FU), 800*FU),
		z=c.m_faccioloshadow.z+c.rz*FU,
	}
	km_laststandattack_fire(anglepos, c.linedef_player.mo, {colors=lobo_colormap, speed=50*FU, delay=c.selftime, length=14, scale=4*FU})
end,
function(c,e)
	if c.swap_a > #c.sideangle then c.swap_a = 1 end
	if c.swap_h > #c.heightalt then c.swap_h = 1 end
	EventSH.gotoloopuntil(e, "repeat", c.selftime > (lobo_laststand_delay_3 * 10))
end})




local ev_kemonee_intro_stringids = {
	{id=1550, delaytime=6*TICRATE},
	{id=1551, delaytime=4*TICRATE},
	{id=1552, delaytime=3*TICRATE},
	{id=1553, delaytime=5*TICRATE+5},
	{id=1554, delaytime=3*TICRATE+4},
	{id=1555, delaytime=4*TICRATE},
	{id=1556, delaytime=5*TICRATE+6},
	{id=1557, delaytime=3*TICRATE+20},
	{id=1558, delaytime=4*TICRATE+8},
	{id=1559, delaytime=3*TICRATE+15},
	{id=1560, delaytime=4*TICRATE+5},
	{id=1561, delaytime=2*TICRATE+5},
	{id=1562, delaytime=5*TICRATE},
}

-- EventSH.debug = true
EventSH.new("ev_kemonee_intro", {
function(c,e)
	-- Setup
	c.mindtextindex = 1

	-- Enable graphic renderer
	EvActionSH.togglerender(c)
	EvActionSH.drawcineborders(c, 1, 16)

	EvActionSH.SetInternalHudStatus({"time", "score", "rings", "lives"}, false)
	
	-- Disable super forms
	for player in players.iterate do
		player.rings = 0
	end

end,
function(c,e)
	EventSH.wait(e, 5*TICRATE)
end,
function(c,e)
	UnlockSilverhorn()

	-- Silverhorn.SaveValue("setting", "silverhorn_enabled", true)
end,
function(c,e)
	EventSH.wait(e, 3*TICRATE)
end,
function(c,e)
	EventSH.setloop(e, "text_completion")
end,
function(c,e)
	local textid = ev_kemonee_intro_stringids[c.mindtextindex]["id"]
	local waitingtime = ev_kemonee_intro_stringids[c.mindtextindex]["delaytime"]

	startmindtext(textid)

	if textid == 1551 then
		-- Set BGM
		EvActionSH.doforall(function(p)
			EvActionSH.SetCurrentMusic(true, "CBACC", true, p, 0, 0, 2*MUSICRATE)
			EvActionSH.SetMapMusicFlags("reload")
		end)
	elseif textid == 1560 then
		EvActionSH.doforall(function(p)
			S_FadeOutStopMusic(4*MUSICRATE, p)
		end)
		EventSH.start("fx_kemonee_fire", {spawn=c.ac_facciolo_down})
	elseif textid == 1562 then
		EventSH.start("PH2PORT__DM_COUNTER", {mobj=c.ac_facciolo_down,
			mass_sfx=sfx_facfdh,
			mass_waittime=5,
			mass_fuse=5*TICRATE,
			fill_effect=true,
			fill_waitingtime=4*TICRATE,
			skipmassfade=true,
			mass_speed=12*FU})
	end

	EventSH.wait(e, waitingtime, true)
end,
function(c,e)
	-- Increase text count
	c.mindtextindex = $1 + 1

	if c.mindtextindex <= #ev_kemonee_intro_stringids then
		-- loop until all completed
		EventSH.gotoloop(e, "text_completion")
	end
end,
function(c,e)
	-- EvActionSH.doforall(function (p)
	-- 	p.powers[pw_nocontrol] = 3*TICRATE
	-- end)
	EventSH.wait(e, 1*TICRATE, true)
end,
function(c,e)
	EventSH.destroy("fx_kemonee_fire")

	-- Restore HUD
	EvActionSH.removecineborders(c)
	EvActionSH.SetInternalHudStatus({"time", "score", "rings", "lives"}, true)

	-- Transport to final destination
	EvActionSH.relocateplayers({x=18560*FU, y=1664*FU, z=0*FU})
	P_LinedefExecute(9090)
	Silverhorn.UndoForceEnableAnalogMode(player)

	EventSH.start("ev_kemonee", c)
end,})


-- Flame effect
EventSH.new("fx_kemonee_fire", {
function(c,e)
	c.statetimer = 0
	c.range = 96
	c.multiplier = 0
	c.qk_multiplier = 0
end,
function(c,e)
	if c.statetimer % 5 == 0 then
		local rx = P_RandomRange(-c.range,c.range)*FU
		local ry = P_RandomRange(-c.range,c.range)*FU
		local kfire = P_SpawnMobj(c.spawn.x + rx, c.spawn.y + ry, c.spawn.z, MT_PUSH)
		kfire.sprite = SPR_FFLF
		kfire.frame = 0 | FF_TRANS30
		kfire.renderflags = $1 | RF_FULLBRIGHT
		kfire.blendmode = AST_ADD
		kfire.scale = (2 + c.multiplier/4)*FU
		kfire.destscale = 1
		kfire.scalespeed = FU/(16)
		kfire.momz = (4 + c.multiplier + 1)*FU
		kfire.fuse = 4*TICRATE
	end
	P_StartQuake((2 + c.qk_multiplier)*FU, 2)
	EvActionSH.PlaySoundRate(nil, sfx_s3kcbl, 110, 20)

	-- Multiply time values
	if c.statetimer % 20 == 0 then
		c.multiplier = $1 + 1
	elseif c.statetimer % 35*3 == 0 then
		c.qk_multiplier = $1 + 4
	end
	c.statetimer = $1 + 1

	EventSH.waitUntil(e, false)
	-- EventSH.wait(e, 16*TICRATE)
end})




EventSH.new("ev_kemonee", {
function(c,e)
	-- Make camera
	EvActionSH.Sq_MakeCamera(c, 0*FU, 0*FU, 0*FU)
	-- print("Load")
end,
function(c,e)
	-- Start global stage effects
	EventSH.start("ev_kemonee_quake")

	-- Map Anchor
    EvActionSH.Sq_CreateValue(c, "hologuideref", Silverhorn.MS_GetSpecialMobj(800))
	EvActionSH.Sq_CreateValue(c, "force_checkpoint1", Silverhorn.MS_GetSpecialMobj(801))
	EvActionSH.Sq_CreateValue(c, "force_checkpoint2", Silverhorn.MS_GetSpecialMobj(802))
	EvActionSH.Sq_CreateValue(c, "force_checkpoint3", Silverhorn.MS_GetSpecialMobj(803))
	-- Extra
	EvActionSH.Sq_CreateValue(c, "force_checkpoint4", Silverhorn.MS_GetSpecialMobj(804))
	EvActionSH.Sq_CreateValue(c, "force_checkpoint5", Silverhorn.MS_GetSpecialMobj(805))
	EvActionSH.Sq_CreateValue(c, "force_checkpoint6", Silverhorn.MS_GetSpecialMobj(806))

	for num = 1, 99, 1 do
		EvActionSH.Sq_CreateValue(c, "facc_follow" .. num, Silverhorn.MS_GetSpecialMobj(900+num))
	end
	-- 980 - Camera
	-- 990 - Extra

	-- Facciolo is the only actor we might need
	EvActionSH.Sq_CreateMobjActor(c, "faccioloshadow", MT_PUSH, {x=0, y=0, z=0}, function(mo)
		-- mo.sprite = SPR_EGGM
		mo.scale = 4*FU
		mo.renderflags = $1|RF_FULLBRIGHT
		mo.flags = $1 | (MF_NOCLIP|MF_NOCLIPHEIGHT)
		mo.state = S_LOBOSHADOW
		mo.kemo = 1
		mo.facc = {health = 300}
	end)

	EvActionSH.Sq_CreateActor(c, "inazuma", "inazuma", SPR_PLAY, 4*FU, 6*FU,  SKINCOLOR_CERULEAN, function(act)

		act.renderflags = $1|RF_FULLBRIGHT
	end)

	-- Set up various helper objects
	EvActionSH.Sq_CreateMobjActor(c, "hologuide", MT_PUSH, {x=c.hologuideref.x, y=c.hologuideref.y, z=c.hologuideref.z+32*FU}, function(mo)
		mo.kemo = 1
		mo.height = 64*FU
		mo.angle = $1-ANGLE_90
		mo.state = S_UL_HOLOGUIDE
	end)

	-- Restore previous bright levels before level-wide change occurred
	Silverhorn.ReloadMindscapeBrightnessLevels(gamemap)
end,
function(c,e)

	-- Complete transition to the final area
	EvActionSH.doforall(function(p)
		local fcmass = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_PUSH)
		fcmass.sprite = SPR_FTHK
		fcmass.spriteyoffset = -16*FU
		fcmass.scale = 32*FU
		fcmass.color = SKINCOLOR_BLACK
		fcmass.destscale = 0
		fcmass.scalespeed = 4*FU
		fcmass.fuse = 3*TICRATE
	end)
	S_StartSound(nil, sfx_dawrld)

	-- Emerald Failsafe
	if not All7Emeralds(emeralds) then
		for i = 1, 7
			emeralds = $ | (1 << (i - 1))
		end
	end
	-- Set BGM
	EvActionSH.doforall(function(p)
		EvActionSH.SetCurrentMusic(true, "COLAPS", true, p)
		EvActionSH.SetMapMusicFlags("reload")
	end)
end,
function(c,e)
	-- .. Waiting for input ...
	for player in players.iterate do
		if not (player and player.valid) then continue end
		if EventSH.waitUntil(e, Silverhorn.Inazuma.IsUltimate(player)) then break end
	end
end,
function(c,e)
	-- Waiting until transformation is complete
	-- Set BGM
	EvActionSH.doforall(function(p)
		EvActionSH.SetCurrentMusic(true, "", true, p)
		EvActionSH.SetMapMusicFlags("reload")
	end)

	for player in players.iterate do
		if not (player and player.valid) then continue end
		if EventSH.waitUntil(e, (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_FLOAT) ) then break end
	end
end,
function(c,e)
	-- Transformation tutorial complete
	P_SetupLevelSky(8)
	startmindtext(1563)
	
	-- Make exit passible
	local line = P_FindSpecialLineFromTag(41, 642)
	line = $ and lines[$]
	if line and line.valid and line.frontsector and line.frontsector.valid
		line.frontsector.ceilingheight = line.frontsector.floorheight
	end
	
	local music = Silverhorn.UltimateMode() and "PS3ULT" or "UND3"
	EvActionSH.doforall(function(p)
		EvActionSH.SetCurrentMusic(true, music, true, p)
		EvActionSH.SetMapMusicFlags("reload")
	end)
end,
function(c,e)
	-- c.execmobj.momx = 0
	-- c.execmobj.momy = 0
	-- c.execmobj.momz = 0
	-- MobjMoverSH.moveto("move", c.execmobj, {x=4*FU,y=512*FU,z=240*FU}, {speed=8*FU})

	Silverhorn.ReloadMindscapeBrightnessLevels(gamemap)
end,
-- ==============================
-- ...
-- Checkpoint 1
-- ...
-- ==============================
function(c,e)
	EventSH.waitSignal(e, "collapse_trigger_start")
end,
function(c,e)
	EvActionSH.movemobjto(c.m_faccioloshadow, c.facc_follow1)
end,
function(c,e)
	MobjMoverSH.moveto("move_shado", c.m_faccioloshadow, c.facc_follow2, {speed=FCS_TRAVELSPEED, varc=-200*FU, harc=128*FU, locked=false})
end,
function(c,e)
	MobjMoverSH.waitmovedone(e, "move_shado", function (cc)
		MobjMoverSH.moveto("move_shado", cc.m_faccioloshadow, cc.facc_follow3, {speed=FCS_TRAVELSPEED, locked=false})
	end)
end,
function(c,e)
	MobjMoverSH.waitmovedone(e, "move_shado")
end,
function(c,e)
	PH3_Create_Hex(c, "sb1", 15*FU, c.force_checkpoint1, HEXWALLIDS(801, 1), HEXWALLIDS(801, 2))
end,
function(c,e)
	EventSH.waitSignal(e, "collapse_trigger_broken1")
end,
function(c,e)
	-- End Inazuma's laser early
	ULTLASEREARLYEXIT(4*TICRATE+25)
	-- First broken
	S_StartSound(displayplayer.mo, sfx_chrg1, displayplayer)
	local target = Silverhorn.GetNearbyTarget(c.m_faccioloshadow, 6400*FU)
	for i = 0, (lobo_laststand_delay_1 * 3), lobo_laststand_delay_1 do
		km_laststandattack_fire(c.m_faccioloshadow, target, {colors=lobo_colormap, speed=15*FU, delay=1*TICRATE+i, length=2*TICRATE, scale=4*FU})
	end
	EventSH.wait(e, 15, true)
end,
function(c,e)
	MobjMoverSH.moveto("move_shado", c.m_faccioloshadow, c.facc_follow4, {speed=FCS_TRAVELSPEED, harc=-2000*FU, locked=false})
end,
function(c,e)
	-- Facciolo will be disappearing for a bit...
	MobjMoverSH.waitmovedone(e, "move_shado", function (cc)
		cc.m_faccioloshadow.state = S_LOBOSHADOW_EXIT
	end)
end,
-- ==============================
-- ...
-- Checkpoint 2
-- ...
-- ==============================
function(c,e)
	EventSH.waitSignal(e, "collapse_trigger_check2")
end,
function(c,e)
	EvActionSH.movemobjto(c.m_faccioloshadow, c.facc_follow5)
	c.m_faccioloshadow.state = S_LOBOSHADOW_REFORM
end,
function(c,e)
	MobjMoverSH.moveto("move_shado", c.m_faccioloshadow, c.facc_follow6, {speed=FCS_TRAVELSPEED, varc=-128*FU, harc=64*FU, locked=false})
end,
function(c,e)
	MobjMoverSH.waitmovedone(e, "move_shado")
end,
function(c,e)
	PH3_Create_Hex(c, "sb2", 9*FU, c.force_checkpoint2, HEXWALLIDS(802, 1), HEXWALLIDS(802, 2))
end,
function(c,e)
	EventSH.waitSignal(e, "collapse_trigger_broken2")
end,
function(c,e)
	-- End Inazuma's laser early
	ULTLASEREARLYEXIT(4*TICRATE+25)

	S_StartSound(displayplayer.mo, sfx_chrg1, displayplayer)
	local target = Silverhorn.GetNearbyTarget(c.m_faccioloshadow, 6400*FU)
	for i = 0, (lobo_laststand_delay_2 * 7), lobo_laststand_delay_2 do
		km_laststandattack_fire(c.m_faccioloshadow, target, {colors=lobo_colormap, speed=15*FU, delay=2*TICRATE+i, length=15, scale=4*FU})
	end

	EventSH.wait(e, 15, true)
end,
function(c,e)
	MobjMoverSH.moveto("move_shado", c.m_faccioloshadow, c.facc_follow7, {speed=FCS_TRAVELSPEED, harc=1400*FU, locked=false})
end,
function(c,e)
	MobjMoverSH.waitmovedone(e, "move_shado")
end,
function(c,e)
	MobjMoverSH.stop("move_shado")
end,
function(c,e)
	MobjMoverSH.moveto("move_shado", c.m_faccioloshadow, c.facc_follow8, {speed=FCS_TRAVELSPEED, harc=-1280*FU, locked=false})
end,
function(c,e)
	MobjMoverSH.waitmovedone(e, "move_shado")
end,
function(c,e)
	MobjMoverSH.moveto("move_shado", c.m_faccioloshadow, c.facc_follow9, {speed=FCS_TRAVELSPEED, harc=900*FU, locked=false})
end,
function(c,e)
	MobjMoverSH.waitmovedone(e, "move_shado")
end,
-- ==============================
-- ...
-- Checkpoint 3
-- ...
-- ==============================
function(c,e)
	-- Start final checkpoint cinematic (and final movement)
	EvActionSH.movemobjto(c.camera, c.facc_follow9)
	EvActionSH.setcamera(true, c.camera, c.facc_follow80, 180*FU, 0)
	MobjMoverSH.moveto("move_camera", c.camera, c.facc_follow81, {ease="outcubic", speed=50*FU, noangle=true, locked=false})
	MobjMoverSH.moveto("move_shado", c.m_faccioloshadow, c.facc_follow10, {speed=FCS_TRAVELSPEED, locked=false})

	-- Freeze all player positions temporarily
	EvActionSH.FreezePlayers(EvActionSH.createplayerlist())
end,
function(c,e)
	EventSH.wait(e, 5, true)
end,
function(c,e)
	PH3_Create_Hex(c, "sb6", 8*FU, {x=c.force_checkpoint6.x, y=c.force_checkpoint6.y, z=c.force_checkpoint6.z, angle=c.force_checkpoint3.angle}, 0, 0)
end,
function(c,e)
	EventSH.wait(e, 5, true)
end,
function(c,e)
	PH3_Create_Hex(c, "sb5", 8*FU, {x=c.force_checkpoint5.x, y=c.force_checkpoint5.y, z=c.force_checkpoint5.z, angle=c.force_checkpoint3.angle}, 0, 0)
end,
function(c,e)
	EventSH.wait(e, 10, true)
end,
function(c,e)
	PH3_Create_Hex(c, "sb4", 8*FU, {x=c.force_checkpoint4.x, y=c.force_checkpoint4.y, z=c.force_checkpoint4.z, angle=c.force_checkpoint3.angle}, 0, 0)
end,
function(c,e)
	PH3_Create_Hex(c, "sb3", 8*FU, c.force_checkpoint3, HEXWALLIDS(803, 1), HEXWALLIDS(803, 2))
	c.m_sb6.breakref = c.m_sb3
	c.m_sb5.breakref = c.m_sb3
	c.m_sb4.breakref = c.m_sb3
	c.m_sb6.breakdelay = 4*1
	c.m_sb5.breakdelay = 4*2
	c.m_sb4.breakdelay = 4*3
	c.m_sb6.nosound = true
	c.m_sb5.nosound = true
	c.m_sb4.nosound = true
	EventSH.wait(e, 2*TICRATE, true)
end,
function(c,e)
	-- Unfreeze players
	EvActionSH.UnfreezePlayers()
	EvActionSH.stopcameraview(true)
end,
function(c,e)
	EventSH.waitSignal(e, "collapse_trigger_broken3")
end,
function(c,e)
	c.m_faccioloshadow.state = S_LOBOSHADOW_EXIT

	-- End Inazuma's laser early
	ULTLASEREARLYEXIT(4*TICRATE+25)
	EventSH.wait(e, 15, true)
end,
-- ==============================
-- ...
-- Final
-- ...
-- ==============================
function(c,e)
	-- Prevent unjoiners and prompt failures from locking the scene
	-- EventSH.setloop(e, "shadoblast_retry")
end,
function(c,e)
	-- Moves facc to final defense position
	EvActionSH.movemobjto(c.m_faccioloshadow, c.facc_follow11)
	c.m_faccioloshadow.angle = FixedAngle(90*FU)
	c.m_faccioloshadow.state = S_LOBOSHADOW
end,
-- Wait for trigger (Each time)
-- ==================================================
function(c,e)
	EventSH.waitSignal(e, "collapse_trigger_end")
end,
function(c,e)
	-- @note Failsafes for disconnectors
	EvActionSH.Sq_SetQTimer(c, 7*TICRATE)
end,
-- ==================================================
function(c,e)
	-- End any interactions early for everyone
	ULTLASEREARLYEXIT(0)

	-- Display final name
	local bossname = (Silverhorn.UltimateMode() and "Ember of Disaster" or "Soul of Facciolo")
	HitDisplaySH.shownew(c.m_faccioloshadow.facc, HitDisplaySH.facciolo(bossname, c.m_faccioloshadow.facc.health, c.m_faccioloshadow))

	-- Move player to final destination
	MobjMoverSH.moveto("move_player", c.linedef_player.mo, c.facc_follow90, {speed=96*FU})

	EventSH.start("kemonee_laststand_final_fire", c)
end,
function(c,e)
	-- Failsafe timer
	if not (c.linedef_player or c.linedef_player.valid) then
		EvActionSH.Sq_AdvanceQTimer(e, c)
	else
		MobjMoverSH.waitmovedone(e, "move_player")
	end
end,
-- @note Interactive Cinematic
-- ==================================================
function(c,e)
	c.firedirection = EvActionSH.getlookangle(c.facc_follow90, c.m_faccioloshadow)

	-- Actor
	-- ========
	EvActionSH.movemobjto(c.ac_inazuma, c.facc_follow90)
	EvActionSH.stopmobjmomentum(c.ac_inazuma)
	EvActionSH.setmobjeangle(c.ac_inazuma, c.firedirection)
	c.ac_inazuma.scale = FU

	-- Start color shifting
	EventSH.start("fx_colorshift_ultimate", {shiftmobj=c.ac_inazuma})
	FrameAnimSH.addspr2("ina", c.ac_inazuma, SPR2_PAIN, "A", nil, {delay=2, super=true, loopalways=true})

	-- Player
	-- ========
	EvActionSH.relocateplayers({x=18560*FU, y=1664*FU, z=0*FU})
	-- EvActionSH.movemobjto(c.linedef_player.mo, c.facc_follow90)
	-- EvActionSH.stopmobjmomentum(c.linedef_player.mo)
	-- c.linedef_player.inazuma.laserangle = EvActionSH.getlookangle(c.linedef_player.mo, c.m_faccioloshadow)
end,
function(c,e)
	-- Start cinematic
	EvActionSH.setcamera(true, c.camera, {x=c.facc_follow90.x, y=c.facc_follow90.y-200*FU, z=c.facc_follow90.z}, 180*FU, 0)
	-- Track Actor
	EvActionSH.cameratrack(true, c.camera, c.ac_inazuma)
	-- Start Ultimate Laser
	EventSH.start("fx_ultimate_laser", {fireangle=c.ac_inazuma.angle, firingtime=18*TICRATE, firingorigin={x=c.ac_inazuma.x, y=c.ac_inazuma.y, z=c.ac_inazuma.z}})
	-- STARTULTLASER(c.linedef_player)
end,
function(c,e)
	EventSH.wait(e, 1*TICRATE)
end,
function(c,e)
	FrameAnimSH.addspr2("ina", c.ac_inazuma, SPR2_FIRE, "A", nil, {delay=2, super=true, loopalways=true})

	-- Start cinematic
	EvActionSH.setcamera(true, c.camera, c.ac_inazuma, 180*FU, 0)
	-- EvActionSH.setcamera(true, c.camera, c.linedef_player.mo, 180*FU, 0)
	MobjMoverSH.moveto("move_camera", c.camera, {
		x=c.facc_follow85.x,
		y=c.facc_follow85.y,
		z=c.facc_follow85.z}, {ease="inoutcubic", speed=50*FU, noangle=true})

	EventSH.start("panshadow", {cam = c.camera, dest = c.facc_follow86})
end,
function(c,e)
	-- Loop laser
	-- ULTLASEREARLYEXIT(4*TICRATE+25, true)
	-- c.linedef_player.inazuma.laserangle = EvActionSH.getlookangle(c.linedef_player.mo, c.m_faccioloshadow)
	-- EvActionSH.movemobjto(c.linedef_player.mo, c.facc_follow90)

	-- Track centerpoint
	EvActionSH.cameratrack(true, c.camera, {x=c.m_faccioloshadow.x, y=c.m_faccioloshadow.y+800*FU, z=c.m_faccioloshadow.z})

	-- Quickly chip off health
	searchBlockmap("objects", function(refmobj, foundmobj)
		if (foundmobj.type == MT_THOK) then
			-- if (c.timer % 15 == 0) then
			-- 	S_StartSoundAtVolume(nil, sfx_s239, 95)
			-- end
			refmobj.facc.health = $1 - 1
		end
	end, c.m_faccioloshadow)

	-- EventSH.wait(e, 15*TICRATE)
	EventSH.waitUntil(e, c.m_faccioloshadow.facc.health == 0)
end,
-- ==============================
-- ...
-- Defeat (player has won!)
-- ...
-- ==============================
function(c,e)
	-- Remove all players from the field, because the level is now counted as complete
	-- Freeze players
	-- EvActionSH.FreezePlayers(EvActionSH.createplayerlist())

	-- Relocate players (stability)
	EvActionSH.relocateplayers({x=18560*FU, y=1664*FU, z=0*FU})

	-- Disable Hud
	EvActionSH.SetInternalHudStatus({"time", "score", "rings", "lives"}, false)

	-- Stop everything
	-- EvActionSH.SetCurrentMusic(true, "", true)
	-- EvActionSH.SetMapMusicFlags("reload")
	EvActionSH.startsound(nil, sfx_srbht)
	EvActionSH.startsound(nil, sfx_srbht)

	EvActionSH.doforall(function (p)
		P_FlashPal(p, 1, 5)
	end)

	-- (this is a fake stop since the laser continues to shake the screen)
	EventSH.destroy("ev_kemonee_quake")
	EventSH.start("ev_kemonee_quake", {rate = 1, intensity = 1*FU/2})
	P_LinedefExecute(9091) -- (We can't stop scrolling textures, but we can pretend they did)

	-- Stop boss
	c.m_faccioloshadow.state = S_LOBOSHADOW_SHOCK
	EvActionSH.setmobjlookat(c.m_faccioloshadow, c.facc_follow90)
	-- c.m_faccioloshadow.angle = R_PointToAnglec.facc_follow90.x, c.facc_follow90.y)
end,
function(c,e)
	-- Everything is (kind of) frozen
	ULTLASEREARLYEXIT(4*TICRATE+25)
	EventSH.wait(e, 2*TICRATE)
end,
function(c,e)
	-- Restore the frozen state
	EventSH.destroy("ev_kemonee_quake")
	P_LinedefExecute(9092) -- (resets the 'stopped' sky)

	-- Set camera
	EvActionSH.setcamera(true, c.camera, c.facc_follow87, AngleFixed(R_PointToAngle2(c.camera.x, c.camera.y, c.m_faccioloshadow.x, c.m_faccioloshadow.y)), 0)
	EvActionSH.cameratrack(true, c.camera, c.m_faccioloshadow)

	-- Actual boss death
	c.m_faccioloshadow.state = S_LOBOSHADOW_DEAD1
	c.m_faccioloshadow.spriteyoffset = $1 + 10*FU
	EvActionSH.startsound(nil, sfx_facde2)

end,
function(c,e)
	ULTLASEREARLYEXIT(4*TICRATE, true)
	EventSH.wait(e, 2*TICRATE)
end,
function(c,e)
	-- Transition into the ending
	EvActionSH.fadescreen("out", 1, 18)

	EvActionSH.doforall(function(p)
		S_FadeOutStopMusic(6*MUSICRATE, p)
	end)
end,
function(c,e)
	-- Goodbye facc
	ULTLASEREARLYEXIT(4*TICRATE, true)
	EventSH.wait(e, 9*TICRATE)
end,
-- ==============================
-- ...
-- Ending
-- ...
-- ==============================
function(c,e)
	-- Take care of some final things here before the transition
	-- =====================================
	-- Create exit portal
	EvActionSH.Sq_CreateMobjActor(c, "exitportal", MT_PUSH, {x=0, y=0, z=0}, function(mo)
		mo.scale = 0*FU
		mo.renderflags = $1|RF_FULLBRIGHT
		mo.flags = $1 | (MF_NOCLIP|MF_NOCLIPHEIGHT)
		mo.colorized = true
		mo.color = SKINCOLOR_SUPERGOLD5
		mo.state = S_FACCIOLO2_SPACEPORTAL
		mo.spriteyoffset = $1 - 32*FU
	end)

    -- Attempt another re-location just in case
	EvActionSH.relocateplayers( {x=16576*FU, y=15168*FU, z=48*FU})
	-- EvActionSH.relocateplayers(c.facc_follow90)
	EvActionSH.FreezePlayers(EvActionSH.createplayerlist())

	-- Move exit portal to final area
	EvActionSH.movemobjto(c.m_exitportal, c.facc_follow98)

	-- Move actor to final area
	EvActionSH.movemobjto(c.ac_inazuma, c.facc_follow97)
	EvActionSH.setmobjlookat(c.ac_inazuma, c.m_exitportal)
	FrameAnimSH.addspr2("ina", c.ac_inazuma, SPR2_STND, 0, "H", {delay=4, super=true, loopalways=true})

	-- Start color shifting (Old)
	-- EventSH.Start("fx_colorshift_ultimate", {shiftmobj=c.ac_inazuma})

	-- Set camera to final area
	EvActionSH.setcamera(true, c.camera, c.facc_follow95, 0, 0)
	EvActionSH.cameratrack(true, c.camera, c.m_exitportal)

	EventSH.wait(e, 3*TICRATE, true)
end,
function(c,e)
	-- Transition into the ending
	EvActionSH.fadescreen("in", 1, 10)

	-- (A crash happens here and above if you maange to die. Fixed in SRB2 v2.2.11)
	-- Set mood
	EvActionSH.SetCurrentMusic(true, "FNLSQ", true, nil, 0, 0, 0, 4*MUSICRATE)
	EvActionSH.SetMapMusicFlags("reload")

	EventSH.wait(e, 2*TICRATE, true)
end,
function(c,e)
	EvActionSH.setmobjscale(c.m_exitportal, 4*FU, FU/20)
	EvActionSH.startsound(nil, sfx_s3kbds)
	MobjMoverSH.moveto("move_camera", c.camera, c.facc_follow96, {ease="inoutsine", speed=4*FU, noangle=true})
end,
function(c,e)
	EvActionSH.cameratrack(true, c.camera, c.m_exitportal)
	MobjMoverSH.waitmovedone(e, "move_camera")
end,
function(c,e)
	-- Enable graphic render
	EvActionSH.togglerender(c)
	EvActionSH.rendertext(c, 4, "leaveprompt", 320/2, (200/2)+50, "\x82[JUMP] - Leave Mindscape", V_30TRANS|V_SNAPTOTOP, "thin-center")
	EvActionSH.Sq_SetQTimer(c, 30*TICRATE)
end,
function(c,e)
	for player in players.iterate do
		if player.bot or not player.valid then continue end
		EvActionSH.waitForInput(e, player, BT_JUMP)
	end
	-- @note Failsafe for disconnectors
	EvActionSH.Sq_AdvanceQTimer(e, c)
end,
function(c,e)
	-- speedrunners, this is the frame you can call on :)
	MobjMoverSH.moveto("move_ina", c.ac_inazuma, {x=c.ac_inazuma.x,y=c.ac_inazuma.y+128*FU,z=c.ac_inazuma.z+256*FU}, {ease="outquart", speed=8*FU, varc=64*FU, noangle=true})

	EvActionSH.renderitemvisibility(c, "leaveprompt", false)

	-- Jump!
	EvActionSH.startsound(nil, sfx_inaju1)
	FrameAnimSH.addspr2("ina", c.ac_inazuma, SPR2_ROLL, 0, nil, {delay=4, super=true, loopalways=true})
end,
function(c,e)
	MobjMoverSH.waitmovedone(e, "move_ina")
end,
function(c,e)
	-- Dash!
	EvActionSH.startsound(nil, sfx_boltbl)
	MobjMoverSH.moveto("move_ina", c.ac_inazuma, c.m_exitportal, {ease="inback", speed=26*FU})
	FrameAnimSH.addspr2("ina", c.ac_inazuma, SPR2_SKID, 0, nil, {delay=4, super=true, loopalways=true})
end,
function(c,e)
	EvActionSH.doforall(function (p)
		P_FlashPal(p, 1, 5)
	end)
	MobjMoverSH.moveto("move_ina", c.ac_inazuma,  {x=c.m_exitportal.x,y=c.m_exitportal.y,z=c.m_exitportal.z+64*FU}, {ease="linear", speed=80*FU})
	FrameAnimSH.addspr2("ina", c.ac_inazuma, SPR2_RUN_, 0, "C", {delay=2, super=true, loopalways=true})
end,
function(c,e)
	Silverhorn.Inazuma.SpawnTrail(c.ac_inazuma)
	MobjMoverSH.waitmovedone(e, "move_ina", function(cc)
	-- This actor is no longer needed since it is the end of the map
		P_RemoveMobj(cc.ac_inazuma)
	end)
end,
function(c,e)
	-- Close out the level with final effects, animations, sounds
	EvActionSH.fadescreen("out", 1, 30)

	EvActionSH.doforall(function (p)
		P_FlashPal(p, 1, 5)
	end)

	-- Stops music
	for player in players.iterate do
		S_FadeOutStopMusic(6000, player)
	end

	-- TODO: ignore - sizing math is way off where the number comments are,
	local flip = 1
	local rad = 9
	for i = 1, 4, 1 do

		for ang = 1, 360, 16 do
			local prt = P_SpawnMobj(c.m_exitportal.x, c.m_exitportal.y, c.m_exitportal.z, MT_THOK)
			prt.tics = 100
			prt.scale = FixedMul($1, 4*FU)
			prt.destscale = 0
			prt.scalespeed = FU/20
			prt.renderflags = RF_FULLBRIGHT
			prt.color = SKINCOLOR_SUPERGOLD5
			prt.blendmode = AST_ADD
			P_InstaThrust(prt, FixedAngle(ang*FU), (rad*FU) - i*FU) --6
			flip = $1 * -1
			prt.momz = FixedMul(flip*FU, (i/2)*(FU*(rad/3))) --2
		end
	end
	EvActionSH.startsound(nil, sfx_s3kb3)
	EvActionSH.startsound(nil, sfx_hxexit)

	EvActionSH.setmobjscale(c.m_exitportal, 0, FU/70)
	MobjMoverSH.moveto("move_camera", c.camera, c.m_exitportal, {speed=3*FU, noangle=true})
end,
function(c,e)
	EventSH.wait(e, 2*TICRATE)
end,
function(c,e)
	EvActionSH.setplayerviewroll(true, 20*FU, true)
	EventSH.wait(e, 8*TICRATE)
end,
function(c,e)
	-- A bit longer just in case (and reset / place)
	EvActionSH.setplayerviewroll(true, 0, true)
	EvActionSH.setcamera(true, c.camera, c.facc_follow99, 0, 0)
	EventSH.wait(e, 2*TICRATE)
end,
function(c,e)
	EvActionSH.fadescreen("out", 1, 2)
	EventSH.wait(e, 2*TICRATE, true)
end,
function(c,e)
	-- Campaign Continue
	-- if (MindscapeSessionFlags & MS_DIRE) then
	-- 	MindscapeSessionFlags = $1 | MS_BEATMINDSCAPE
	-- 	G_SetCustomExitVars(Silverhorn.MS_RETURNMAP, 0)
	-- else
		-- Casual End
		G_SetCustomExitVars(M_MapNumber(Silverhorn.SpMaps["Credits"]), 1)
	-- end

	-- Set stage as clear
	MindscapeSessionFlags = $1 | MS_BEATMINDSCAPE
	-- Exit level (: (3-4-2023 8)
	G_ExitLevel()
	EvActionSH.doforall(function(play)
		play.exiting = 0
	end)
end})


-- Shifts colors to a preset color range
EventSH.new("fx_colorshift_ultimate", {
function(c,e)
	-- Setup
	c.ult_colors = {SKINCOLOR_ULTIMATE1, SKINCOLOR_ULTIMATE2, SKINCOLOR_ULTIMATE3, SKINCOLOR_ULTIMATE4, SKINCOLOR_ULTIMATE5, SKINCOLOR_ULTIMATE4, SKINCOLOR_ULTIMATE3, SKINCOLOR_ULTIMATE2}
	c.shifttimer = 0
	c.shift_index = 1
end,
function(c,e)
	if c.shift_index > #c.ult_colors then c.shift_index = 1 end

	if c.shiftmobj and c.shiftmobj.valid then
		if (c.shifttimer % 3 == 0)  then
			c.shiftmobj.color = c.ult_colors[c.shift_index]
			c.shift_index = $1 + 1
		end
	end

	c.shifttimer = $1 + 1
	EventSH.waitUntil(e, false)
end})


-- Ultimate Laser (Visual) Remake
EventSH.new("fx_ultimate_laser", {
function(c,e)
	c.lasertime = 0
	c.lasermobjs = {}
	c.fireangle = $1
	c.scale = FU
	c.originheight = 32*FU
	c.originradius = 32*FU
	c.ultimatelasercharge = 1*TICRATE
	c.ultimatelaserdivision = 64
	c.ultimatelasercolor = SKINCOLOR_SKY
	c.ultimatelaserrange = RING_DIST*2
	c.ultimatelasernum = c.ultimatelaserrange / c.ultimatelaserdivision / FU
	c.ultimatelasertime = 4*TICRATE
end,
function(c,e)

	-- State and timer
	c.lasertime = $1 + 1
	if c.lasertime < c.ultimatelasercharge then
		if c.lasertime == 2 then
			S_StartSound(nil, sfx_inzlz1)
			S_StartSound(nil, sfx_inlaz1 + (leveltime % 5))

			-- Charge effect
			local charge = P_SpawnMobj(c.firingorigin.x, c.firingorigin.y, c.firingorigin.z, MT_THOK)
			charge.state = S_ULTZUMA_CHARGE
			charge.color = c.ultimatelasercolor
			charge.tics = c.ultimatelasercharge
			charge.blendmode = AST_ADD
		end
	end
	-- else
	if c.lasertime == c.ultimatelasercharge then
		S_StopSoundByID(nil, sfx_inzlz1)
		S_StartSound(nil, sfx_inzlz2)

		-- Explode effect
		local fx = P_SpawnMobj(c.firingorigin.x + P_ReturnThrustX(nil, c.fireangle, 128*FU), c.firingorigin.y + P_ReturnThrustY(nil, c.fireangle, 128*FU), c.firingorigin.z, MT_THOK)
		fx.color = SKINCOLOR_SKY --mobj.color
		fx.blendmode = AST_ADD
		fx.state = S_ULTZUMA_EXPLODE
		P_SetOrigin(fx, c.firingorigin.x, c.firingorigin.y, fx.z)
	end
	-- end
	EventSH.waitUntil(e, c.lasertime > c.ultimatelasercharge)
end,
function(c,e)
	c.lasertime = $1 + 1

	-- Ring effect
	if not (c.lasertime % 4) then
		local factor = (c.lasertime % 8) and 1 or 0
		local hoop = P_SpawnMobj(c.firingorigin.x, c.firingorigin.y, c.firingorigin.z + (c.originheight/3*factor), MT_THOK)

		hoop.angle = c.fireangle + ANGLE_90
		hoop.color = SKINCOLOR_SUPERSILVER1
		hoop.colorized = true
		hoop.state = S_INAZUMA_HOOP
		hoop.scale = c.scale >> 1
		hoop.destscale = c.scale << 1
		hoop.scalespeed = c.scale/10

		hoop.blendmode = AST_ADD
		if factor then
			factor = 2
		else
			factor = 4
			hoop.scale = $1 << 1
			hoop.destscale = $1 << 1
		end
		P_TryMove(hoop, c.firingorigin.x + P_ReturnThrustX(nil, c.fireangle, c.originradius*factor),
		c.firingorigin.y + P_ReturnThrustY(nil, c.fireangle, c.originradius*factor), true)
	end

	-- Create laser
	if not #c.lasermobjs then
		for i = 1, c.ultimatelasernum do
			local mobj = P_SpawnMobj(c.firingorigin.x, c.firingorigin.y, c.firingorigin.z, MT_THOK)
			mobj.state = S_ULTZUMA_LASERSTART
			mobj.color = c.ultimatelasercolor
			mobj.flags = $1 & ~MF_NOBLOCKMAP

			mobj.scalespeed = FixedMul($1, mobj.scale)
			P_SetScale(mobj, mobj.scale/64)
			mobj.destscale = $1/64 + min(i, c.ultimatelasernum/2)*$1

			table.insert(c.lasermobjs, mobj)
		end
	end

	-- Iterate through laser objects
	local maxlaser = nil
	local xmax1 = c.firingorigin.x
	local ymax1 = c.firingorigin.y
	for i, mobj in ipairs(c.lasermobjs) do
		if not (mobj and mobj.valid) then continue end

		-- Move laser into position
		local dist = (c.ultimatelaserdivision*mobj.scale)/2*(i - 1)
		mobj.height = 1

		local x = c.firingorigin.x + P_ReturnThrustX(nil, c.fireangle, dist + c.originradius*4)
		local y = c.firingorigin.y + P_ReturnThrustY(nil, c.fireangle, dist + c.originradius*4)
		local z = c.firingorigin.z + c.originheight/2 + c.originheight/8
		-- local z = c.firingorigin.z + c.originheight/2 + c.originheight/8*P_MobjFlip(c.firingorigin)

		P_SetOrigin(mobj, x, y, z)

		-- Laser squish
		local squish = (i - c.lasertime)*ANG20*2
		mobj.spritexscale = FRACUNIT*3/2 + sin(squish)/8
		mobj.spriteyscale = FRACUNIT + cos(squish)/8

		-- Laser sprite
		if mobj.state == S_ULTZUMA_LASER then
			local state = states[mobj.state]
			local frame = ((i + c.lasertime)/state.var2) % (state.var1 + 1)
			frame = $1+ (state.frame & FF_FRAMEMASK)
			mobj.frame = ($1 &~ FF_FRAMEMASK) + frame
		end

	end
	EventSH.wait(e, c.firingtime or (6*TICRATE))
end,
function(c,e)
	-- Delete laser
	if #c.lasermobjs then
		for i, las in ipairs(c.lasermobjs) do
			if (las and las.valid) then
				las.state = S_ULTZUMA_LASEREND
			end
		end
		c.lasermobjs = {}
	end

end})

-- Collapse Quake
EventSH.new("ev_kemonee_quake", {
function(c,e)
	if leveltime % (c.rate or 5) == 0 then
		P_StartQuake(c.intensity or 12*FU, 3)
	end
	EventSH.waitUntil(e, false)
end,})

-- Final Laser camera move
EventSH.new("panshadow", {
function(c, e)
	EventSH.wait(e, 2*TICRATE)
end,
function(c, e)
	if c.dest and c.cam then
		MobjMoverSH.moveto("move_camera", c.cam, {
			x=c.dest.x,
			y=c.dest.y,
			z=c.dest.z}, {ease="inoutsine", speed=6*FU, noangle=true})
	end
end})

-- Collapse signal trigger (linedef)
-- assigns the player that executed this from a linedef
EventSH.new("ev_fac_trig", {
function(c,e)
	if (c.execlinedef.frontsector.ceilingpic) then
		local signame = "collapse_trigger_" ..  string.lower(c.execlinedef.frontsector.ceilingpic)
		EventSH.signal(signame)
		EventSH.read("any", function(cc, ee)
			if (string.find(ee.signal, signame)) then
				cc["linedef_player"] = c.execplayer
			end
		end)
	else
		print("The sequence cannot progress because the signal number is not valid!")
		return
	end
end})

