-- Test abilities for inazuma's lua....

if not srb2p return end

-- start at 150% damage dealt/taken
local OVERLOAD_START = 150
-- +25% damage dealt/taken for every hit
local OVERLOAD_STEP = 25

local function table_replace(table, elem , replace)
	if not table return end
	for i = 1, #table do
		if table[i] == elem
			table[i] = replace
		end	
	end
end

attackDefs["cross slash"] = {
	name = "Cross Slash",
	type = ATK_SLASH,
	power = 75*2,	-- ~300 power with dual hit
	accuracy = 9999,
	costtype = CST_HPPERCENT,
	cost = 14,
	critical = 2,
	hits = 2,
	desc = "Medium slash damage to \none enemy 2 times.\nNever misses.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]

		if timer == 15
		or timer == 25
			local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
			s.state = S_SLASHING_1_1
			s.color = SKINCOLOR_ORANGE
			s.scale = FRACUNIT*3/2
			
			if timer == 25
				s.rollangle = ANG1*90
			end	
			
			playSound(mo.battlen, sfx_slash)

		elseif timer == 17
		or timer == 27
			local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
			d.sprite = SPR_THMP
			d.frame = C|FF_FULLBRIGHT
			d.scale = FRACUNIT/4
			d.destscale = FRACUNIT*3
			d.scalespeed = FRACUNIT/8
			d.fuse = TICRATE-10
			d.tics = d.fuse
			d.momz = FRACUNIT*2
			d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
			d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
			d.color = SKINCOLOR_ORANGE

		elseif timer == 19
		or timer == 29

			damageObject(target)
			playSound(mo.battlen, sfx_bexpld)
			if not target.plyr
				createSplat(mo)
				createSplat(mo)
			end
			localquake(mo.battlen, FRACUNIT*10, 10)
			for i=1,10
				local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-35, 35)*FRACUNIT
				b.momy = P_RandomRange(-35, 35)*FRACUNIT
				b.momz = P_RandomRange(-35, 35)*FRACUNIT
				b.color = SKINCOLOR_RED
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT/2
				b.destscale = FRACUNIT/12
				b.tics = 35
			end

			local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
			s.sprite = SPR_SLSH
			s.frame = I|FF_FULLBRIGHT
			s.scale = FRACUNIT/2
			s.destscale = FRACUNIT*4
			s.scalespeed = FRACUNIT/3
			s.color = SKINCOLOR_ORANGE
			
			if timer == 29
				s.rollangle = ANG1*90
			end	
			

		elseif timer == 60
			target.slashsprite = nil
			return true
		end
	end,	
}

attackDefs["cross impact"] = {
	name = "Cross Impact",
	type = ATK_SLASH,
	power = 185*2,	-- ~750 power with dual hit
	accuracy = 9999,
	costtype = CST_HPPERCENT,
	cost = 18,
	critical = 2,
	hits = 2,
	desc = "Heavy slash damage to \none enemy 2 times.\nNever misses.",
	target = TGT_ENEMY,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]

		if timer == 15
		or timer == 35
			local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
			s.state = S_SLASHING_1_1
			s.color = SKINCOLOR_RED
			s.scale = FRACUNIT*3/2
			
			if timer == 25
				s.rollangle = ANG1*90
			end	
			
			playSound(mo.battlen, sfx_slash)

		elseif timer == 17
		or timer == 37
			local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
			d.sprite = SPR_THMP
			d.frame = C|FF_FULLBRIGHT
			d.scale = FRACUNIT/2
			d.destscale = FRACUNIT*6
			d.scalespeed = FRACUNIT/8
			d.fuse = TICRATE-10
			d.tics = d.fuse
			d.momz = FRACUNIT*2
			d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
			d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
			d.color = SKINCOLOR_RED

		elseif timer == 19
		or timer == 39

			damageObject(target)
			playSound(mo.battlen, sfx_bexpld)
			if not target.plyr
				createSplat(mo)
				createSplat(mo)
			end
			localquake(mo.battlen, FRACUNIT*10, 10)
			for i=1,10
				local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
				b.momx = P_RandomRange(-35, 35)*FRACUNIT
				b.momy = P_RandomRange(-35, 35)*FRACUNIT
				b.momz = P_RandomRange(-35, 35)*FRACUNIT
				b.color = SKINCOLOR_RED
				b.frame = A|FF_FULLBRIGHT
				b.scale = FRACUNIT
				b.destscale = FRACUNIT/12
				b.tics = 35
			end

			local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
			s.sprite = SPR_SLSH
			s.frame = I|FF_FULLBRIGHT
			s.scale = FRACUNIT
			s.destscale = FRACUNIT*8
			s.scalespeed = FRACUNIT/3
			s.color = SKINCOLOR_RED
			
			if timer == 39
				s.rollangle = ANG1*90
			end	
			

		elseif timer == 70
			target.slashsprite = nil
			return true
		end
	end,	
}

attackDefs["ina_natk"] = {
	name = "Bolt Strike",
	type = ATK_STRIKE,
	target = TGT_ENEMY,
	costtype = CST_SP,
	cost = 0,
	desc = "Inazuma's Basic Attack",
	power = 30,
	physical = true,
	anim_norepel = true,
	anim = 	function(mo, targets, hittargets, timer)
				local target = targets[1]
				local atarget = hittargets[1]
				if timer == 1
					mo.momz = mo.scale*4
					ANIM_set(mo, mo.anim_special3, true)
					mo.reachedtarget = false	-- yeah we can use variables here that you like it or not :^)

					local cx = target.x + 168*cos(target.angle + ANG1*20)
					local cy = target.y + 168*sin(target.angle + ANG1*20)
					CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
					CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
					playSound(mo.battlen, sfx_jump)
					playSound(mo.battlen, sfx_boltbl)
				end


				if not mo.reachedtarget
					P_InstaThrust(mo, mo.angle, FRACUNIT*30)
					if mo.anim ~= mo.anim_special3
						ANIM_set(mo, mo.anim_special3, true)
					end

					if leveltime & 1
						local g = P_SpawnGhostMobj(mo)
						g.tics = 8
						g.colorized = true
						g.color = mo.color
					end

					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

					if R_PointToDist2(mo.x, mo.y, target.x, target.y) <= FRACUNIT*60
					
						damageObject(atarget)
						playSound(mo.battlen, sfx_hit)
						mo.reachedtarget = timer
						
						local t = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						t.state = S_BOLTBLAST
						t.color = skins["inazuma"].prefcolor
						
						P_InstaThrust(mo, mo.angle, -mo.scale*16)
						mo.momz = mo.scale*18
						ANIM_set(mo, mo.anim_special2, true)

						local cx = target.x + 300*cos(target.angle + ANG1*20)
						local cy = target.y + 300*sin(target.angle + ANG1*20)
						local cam = server.P_BattleStatus[mo.battlen].cam
						
						CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 20*FRACUNIT)
						
						for i = 1, 4
							createSplat(mo)
						end
						
						localquake(mo.battlen, FRACUNIT*20, 8)
					end
				else
						
					if timer - mo.reachedtarget > 40
						mo.z = mo.floorz
						return true
					end
				end
			end,

	critanim = 	function(mo, targets, hittargets, timer)
				local target = targets[1]
				local atarget = hittargets[1]
				if timer == 1
					mo.momz = mo.scale*4
					ANIM_set(mo, mo.anim_special3, true)
					mo.reachedtarget = 0	-- yeah we can use variables here that you like it or not :^)

					local cx = target.x + 168*cos(target.angle + ANG1*20)
					local cy = target.y + 168*sin(target.angle + ANG1*20)
					CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
					CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
					playSound(mo.battlen, sfx_jump)
					playSound(mo.battlen, sfx_boltbl)
				end


				if mo.reachedtarget == 0
					P_InstaThrust(mo, mo.angle, FRACUNIT*30)
					if mo.anim ~= mo.anim_special3
						ANIM_set(mo, mo.anim_special3, true)
					end

					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

					if leveltime & 1
						local g = P_SpawnGhostMobj(mo)
						g.tics = 8
						g.colorized = true
						g.color = mo.color
					end

					if R_PointToDist2(mo.x, mo.y, target.x, target.y) <= FRACUNIT*60

						playSound(mo.battlen, sfx_hit)
						mo.reachedtarget_1 = timer
						mo.reachedtarget = 1
						
						local t = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						t.state = S_BOLTBLAST
						t.color = skins["inazuma"].prefcolor
						
						P_InstaThrust(mo, mo.angle, -mo.scale*8)
						mo.momz = mo.scale*14
						ANIM_set(mo, mo.anim_special2, true)

						local cx = target.x + 300*cos(target.angle + ANG1*20)
						local cy = target.y + 300*sin(target.angle + ANG1*20)
						local cam = server.P_BattleStatus[mo.battlen].cam
						
						CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 20*FRACUNIT)
						
						--CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
						
						for i = 1, 4
							createSplat(mo)
						end
						
						localquake(mo.battlen, FRACUNIT*20, 8)
					end
				
				elseif mo.reachedtarget == 1
					if timer - mo.reachedtarget_1 == 20
						ANIM_set(mo, mo.anim_special3, true)
						mo.momx = (target.x - mo.x)/10
						mo.momy = (target.y - mo.y)/10
						mo.momz = (target.z + 20*FRACUNIT - mo.z)/10
						playSound(mo.battlen, sfx_boltbl)
						
					elseif timer - mo.reachedtarget_1 > 20
						if leveltime & 1
							local g = P_SpawnGhostMobj(mo)
							g.tics = 8
							g.colorized = true
							g.color = mo.color
						end
						
						if R_PointToDist2(mo.x, mo.y, target.x, target.y) <= FRACUNIT*60
							
							
							mo.reachedtarget_2 = timer
							mo.reachedtarget = 2

							local t = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
							t.state = S_BOLTBLAST
							t.color = skins["inazuma"].prefcolor
							t = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
							t.state = S_INAZUMA_LIGHTNINGSTRIKE
							t.color = skins["inazuma"].prefcolor
							t.scale = $*2
							
							mo.momz = 18*mo.scale

							for i = 1, 4
								createSplat(mo)
							end
							
							localquake(mo.battlen, FRACUNIT*20, 8)
							
						end
					end
				
				elseif mo.reachedtarget == 2

					local s = P_SpawnMobj(target.x + P_RandomRange(-64, 64)*FRACUNIT, target.y + P_RandomRange(-32, 32)*FRACUNIT, target.z + P_RandomRange(0, 64)*FRACUNIT, MT_THOK)
					s.state = S_AOADUST1
					s.scale = $*3/2
					
					if timer - mo.reachedtarget_2 == 4
					
						if atarget == target
							P_InstaThrust(target, mo.angle, 12*target.scale)
							target.momx = 10*target.scale
						end						
						damageObject(atarget)
					end
					
					if timer - mo.reachedtarget_2 > 50
						mo.z = mo.floorz
						target.z = mo.floorz
						return true
					end
				end
			end,
			
}

attackDefs["ina_overload"] = {
	name = "Overload",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 20,
	desc = "Increase damage dealt and taken by 25%.\nEffect grows by 25% each hit.\nDoesn't consume a turn.",
	target = TGT_CASTER,
	anim =	function(mo, target, hittargets, timer)				
				if timer == 16
					BTL_logMessage(mo.name.." is overcharged!")
					
					mo.ina_overload = OVERLOAD_START

					local t = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					t.state = S_INAZUMA_LIGHTNINGSTRIKE
					t.color = skins["inazuma"].prefcolor
					t.scale = $*2

					playSound(mo.battlen, sfx_buff2)
					for i = 1,16
						local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_CYAN
						dust.scale = FRACUNIT*2
					end
					
					local g = P_SpawnGhostMobj(mo)
					g.destscale = mo.scale*12


				elseif timer > 20 and timer <= 50

					if leveltime%2 == 0
						for i = 1,16

							local thok = P_SpawnMobj(mo.x+P_RandomRange(-70, 70)*FRACUNIT, mo.y+P_RandomRange(-70, 70)*FRACUNIT, mo.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
							thok.state = S_CDUST1
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_CYAN
							thok.tics = P_RandomRange(10, 35)
							thok.scale = FRACUNIT*3/2
						end
					end

					for i = 1, 8
						local thok = P_SpawnMobj(mo.x+P_RandomRange(-70, 70)*FRACUNIT, mo.y+P_RandomRange(-70, 70)*FRACUNIT, mo.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_CYAN
						thok.tics = P_RandomRange(10, 35)
					end
					
				elseif timer == TICRATE*2
					table_replace(mo.saveskills, "ina_overload", "ina_overload.cancel")
					table_replace(mo.skills, "ina_overload", "ina_overload.cancel")
					
					-- cheat the turnorder
					local btl = server.P_BattleStatus[mo.battlen]
					local i = #btl.turnorder +1
					while i > 1
						btl.turnorder[i] = btl.turnorder[i-1]
						i = $-1
					end
					
					btl.turnorder[2] = mo	-- we moved everyone back and gave ourselves an extra turn. :)
					return true
				end	
			end,
			
	implicit = "ina_overload.hitpassive"
}

attackDefs["ina_overload.cancel"] = {
	name = "Overload",
	type = ATK_ELEC,
	target = TGT_ENEMY,
	costtype = CST_SP,
	cost = 12,
	desc = "Cancels Overload and deals damage\nto one enemy based on charge.",
	power = 200,
	anim =	function(mo, target, hittargets, timer)
				local target = target[1]
				if timer == 10
					
					mo.ina_overload = $ or 150	-- ???
					ANIM_set(mo, mo.anim_special4, true)
					localquake(mo.battlen, FRACUNIT*30, TICRATE*10)
				
				elseif timer == 40
					
					ANIM_set(mo, mo.anim_special5, true)
					for k,v in ipairs(mo.allies)
						if v and v.control and v.control.valid
							P_FlashPal(v.control, 1, 5)
						end
					end					
					
					mo.helper = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					mo.helper.tics = -1
					mo.helper.flags2 = $|MF2_DONTDRAW
					
					local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					P_InstaThrust(mo.helper, ang, mo.scale*10)
				end
				
				if timer >= 40
					if mo.helper and mo.helper.valid and R_PointToDist2(mo.helper.x, mo.helper.y, target.x, target.y) > 40*mo.scale
						
						if leveltime & 1
							local t = P_SpawnMobj(mo.helper.x+P_RandomRange(-70, 70)*FRACUNIT, mo.helper.y+P_RandomRange(-70, 70)*FRACUNIT, mo.helper.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
							t.state = S_INAZUMA_LIGHTNINGSTRIKE
							t.color = skins["inazuma"].prefcolor
							t.scale = $*2
						end
						
						if leveltime%5 == 0
							playSound(mo.battlen, sfx_zio2)
						end	
				
					elseif mo.helper and mo.helper.valid
						
						local t = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						t.state = S_INAZUMA_LIGHTNINGSTRIKE
						t.color = skins["inazuma"].prefcolor
						t.scale = $*5	

						for k,v in ipairs(mo.allies)
							if v and v.control and v.control.valid
								P_FlashPal(v.control, 1, 5)
							end
						end					
													
						lightningblast(target, SKINCOLOR_GOLD, FRACUNIT*3/2)
						localquake(mo.battlen, FRACUNIT*50, 20)
						
						mo.ina_overload = $*2
						damageObject(target)
						
						mo.ina_overload = nil
						
						mo.ina_tmrend = timer

						P_RemoveMobj(mo.helper)
						mo.helper = nil
						
						playSound(mo.battlen, sfx_bkpoof)
						
					elseif timer == mo.ina_tmrend + TICRATE*2
						table_replace(mo.saveskills, "ina_overload.cancel", "ina_overload")
						table_replace(mo.skills, "ina_overload.cancel", "ina_overload")
						mo.colorized = false
						mo.ina_tmrend = nil
						
						return true
					end
				end	
			end,
			
	implicit = "ina_overload.hitpassive"
}


attackDefs["ina_overload.hitpassive"] = {
	name = "Overload - Hit Passive",
	type = ATK_PASSIVE,
	desc = "",
	passive = PSV_TRIGGERDAMAGE,
	anim = 	function(mo, target, dmg, crit)
				if not mo.ina_overload return dmg end
				
				dmg = $*mo.ina_overload/100			
				mo.ina_overload = $ + OVERLOAD_STEP
				return dmg
			end,
			
	implicit = "ina_overload.dmgpassive",
}

attackDefs["ina_overload.dmgpassive"] = {
	name = "Overload - Dmg Passive",
	type = ATK_PASSIVE,
	desc = "",
	passive = PSV_TRIGGERDAMAGE_RECEIVED,
	anim = 	function(mo, target, dmg, crit)
				if not mo.ina_overload return dmg end
				dmg = $*mo.ina_overload/100			
				return dmg
			end,
			
	implicit = "ina_overload.reset",
}

attackDefs["ina_overload.reset"] = {
	name = "Overload - Reset",
	type = ATK_PASSIVE,
	desc = "",
	passive = PSV_ENDBATTLE,
	anim =	function(mo)
				table_replace(mo.saveskills, "ina_overload.cancel", "ina_overload")
				table_replace(mo.skills, "ina_overload.cancel", "ina_overload")
				mo.ina_overload = nil
				mo.colorized = false
			end,
}

-- overload active thinker
addHook("MobjThinker", function(mo)
	if mo and mo.valid and mo.ina_overload
		mo.colorized = leveltime%4 < 2
		
		-- if players die...
		if mo.hp <= 0
			table_replace(mo.saveskills, "ina_overload.cancel", "ina_overload")
			table_replace(mo.skills, "ina_overload.cancel", "ina_overload")		
			mo.ina_overload = nil
			mo.colorized = false
		end	
	end
	
end, MT_PFIGHTER)

freeslot("SPR_IZNG", "SPR_INSH")

personaList["ina_izanagi"] = {
		-- GENERAL
		name = "Izanagi",
		arcana = ARCANA_FOOL,

		-- STATS (at level 10. so we can have some precision, y'see)

		sprite = SPR_PSN0,
		anim_idle = 	{SPR_IZNG, A, B, 12},
		anim_atk = 		{SPR_IZNG, C, D, E, F, G, H, I, J, K, L, L, L, L, 2},
		startframe = 0,

		strength = 12,
		magic = 8,
		endurance = 8,
		luck = 4,
		agility = 7,
		weak = ATK_ICE|ATK_PSY,
		resist = ATK_NUCLEAR|ATK_SLASH,
		block = ATK_ELEC,
		skills = {
				
					{"zio", 1},	{"cleave", 4}, {"frei", 8}, {"tarukaja", 14},
					{"giant slice", 22, "cleave"}, {"zionga", 26, "zio"}, {"freila", 29, "frei"},
					
					{"regenerate 1", 32}, {"gale slash", 35}, {"ina_overload", 40},  {"matarukaja", 44, "tarukaja"}, 
					{"blade of fury", 48, "gale slash"}, {"cross slash", 51, "giant slice"},
					{"regenerate 2", 53, "regenerate 1"}, {"endure", 55}, {"ziodyne", 59, "zionga"}, {"freidyne", 63, "freila"},
					{"cross impact", 68, "cross slash"}, {"regenerate 3", 72, "regenerate 2"}, {"deathbound", 75, "blade of fury"}
				},
}

charStats["inazuma"] = {

		-- GENERAL

		name = "Inazuma",			-- This is only for bots / enemies
		basehp = 75,			-- base HP for level 1
		basesp = 30,
		persona = "ina_izanagi",
		melee_natk = "ina_natk",	-- normal melee attack

		supercolor_start = SKINCOLOR_FULLPOWERSUPER1,

		atk = 30,
		acc = 85,
		crit = 3,

		wep = "limiter_01",
		weptype = WPT_LIMITERS,

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_PLAY, A, B, C, D, E, 8, "SPR2_STND"},		-- standing
		anim_stand_hurt =	{SPR_PLAY, A, B, C, D, E, 16, "SPR2_STND"},		-- standing (low HP)
		anim_stand_bored =	{SPR_PLAY, A, B, C, D, E, 8, "SPR2_STND"},
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},		-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, E, F, G, H, I, J, 2, "SPR2_WALK"},		-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},	-- attacking
		anim_aoa_end =		{SPR_PLAY, D, C, B, A, 1, "SPR2_ROLL"},	-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},		-- taking damage
		anim_getdown =		{SPR_PLAY, A, 1, "SPR2_PAIN"},		-- knocked down from weakness / crit
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_OOF_"},		-- is down
		anim_getup =		{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},		-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_PAIN"},		-- dies
		anim_revive =		{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},		-- gets revived
		anim_evoker =		{SPR_INSH, A, 1},
		anim_evoker_shoot =	{SPR_INSH, B, A, 4},
		
		anim_special1 =		{SPR_PLAY, A, B, 2, "SPR2_DASH"},
		anim_special2 =		{SPR_PLAY, A, B, 4, "SPR2_FALL"},
		anim_special3 =		{SPR_PLAY, A, B, C, D, 1, "SPR2_TWIN"},
		
		-- overload
		anim_special4 =		{SPR_PLAY, C, 1, "SPR2_TRNS"},
		anim_special5 =		{SPR_PLAY, F, G, 1, "SPR2_TRNS"},

		vfx_summon = {"sfx_insum1", "sfx_insum2", "sfx_insum3", "sfx_insum4", "sfx_insum5"},
        vfx_skill = {"sfx_insk1", "sfx_insk2", "sfx_insk3", "sfx_insk4", "sfx_insk5", "sfx_insk6"},
        vfx_item = {"sfx_init1", "sfx_init2", "sfx_init3", "sfx_init4"},
        vfx_hurt = {"sfx_inht1", "sfx_inht2", "sfx_inht3", "sfx_inht4", "sfx_inht5", "sfx_inht6", "sfx_inht7", "sfx_inht8", "sfx_inht9", "sfx_inht10", "sfx_inht11"},
        vfx_hurtx = {"sfx_inxt1", "sfx_inxt2", "sfx_inxt3", "sfx_inxt4", "sfx_inxt5", "sfx_inxt6", "sfx_inxt7", "sfx_inxt8"},
        vfx_die = {"sfx_indi1", "sfx_indi2", "sfx_indi3", "sfx_indi4", "sfx_indi5", "sfx_indi6", "sfx_indi7"},
        vfx_heal = {"sfx_inhs1", "sfx_insh2", "sfx_insh3", "sfx_inhe1", "sfx_inhe2"},
        vfx_healself = {"sfx_inhe1", "sfx_inhe2"},
        vfx_kill = {"sfx_inkl1", "sfx_inkl2", "sfx_inkl3", "sfx_inkl4", "sfx_inkl5", "sfx_inkl6", "sfx_inkl7", "sfx_inkl8"},
        vfx_1more = {"sfx_in1m1", "sfx_in1m2", "sfx_in1m3", "sfx_in1m4"},
        vfx_crit = {"sfx_incu1", "sfx_incu2", "sfx_incu3", "sfx_incu4"},
        vfx_aoaask = {"sfx_inao1", "sfx_inao2"},
        vfx_aoado = {"sfx_inao3"},
        vfx_aoarelent = {"sfx_inao4"},
        vfx_miss = {"sfx_inmi1", "sfx_inmi2", "sfx_inmi3", "sfx_inmi4"},
        vfx_dodge = {"sfx_indo1", "sfx_indo2", "sfx_indo3"},
        vfx_win = {"sfx_inwi1", "sfx_inwi2", "sfx_inwi3", "sfx_inwi4"},
        vfx_levelup = {"sfx_inlv1"},
		
		
		icon = "ICO_INA",		-- icon for net select and other menus
		hudbust = "INA_H",			-- patch to draw on the stat hud
		hudbustlayer = "",		-- transparent patch to draw for status conditions
		hudaoa = "H_INAAOA",	-- patch for all out attack hud
		hudcutin = "INA_A",	-- cut in
		aoa_quote = "Unlimited Power!",

		tip = "Uses Slash Skills as well Electric and Nuclear for coverage. His unique Overload Skill increases his damage in exchange for also taking more damage, so he will require support from the team to make the most out of it.",

}

VFX_freeslotC("inazuma")