/*
InazumaChars dance tables
	by Lach

beta
*/

local spr2numframes = {}
local function GetSprite2NumFrames(skin, spr2)
	local frame
	
	if not spr2numframes[skin]
		spr2numframes[skin] = {}
	else
		frame = spr2numframes[skin][spr2]
	end
	
	if frame ~= nil
		return frame
	end
	
	local statenum = S_UNKNOWN
	local state = states[statenum]
	local statedef = {
		state.sprite,
		state.frame,
		state.tics,
		state.action,
		state.var1,
		state.var2,
		state.nextstate
	}
	local thok = P_SpawnMobj(0, 0, 0, MT_THOK)
	state.sprite = SPR_PLAY
	state.frame = spr2
	state.action = nil
	thok.skin = skin
	thok.state = statenum
	frame = -1
	while thok.frame & FF_FRAMEMASK > frame
		frame = thok.frame & FF_FRAMEMASK
		thok.state = statenum
	end
	frame = $ + 1
	spr2numframes[skin][spr2] = frame
	states[statenum] = statedef
	P_RemoveMobj(thok)
	return frame
end

if not CC_DanceSkins
	rawset(_G, "CC_DanceSkins", {})
end

// Inazuma

local thrustleft = function(player)
	local mo = player.mo
	local angle = (player.cmd.angleturn << 16) + ANGLE_90
	P_Thrust(mo, angle, 3*mo.scale)
end

local thrustright = function(player)
	local mo = player.mo
	local angle = (player.cmd.angleturn << 16) - ANGLE_90
	P_Thrust(mo, angle, 3*mo.scale)
end

local kickright = function(player)
	local mo = player.mo
	local angle = (player.cmd.angleturn << 16) - ANGLE_90
	P_Thrust(mo, angle, 4*mo.scale)
end

local stop = function(player)
	local mo = player.mo
	mo.momx = player.cmomx
	mo.momy = player.cmomy
end

local leftdown = {
	{
		start = thrustleft,
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = B,
		tics = 2
	},
	{
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = C,
		tics = 5
	},
	{
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = D,
		tics = 4
	},
	{
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = A,
		tics = 5
	}
}

local rightdown = {
	{
		start = thrustright,
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = F,
		tics = 2
	},
	{
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = G,
		tics = 5
	},
	{
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = H,
		tics = 4
	},
	{
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = E,
		tics = 5
	}
}

local leftupstart = {
	{
		start = thrustleft,
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = I,
		tics = 2
	},
	{
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = K,
		tics = 2
	},
	{
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = L,
		tics = 5
	},
	{
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = M,
		tics = 4
	},
	{
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = N,
		tics = 3
	}
}

local leftup = {
	{
		start = thrustleft,
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = J,
		tics = 2
	},
	{
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = K,
		tics = 2
	},
	{
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = L,
		tics = 5
	},
	{
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = M,
		tics = 4
	},
	{
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = N,
		tics = 3
	}
}

local rightup = {
	{
		start = thrustright,
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = O,
		tics = 2
	},
	{
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = P,
		tics = 2
	},
	{
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = Q,
		tics = 5
	},
	{
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = R,
		tics = 4
	},
	{
		angle = ANGLE_180,
		sprite2 = SPR2_DNCE,
		frame = S,
		tics = 3
	}
}

local kickstart = {
	{
		start = kickright,
		angle = ANGLE_135,
		sprite2 = SPR2_DNCE,
		frame = T,
		tics = 2
	},
	{
		angle = ANGLE_90,
		sprite2 = SPR2_DNCE,
		frame = U,
		tics = 4
	},
	{
		angle = ANGLE_90,
		sprite2 = SPR2_DNCE,
		frame = V,
		tics = 5
	},
	{
		angle = ANGLE_90,
		sprite2 = SPR2_DNCE,
		frame = W,
		tics = 5
	}
}

local kick = {
	{
		start = kickright,
		angle = ANGLE_135,
		sprite2 = SPR2_DNCE,
		frame = V,
		tics = 2
	},
	{
		angle = ANGLE_90,
		sprite2 = SPR2_DNCE,
		frame = U,
		tics = 4
	},
	{
		angle = ANGLE_90,
		sprite2 = SPR2_DNCE,
		frame = V,
		tics = 5
	},
	{
		angle = ANGLE_90,
		sprite2 = SPR2_DNCE,
		frame = W,
		tics = 5
	}
}

local kickending = {
	{
		start = kickright,
		angle = ANGLE_135,
		sprite2 = SPR2_DNCE,
		frame = V,
		tics = 2
	},
	{
		angle = ANGLE_90,
		sprite2 = SPR2_DNCE,
		frame = U,
		tics = 4
	},
	{
		angle = ANGLE_90,
		sprite2 = SPR2_DNCE,
		frame = V,
		tics = 5
	},
	{
		angle = ANGLE_90,
		sprite2 = SPR2_DNCE,
		frame = W,
		tics = 5
	},
	{
		angle = ANGLE_90,
		sprite2 = SPR2_DNCE,
		frame = X,
		tics = 6
	},
	{
		angle = ANGLE_90,
		sprite2 = SPR2_DNCE,
		frame = Y,
		tics = 6
	},
	{
		angle = ANGLE_90,
		sprite2 = SPR2_DNCE,
		frame = Z,
		tics = 7
	},
	{
		angle = ANGLE_90,
		sprite2 = SPR2_DNCE,
		frame = Z + 1,
		tics = 7
	},
	{
		angle = ANGLE_90,
		sprite2 = SPR2_DNCE,
		frame = Z + 2,
		tics = 11
	},
	{
		angle = ANGLE_90,
		sprite2 = SPR2_DNCE,
		frame = Z + 1,
		tics = 3
	},
	{
		angle = ANGLE_90,
		sprite2 = SPR2_DNCE,
		frame = Y,
		tics = 3
	},
	{
		angle = ANGLE_135,
		sprite2 = SPR2_DNCE,
		frame = T,
		tics = 5
	}
}

local anims = {
	leftdown,
	rightdown,
	leftdown,
	leftdown,
	rightdown,
	leftdown,
	rightdown,
	rightdown,
	leftupstart,
	rightup,
	leftup,
	leftup,
	rightup,
	leftup,
	rightup,
	rightup,
	kickstart,
	kick,
	kick,
	kick,
	kickending,
	leftdown,
	rightdown,
	leftdown,
	leftdown,
	rightdown,
	leftdown,
	rightdown,
	rightdown
}

local keys = {}

for i, anim in ipairs(anims)
	for j, key in ipairs(anim)
		table.insert(keys, key)
	end
end

CC_DanceSkins["inazuma"] = {
	["dancebutton_var"] = "silverhorn_dancebutton",
	[1] = {
		condition = function(player) return (player.mo.state ~= S_CHRISPY_DANCE or player.cc_dance.num == 0) end,
		music = "GANGNM",
		keys = {
			{
				sprite2 = SPR2_STND,
				frame = A,
				tics = 64,
				start = function(player)
					player.cc_dance.queuechange = true
				end,
				think = function(player)
					local standframes = GetSprite2NumFrames("inazuma", SPR2_STND)
					local dance = player.cc_dance
					player.mo.frame = ($ & ~FF_FRAMEMASK) | (standframes - (dance.tics / states[S_PLAY_STND].var2 % standframes) - 1)
					player.skidtime = max($, 1)
					player.drawangle = $ + ((player.cmd.angleturn << 16) + ANGLE_180 - $) / 4
				end
			}
		}
	},
	[2] = {
		condition = function(player) return (player.mo.state == S_CHRISPY_DANCE and player.cc_dance.tics == 0) end,
		music = "GANGNM",
		keys = keys,
		alwaysreset = true
	}
}

// Aether

CC_DanceSkins["aether"] = {
	["dancebutton_var"] = "silverhorn_dancebutton",
	[1] = {
		music = "AETHERDANCE",
		keys = {
			{
				sprite2 = SPR2_DNCE,
				frame = A,
				tics = 4
			},
			{
				sprite2 = SPR2_DNCE,
				frame = B,
				tics = 4,
				start = function(player) -- left thrust
					local mo = player.mo
					P_Thrust(mo, (player.cmd.angleturn << 16) - ANGLE_90, -2*mo.scale)
				end
			},
			{
				sprite2 = SPR2_DNCE,
				frame = C,
				tics = 4
			},
			{
				sprite2 = SPR2_DNCE,
				frame = D,
				tics = 4
			},
			{
				sprite2 = SPR2_DNCE,
				frame = E,
				tics = 4,
				start = function(player) -- right thrust
					local mo = player.mo
					P_Thrust(mo, (player.cmd.angleturn << 16) - ANGLE_90, 2*mo.scale)
				end
			},
			{
				sprite2 = SPR2_DNCE,
				frame = F,
				tics = 4
			},
		}
	}
}