/*
XSpeedGodX
	by Lach
*/

local CAPTION = "Ominous organ"
local JINGLE_TIME = 5*TICRATE

if XSpeedGodX
	return
end
rawset(_G, "XSpeedGodX", true)

// To prevent duplicate freeslots
local function CheckSlot(item) // this function deliberately errors when a freeslot does not exist
	if _G[item] == nil // this will error by itself for states and objects
		error() // this forces an error for sprites, which do actually return nil for some reason
	end
end

local function SafeFreeslot(...)
	local item = ...
	if item == nil
		return
	end
	
	if pcall(CheckSlot, item)
		print("\131NOTICE:\128 " .. item .. " was not allocated, as it already exists.")
	else
		freeslot(item)
	end
	
	SafeFreeslot(select(2, ...))
end

local function Fade(mo)
	mo.extravalue1 = $ + 1
	if mo.extravalue1 > 9
		P_RemoveMobj(mo)
	else
		mo.frame = $ & ~FF_TRANSMASK | (mo.extravalue1 << FF_TRANSSHIFT)
	end
end

SafeFreeslot("SPR_XSGX", "S_XSPEEDGODX", "S_XSPEEDGODX_FADE", "MT_XSPEEDGODX")

states[S_XSPEEDGODX] = {
	sprite = SPR_XSGX,
	frame = FF_FULLBRIGHT,
	tics = -1
}

states[S_XSPEEDGODX_FADE] = {
	sprite = SPR_XSGX,
	frame = FF_FULLBRIGHT,
	tics = 8,
	nextstate = S_XSPEEDGODX_FADE,
	action = Fade
}

mobjinfo[MT_XSPEEDGODX] = {
	//$Name XSpeedGodX
	//$Sprite XSGXA1
	doomednum = 69,
	spawnhealth = 1000,
	spawnstate = S_XSPEEDGODX,
	deathstate = S_XSPEEDGODX_FADE,
	radius = 16*FRACUNIT,
	height = 48*FRACUNIT,
	flags = MF_SPECIAL|MF_SCENERY|MF_NOGRAVITY
}

addHook("MobjSpawn", function(mo)
	mo.shadowscale = FRACUNIT
end, MT_XSPEEDGODX)

addHook("MobjDeath", function(mo, _, src)
	local player = src and src.player
	
	if not player
		return
	end
	
	P_PlayJingleMusic(player, "XSGX", 0, false, JT_OTHER)
	player.powers[pw_extralife] = JINGLE_TIME
	S_StartMusicCaption(CAPTION, JINGLE_TIME, player)
end, MT_XSPEEDGODX)

addHook("ShouldJingleContinue", function() return false end, "XSGX")